CHANGES
=======

12.0.3
------

* [Fullstack] Change time waiting for async ping results
* Don't skip DVR port while neutron-openvswitch-agent is restared
* Disable IPv6 forwarding by default on HA routers
* Fix lack of routes for neighbour IPv4 subnets
* Change ovs release used to compile kernel module for tests node
* tests: port test\_port\_presence\_prevents\_network\_rbac\_policy\_deletion
* Fix wrong release names in docs
* Use Param DHCP\_OPT\_CLIENT\_ID\_NUM
* Fix delete vlan allocation error for ML2
* Avoid agents adding ports as trunk by default
* Monitor phys\_bridges to reconfigured it if created again
* Only allow SG port ranges for whitelisted protocols
* [L3][QoS] Cover mixed dvr\_snat and compute node dvr router
* Stop using legacy nodesets
* Retry dhcp\_release on failures

12.0.2
------

* ovs-fw: Apply openflow rules immediately during update
* [RBAC] Fix setting network as not shared
* Override ovsdb\_timeout default value in ovs\_cleanup tool
* Handle AgentNotFoundByTypeHost exception properly
* Fix pep8 errors
* DVR: Restarting l3 agent loses centralized fip ip on qg-interface
* Refresh router objects after port binding
* Use cidr during tenant network rule deletion
* DVR: Check for item\_allocator key before releasing
* DVR: Add error handling for get\_network\_info\_for\_id rpc call
* Fix l3-agent crash on routers without ha\_state

12.0.1
------

* ovs-fw: Fix firewall blink
* Add in missing QUEENS tag
* Set trusted port only once in iptables firewall driver
* Spawn/stop metadata proxies upon adding/deleting router interfaces
* Remove race and simplify conntrack state management
* Process conntrack updates in worker threads
* Iptables firewall driver adds forward rules for trusted ports
* Try to enable L3 agent extension \`fip\_qos\`
* DVR: Fix allowed\_address\_pair IP, ARP table update by neutron agent
* ovs-fw: Clear conntrack information before egress pipeline
* Pull in ubuntu cloud archive openvswitch pkg
* [Scenario tests] Try longer SSH timeout for ubuntu image
* DVR: Inter Tenant Traffic between networks not possible with shared net
* DVR: Fix mac format for backward compatibility with vsctl api
* Imported Translations from Zanata
* Config privsep in the linuxbridge agent
* ovsfw: Use bundle when adding security group rules
* ovs-fw: Don't modify passed rules to update
* Fix creation of port when network has admin's QoS policy set
* DVR: verify subnet has gateway\_ip before installing IPv4 flow
* [Fullstack] Respawn dhclient process in case of error
* Update documentation for DNS integration
* Always pass device\_owner to \_ipam\_get\_subnets()
* Fixing the filter in get MTU by network list query
* DVR: Fix dvr\_no\_external agent restart with fips
* Fix error message when duplicate QoS rule is created

12.0.0
------

* Compile ovs for ovsfw to avoid ovs-vswitchd core dumps
* Tag the alembic migration revisions for Queens
* ovsfw: Update SG rules even if OVSFW Port is not found
* Update UPPER\_CONSTRAINTS\_FILE for stable/queens
* Update .gitreview for stable/queens

12.0.0.0rc1
-----------

* Fixes using SSL OVSDB connection
* Allow objects to opt in new engine facade
* [Fullstack] Mark security group test as unstable
* Mock ipv6\_utils.is\_enabled\_and\_bind\_by\_default method
* Add notification for floatingip update/delete
* Revert "[Fullstack] Mark test\_bw\_limit\_qos\_port\_removed as unstable"
* fix same mechanism driver called twice bug
* Updated from global requirements
* Zuul: Remove project name
* Move Linuxbridge ARP spoofing to nat table PREROUTING chain
* This patch changes the CT zone allocation range
* Revert "Integration of (Distributed) Port Binding OVO"
* Fix eventlet imports issue
* Minor fix to remove legacy OVSDB IDL connection

12.0.0.0b3
----------

* Fix race condition with enabling SG on many ports at once
* [Fullstack] SG test use not too many fake hosts
* More efficiently clean up OVS ports
* Fix Port OVO filtering based on security groups
* Add log-tag to haproxy config file
* Modify link address from http to https
* Log warnings when test fails because of them
* [Fullstack] Clean DSCP mark rule when port removed
* log-api: Don't enable logging for linuxbridge
* Add retry decorator update\_segment\_host\_mapping()
* Fixes minor typo in neutron
* Remove deprecated nova\_metadata\_ip
* Adding DSCP mark and inheritance in OVS and LB tunnels outer header
* Update the gerrit dashboard
* [Doc][L3][QoS] Enable floating IP qos
* Fix \_port\_arg for security rules with icmp/ipv6-icmp aliases
* l3\_ha: only pass host into update\_port when updating router port bindings
* remove neutron.callbacks package
* Updated from global requirements
* Use Router OVO in metering\_db
* Configure log extension for ovs scenario job only
* Fix ingress bw limit for OVS DPDK ports
* Switch to use directly ovsdbapp.api module
* [OVS] Fix for cleaning after skipped\_devices
* Support filtering port with IP address substring
* ovs-lib: Pass string as udp port to ovsdb
* Fix mocking of ovsdb connection in UT
* Treat device with no MAC address as not ready
* Remove usage of deprecated idlutils module
* Remove deprecated method OVSBridge.set\_protocols()
* [log] [doc] Include logging for security groups
* Speed up trunk MTU enforcement check
* Removed neutron-tempest-full
* Fix fwaas v2 configuration doc
* Add missing iptable rule in snat ns for centralized fips
* Revert "Use writer for trunk database operations"
* Switch rally job from q-\* to neutron-\* service names
* broken HybridIptablesHelper function override
* [Fullstack] Mark test\_bw\_limit\_qos\_port\_removed as unstable
* [log]: functional test for logging api
* [log] ovs fw logging implementation
* Use constant 'IS\_DEFAULT' from neutron-lib
* [Fullstack] Change how DSCP marking packets are tested
* L3: prevent associating a FIP to a DHCP port
* Cleaned up get\_session
* Log radvd config contents on reload when debug is on
* ovsfw: Don't create rules if updated port doesn't exist
* Use same instance of iptables\_manager in L2 agent and extensions
* [OVS] Shut down the port on changing the admin-state to false
* Switch to Subnet OVO in ipam\_backend\_mixin \_save\_subnet method
* [doc] Added update regarding URL difference based on deployment
* [trivial fix]fix typos in neutron
* Moving legacy check and gate jobs
* test\_provisioning\_blocks: Network model to OVO
* [Fullstack] Shutdown tcpdump process gracefully
* Updated from global requirements
* Integration of (Distributed) Port Binding OVO
* use callback payloads for BEFORE\_READ events
* use callback payloads for REQUEST/RESPONSE events
* use callback payloads for \_SPAWN events
* ipam: don't commit IPAllocation while IpamAllocation is rolled back
* Update gerrit dashboards
* Fix NeutronPrimaryKeyMissing instantiation
* Improve Qos Policy Rule test
* ovsfw: Create tables for further consumption
* Introduce rfe-confirmed and rfe-triaged tags
* [L3][QoS] L3 agent side Floating IP rate limit
* Fix 1 doc typo
* [log]: Devstack plugin for logging api
* [log]: Change entry point name of logging plugin
* Updated from global requirements
* Switch to use \_get\_subnet\_object() in ipam\_backend\_mixin module
* Ensure floating IP create does not break
* FIP: update\_floatingip\_status() to return the updated object
* use l3 api def from neutron-lib
* l3\_agentschedulers\_db: convert from Agent model to OVO
* Allow \_\_new\_\_  method to accept extra arguments
* Update some l3-agent log messages
* Remove \_get\_subnets\_by\_cidr from neutron/db/extraroute\_db.py
* Fix URL in SR-IOV internals doc
* Update the documentation links
* [Fullstack] Additional log of tcpdump stderr output
* Honor both floating\_ip\_address and subnet\_id when creating FIP
* [Qos] ingress bandwidth limit by ovs is not accurate
* Use hexadecimal when adding DSCP rules
* Switch to use \_get\_subnet\_object in neutrondb\_ipam driver
* Tags: harden validations
* test\_dhcp\_rpc\_agent\_api: convert from Agent model to OVO
* bugs.rst: Add rfe-postponed to the list of tags
* Allow port create/update by shared nw owners
* Update network external attribute for RBAC change
* Switch to use subnet OVO object in get\_subnet
* test\_metering\_plugin: convert from Agent model to OVO
* Updated from global requirements
* Fix error when using protocol number in security groups
* doc: Clarify RFE Triaged state a bit
* Prevent LBaaS VRRP ports from populating DVR router ARP table

12.0.0.0b2
----------

* test\_timestamp: switch to Network OVO
* test\_l3\_dvr\_db: switch to OVO for Agent
* test\_dhcp\_agent\_scheduler: Network model to OVO
* test\_l3\_agent\_scheduler: convert from RouterL3AgentBinding model to OVO
* test\_l3\_agent\_scheduler: convert from Agent model to OVO
* Move segment deletion back to PRECOMMIT\_DELETE
* [Qos] Fix residues of ovs in ingress bw limit
* Add CREATE\_PRECOMMIT notification for Floating IPs
* burst should be set near max-rate
* Build metadata\_agent.ini reproducibly
* Remove router\_ids argument to auto\_schedule\_routers()
* FakeNotifier class 'topic' argument change to 'topics'
* [Fullstack] Log tcpdump output lines in DSCP mark tests
* Integration of Floating IP OVO
* ovs-fw: catches exception from ovsdb
* Fix meter-label-rule creation
* Fix missing backslashes in QoS docs
* [Fullstack] Fix destroy of VM fixture
* Revert "Revert "objects: get, update and delete converted to Subnet OVO usage""
* Fix HA router initialization exception
* use log api plugin const from neutron-lib
* Correctly configure the IPv6 LLA address
* Fix DNS connectivity issues with DVR+HA routers and DHCP-HA
* [log]: Add driver api and rpc stuff for logging
* [L3][QoS] Neutron server side Floating IP QoS
* [QoS] Add info about rate limiting on router's ports
* docs: Correct various mistakes in QoS doc
* fullstack: disable all test\_connectivity test cases
* Disable test\_dscp\_marking\_packets fullstack test case
* clarify nova prereq for controller install docs
* Call update\_all\_ha\_network\_port\_statuses on agent start
* fullstack: Wait at least 3 minute for agents to report
* Router to OVO
* Remove the ensure\_dir
* Remove the bundled intree neutron tempest plugin
* Remove unused variables ‘LOG'
* [OVO] Switch to use own registry
* Add dns-integration setup to devstack plugin
* use agent api def from neutron-lib
* Added zuulv3 jobs for testing neutron tempest plugin
* Remove neutron tempest plugin jobs from neutron project
* Skip tempest plugin tests on releasenotes changes
* use flavors api def from neutron-lib
* Remove Rodolfo Alonso as QoS bug contact
* use l3 ext gw mode api def from neutron-lib
* Remove setting of version/release from releasenotes
* Updated from global requirements
* use dns domain ports api def from neutron-lib
* Updated from global requirements
* ovsfw: Use multiple priorities in RULES\_\*\_TABLE
* ovsfw: Merge multiple conjunction flows
* Add unit test to validate non DB base core plugin can be loaded
* use logging api def from neutron-lib
* Raise exception when synthetic field invalid
* [L3][QoS] Adding L3 rate limit TC lib
* Support that an extension extends a sub-resource
* use net mtu api writable def from neutron-lib
* use net mtu api def from neutron-lib
* use PROVISIONAL\_IPV6\_PD\_PREFIX from neutron-lib
* Donot run neutron-tempest-plugin-api job in gate pipeline
* Tempest: Add availability-zone for agent
* use network az api def from neutron-lib
* use addr pairs api def from lib
* use l3 flavors api def from neutron-lib
* use dvr api def from neutron-lib
* use qos api def from neutron-lib
* use router az api def from neutron-lib
* Added zuulv3 jobs for testing neutron tempest plugin
* Revert "objects: get, update and delete converted to Subnet OVO usage"
* Renamed ovs\_vsctl\_timeout into ovsdb\_timeout
* Support protocol numbers in security group API
* Remove DocImpact info from contributor docs
* use ml2 driver api from neutron-lib
* Remove deprecated cache\_url
* use l3 ext ha mode api def from neutron-lib
* Skip IPv6 sysctl calls when IPv6 is disabled
* Do not load default service plugins if core plugin is not DB based
* use ip allocation api def from neutron-lib
* tests: delete in-use security group
* Change iptables-restore lock interval to 5 per second
* Fix typo "extention" -> "extension"
* Fix typo: allow\_address\_pair -> allowed\_address\_pair
* use project id api def from neutron-lib
* Remove neutron.common.ipv6\_utils.is\_enabled()
* use core resource api defs from lib
* Enable bridge command for openvswitch agent
* Move check\_ha\_state\_for\_router() into notification code
* test\_security\_groups: Randomize SG names
* use pagination api def from neutron-lib
* use net ip availability api def from neutron-lib
* Update section with links to backport/RC potential bugs
* Use Agent OVO in l3\_agentschedulers\_db
* RPC callbacks: add hook to register additional resources
* Update link to stable branch policy page
* objects: get, update and delete converted to Subnet OVO usage
* use metering api def from neutron-lib
* use l2 adjacency api def from neutron-lib
* Fullstack: init trunk agent's driver only when necessary
* Use Agent OVO in agents\_db and test\_agents\_db
* Add initialization in StringMatchingFilterObj class
* Add some missing mocks in l3-agent tests
* use extra route api def from lib
* use FAULT\_MAP from neutron-lib
* Updated from global requirements
* [rally] Port input task to the new format
* [Tempest] Testing remote\_ip\_prefix for security groups
* Add RBAC access\_as\_external unit tests
* Replace http with https for doc links
* Adding OVS Offload documentation
* Integration of L3HARouterAgentPortBinding in ml2/drivers/l2pop/db.py
* Reorder checks in apply\_filters in db/\_model\_query
* Fix callers of get\_devices\_with\_ip() to pass addresses
* tests: Add decorator to mark unstable tests
* docs: Update supported QoS rule types
* use external net api def from lib
* Fix the wrong usage of new style class in metering
* Modify the wrong command in config qos doc
* Correct link in config-ml2.rst
* Change QoS configuration manual
* revert base extension unit test param removal
* Remove the unused code
* use availability zone api def from lib
* use qos constants from neutron-lib
* tempest: Sprinkle extension checks
* shim l3 exceptions with neutron-lib
* Revisit the process on how RFEs are handled
* cleanup unit test usage of api extension maps
* Always call iptables-restore with -w if done once
* Security Groups: Test all protocols names and nums
* Updated from global requirements
* consume load\_class\_by\_alias\_or\_classname from neutron-lib

12.0.0.0b1
----------

* Do not create fip agent port for dvr\_no\_external node
* use dns api def from neutron-lib
* use default subnetpool api def from lib
* Do not try and iterate [None] in l3-agent network\_update()
* Redundant alias in import statement
* shim FAULT\_MAP from neutron-lib
* Add a new method ha\_state\_change to L3 agent extension
* create\_security\_group: Expunge an object selectively
* \_test\_security\_group\_precommit\_create\_event: Check the result of create
* Add NULL check before passing to in\_() column operator
* shim ml2 driver\_api with neutron-lib's api
* trunk: Fix init\_handler() agent parameter
* Only create one IPWrapper class instance in \_arping()
* Stop arping when IP address gets deleted
* Add some debug logs to metadata agent
* use plugin constants from neutron-lib
* Notify port\_update to agent for status change
* Don't pass trailing dash (-) to rand\_name
* Add additional tests for subnet filtering and count
* consume common constants from lib
* Remove release notes from reverted patch
* Remove argument "watch\_log = "
* Fullstack: Add l3\_agent\_mode for testing different agent types
* Fullstack: add ability to specify router scheduler
* iptables: don't log lock error if we haven't passed -w
* Wrong path of rpc\_api.rst in class docstring
* Checksum-fill proxied metadata replies
* [log]: implement logging agent extension
* Add a test csnat port removing in DVR migration
* Fix wrong OS ENV type
* ovs-fw: Remove iptables rules on hybrid ports
* tempest: check router interface exists before ssh
* Change OVS agent to update skipped port status to DOWN
* clarify deferred fixed IP assignment for ports on routed networks
* clarify agent file name in config qos doc
* use new payload objects for \*\_INIT callbacks
* Update get\_l3\_agents() scheduler tests
* Remove ip\_lib SubProcessBase.\_execute() as class method
* Switch test\_mtu.py to tempest.common.utils.requires\_ext
* Allow to configure DHCP T1 and T2 timers in dnsmasq
* Change ip\_lib network namespace code to use pyroute2
* DVR: Fix unbound fip port migration to bound port
* DVR: Fix centralized floatingip with DVR and HA
* Fullstack: add availability zone to host descriptor
* use synchronized lock decorator from neutron-lib
* Refactoring db config options
* Update the QoS bugs contact
* Refactor DVR HA migarations DB operations
* Use port object in notifiers/test\_nova.py
* br\_int: Make removal of DVR flows more strict
* Remove dead code in L3 HA scheduler
* Remove unnecessary IPWrapper() creation
* Updated from global requirements
* Update team and bug ownership info
* Change metering code to iterate through all L3 agents
* of\_native: Use int for comparing datapath ID
* fullstack: Remove ovsdb\_interface config opt
* Fix the link to the rally docs in README.rst
* ml2: fix update\_device\_up to send lm events with linux bridge
* Replace default subnetpool API tests with UT
* Linux Bridge, remove unnecessary logic to retrieve bridge name
* [Tempest] Scenarios for several sec groups on VM
* Revert "Fix for race condition during netns creation"
* Fix \_verify\_gateway\_port() in multiple subnets
* DVR: handle unbound allowed\_address\_pairs added
* ML2: remove method get\_locked\_port\_and\_binding
* Update correct reference for tags
* Remove translation of help messages from tests
* Remove get\_ip\_version from ip\_lib
* Remove deprecated get\_random\_mac()
* Remove deprecated IpNeighCommand.show()
* Updated links to dashboards
* Remove security\_groups\_provider\_updated rpc code
* rally: switch to new format for context name
* ovs: log config options when all of them are registered
* Ensure default security group before port update
* gate: don't configure linuxbridge jobs for geneve
* [Tempest] Check connectivity between VM with different MTU size net
* add doc link validation to release checklist and tox
* DVR: Always initialize floating IP host
* make net\_helpers functions work on OpenSUSE
* use neutron-lib address scope apidef
* Deprecate ivs interface driver
* Fix device\_owner during DVR and HA migrations
* Remove dead versions code
* Allow fullstack to operate on dhclient-script for OpenSUSE
* Fix for race condition during netns creation
* Dont log about skipping notification in normal case
* Tweak configure\_for\_func\_testing to work on OpenSUSE
* fix broken link in config-agents doc
* Fix missing content of neutron database creation
* Change join relationship between routerport and router
* Add API tests for Tag resource with standard attribute
* Don't assume RPC push object has an ID
* Update config-sfc documentation
* Stop using subscribe in l3\_db
* Updated from global requirements
* DVR: Fix bad arping call in centralized floating IP code
* tests: generate unique network ids for L3HARouterVRIdAllocation
* Fix documentation for DNS resolver config
* Update link for API extensions
* Stop using is\_agent\_down in agents\_db
* Switch to tempest.common.utils.is\_extension\_enabled
* Fix missing super's skip\_checks()
* gate\_hook: configure range of GRE ids
* Switch to tempest.common.utils.requires\_ext
* Delete dead API v2 router code
* Switch to Pecan for unit tests
* Drop the web\_framework option
* Remove run\_tests.sh
* gate\_hook: Switched to $NEUTRON\_CORE\_PLUGIN\_CONF
* Remove duplicated ICMPv6 RA rule from iptables firewall
* Updated from global requirements
* Fixing hyperlink issue
* Fixing external hyperlink
* Deprecate ovsdb\_interface option
* Don't trigger DVR port update if status the same
* Remove csnat port when DVR migrated to non-DVR
* Fix post gate hook to accommodate for new os-testr
* Allow OS\_TEST\_TIMEOUT to be configurable from env
* ovs mech: bind only if user request switchdev
* Treat lack of segment info in port object as unbound
* fix missing l2pop config option docs
* doc inherit segmentation type for trunking
* doc for quota details extension
* Cleanup unused params
* Remove gw\_port expire call
* Pecan: fix logic of hiding authZ failures as 404s
* Pecan: add plugin pagination/sorting validation
* Refactoring config options for ml2 config opts
* Pecan: Add missing body validations
* CountableResource: try count/get functions for all plugins
* DVR: Multiple csnat ports created when RouterPort table update fails
* DVR: get\_router\_cidrs not returning the centralized\_floating\_ip cidrs
* OVO for NetworkDhcpAgentBinding
* doc br\_netfilter prereq for linux bridge
* Update config-dns-res to use openstack CLI
* OVO for L3HARouter
* Add a new method get\_router\_info to L3 agent extension API
* Allow to disable DNS server announcement per subnet
* [Tempest] Creating sec group rule with integer
* [Tempest] Testing default security group scenarios
* Validate security group rules for port ranges
* Avoid redundant HA port creation during migration
* ovsfw: Fix up port\_range and ICMP type/code handling
* ovsfw: Fix port\_ranges handling
* use qos DriverBase from neutron-lib
* linuxbridge-agent: add missing sysctl rootwrap entry
* Fix the incorrect doc for class SecurityGroupAgentRpcCallbackMixin
* Fix cleaning QoS rules for not existing port
* Fix generation of thousands of DHCP tap interfaces
* Match load\_rc\_for\_rally logic to load\_rc\_hook
* OVSBridge: use ovs-ofctl with at least OF protocol version x
* Document dns\_domain for ports attribute
* Fix port deletion when dns\_integration is enabled
* Tempest: Fix cleaning of subnets
* Pecan: add missing body to delete notify payload
* DHCP provisioning block only on port addr update
* Remove vestigate HUDSON\_PUBLISH\_DOCS reference
* update docs to use nova\_metadata\_host
* Pecan: strip duplicate and empty user fields
* Pecan: Add missing emulated bulk create method
* test\_ha\_router: wait until two agents are scheduled
* update static urls for pike
* Fix to use . to source script files
* Pecan: set tenant\_id field when project\_id set
* Pecan: add calls to resync/dirty quota usages
* DVR: Fix agent to process only floatingips that have a host match
* Pecan: process filters at end of hook pipeline
* Make use of -w argument for iptables calls
* l3 agent: stop expecting old server when fetching service plugins
* fullstack: skip test\_mtu\_update when DHCP agent is not in rootns
* complete docs for revision number
* Update link for contribution
* dvr: Don't raise KeyError in \_get\_floatingips\_bound\_to\_host
* Revert "DVR: \_get\_floatingips\_bound\_to\_host throws KeyError"
* Prioritize tox environment executables for fullstack/functional tests
* update docs for stdattr tag support
* Integration of Port OVO in db\_base\_plugin\_common.py
* use neutron-lib's OVO exceptions
* API test refactoring about create\_project
* dhcp agent start md-proxy with vrouter id only when has metadata subnet
* Refactoring agent linux&ovsdb config
* Tempest: change way how QoS policies are cleaned
* DVR: \_get\_floatingips\_bound\_to\_host throws KeyError
* update contributor internals index
* Tempest: Fix cleaning of networks after API tests
* fix formatting in ubuntu controller install guide
* Open Queens DB branch
* functional: Remove ovsdb tests
* Updated from global requirements
* functional: Fix reference to ovsdb connection
* Fix default qos policy when creating network
* Fix test\_keepalived\_ipv6\_support for Keepalived v1.2.20
* Add network ip availability filtered by project\_id
* add doc section for ml2 extension drivers
* Treat Filter as Dict in get\_policies
* Fixes input for netlink-lib functional tests
* Stop using v2 identity API
* Add stubs for new ovsdbapp API functions
* tests: Log spawned processes by RootHelperProcess
* Revert "functional: disable netlink tests"
* DB migration checklist task for Pike
* Fix DefaultSubnetPool API test
* Make code follow log translation guideline
* Stop logging full object in RPC push code
* releasenotes: Move Pike ignore-notes to a proper file
* Apply network MTU changes to dhcp ports
* Apply network MTU changes to l3 ports
* Log policy filters in one line
* Stop logging versions on every agent update
* Update reno for stable/pike
* Add a target to Sinkhole so it's compatible

11.0.0.0rc1
-----------

* Allow unprivileged users to get their quota usage
* Deprecate web\_framework option
* Allow to set/modify network mtu
* DVR: Provide options for DVR North/South routing centralized
* Reduce rally sub-port count
* Fixing test\_convert\_default\_subnetpool\_to\_non\_default
* Remove 'persisted dirty' log message
* fullstack: Actually run ovsfw tests
* Hook bandit security linter to pep8 target
* Add API test for port dns\_domain
* Add unit tests for dns\_domain for ports
* functional: disable netlink tests
* Add documentation for Linux Bridge and OVS ingress QoS
* Add port dns\_domain processing logic
* Allow extension driver to provide multiple aliases
* Fill device\_info with port\_security\_enabled data
* DVR: Configure centralized floatingips to snat\_namespace
* Don't check full subnet body in test\_filtering\_shared\_subnets
* [log]: Add validator to logging api
* [log]: add driver manager to LoggingPlugin
* tests: apply latest release milestone alembic scripts first
* doc: Fix non-existing URLs
* Do not use prelude section for individual release notes
* Exclude relnote from past releases from Pike relnotes
* tests: don't set description in test\_blank\_update\_clears\_association
* ovs-fw: Handle only known trusted ports
* Remove configuration options max\_fixed\_ips\_per\_port
* Sinkhole workaround for old topics
* Correct tag link in README
* Updated from global requirements
* Remove code to debug auto address allocation error
* Degrade log message for missing fanout exchange to debug
* Bump network rev on RBAC change
* devstack: fix ovs install on fedora like OS
* docs: clarify wording about how to use advanced glance image
* Enable QoS scenario tests
* ovsfw: fix allowed\_address\_pairs MAC issue
* Change ovsdbapp vlog to INFO
* Drop port\_delete and port\_update debug msgs
* Don't log 'Exit code: 0'
* Check if record is stale after bulk pull
* Removed unnecessary setUp calls in tests
* Fix some pep8 errors under l3 unit tests
* Add auto-generated config reference
* Remove compat checks for psutil 1.x
* docs: Fix in TESTING.rst
* Add bandit target to tox
* Use push notification for security groups
* Log revision number in resource updated message

11.0.0.0b3
----------

* Add segments service plug-in devref
* use neutron-lib auto allocated topology apidef
* Error in docs for configuring dvr router
* DVR: Fix router\_update failure when agent restarts
* Updated from global requirements
* Catch exceptions for all rpc casts
* RouterPort OVO integration
* DVR: Fix binding info for DVR port not found error
* Add netlink-lib to manage conntrack entries
* use neutron-lib.callback.events.AFTER\_SPAWN
* Fixed FlushError on subnet creation retry
* Add project links to feature classification matrix
* [Tempest] Running Trunk test with advanced image only
* Enforce ethertype with IPv6 integer protocols
* Add datapath\_type to vif\_details in OVS driver
* FloatingIP to OVO
* Add specific values to specific fields in get\_random\_object\_fields()
* ml2 plugin: add (PORT, BEFORE\_UPDATE) callback
* Tag mechanism supports resources with standard attribute
* ovs-fw: Update internal docs with TRANSIENT table
* Update the documentation link for doc migration
* Only ensure default security group exists if necessary
* Ignore duplicate record\_resource\_delete calls
* Remove network\_id from network\_map on net delete
* Always try to delete bridge for ID on network\_delete
* Updated from global requirements
* Remove deprecated prevent\_arp\_spoofing option
* use APIExtensionDescriptor for plugins with defs in lib
* hardware offload support for openvswitch
* DistributedVirtualRouter mac address to OVO
* neutron-teams.rst: Remove an orphan footnote
* ovsfw: Fix overlapping MAC addresses on integration bridge
* DVR: Server side patch to schedule an unbound port with Floating IP
* Ignore cast exceptions in AgentNotifierApi
* hacking: Remove dead code
* OVS firewall: do strip\_vlan in TRANSIENT\_TABLE
* neutron-teams.rst: Update the list of networking-midonet lieutenants
* Log reserved cookies in cleanup\_flows method
* Use context interface for constraint
* import the admin guide content from openstack-manuals
* Add callback BEFORE\_DELETE for delete\_router
* Imported Translations from Zanata
* Stop using non-ascii characters
* Updated from global requirements
* Extend Quota API to report usage statistics
* Remove neutron-fwaas specific policies
* Tempest: Fix DeprecationWarning for Read-only property
* Adding option to check VM connectivity with packet of given size
* Updated from global requirements
* Tempest: Adopt keystone api v3 for tests
* Fix typo
* Add port dns\_domain to DB and object models
* Add dns\_domain attribute to ports in the API
* Ensure that fault map translations work correctly
* Replace test.attr() with decorators.attr()
* SR-IOV: remove ml2\_conf\_sriov.ini from manual
* Fixed AttributeError in l2pop.delete\_port\_postcommit
* tests: kill a bunch of unneeded mocks in l2pop unit tests
* Introduce trusted ports to firewall driver API
* [log]: implement logging plugin
* ovs-fw: Use TRANSIENT table for traffic classification
* TrivialFix: Remove only\_contrib argument
* stop ovs that installed from git on unstack
* New API call to get details of supported QoS rule type
* Remove unused exceptions
* import content from cli-reference in openstack-manuals
* ovo\_rpc: Avoid flooding logs with semantic violation warning
* RouterPort to OVO
* Rearrange existing documentation to fit the new standard layout
* Updated from global requirements
* Do not defer allocation if fixed-ips is in the port create request
* Support object string field filtering on "LIKE" statement
* Add QoS policy network binding OVO
* Allow to set UDP ports for VXLAN in Linuxbridge agent
* Enable an update test in UT of logging
* releasenote: Specify openstackdocs as html\_theme
* Do not respond to ARP on IPv6-only interfaces
* Tempest: Add default-subnetpools tests
* Use \_is\_dns\_integration\_supported for \_delete\_floatingip
* devstack ovs: get correct kernel rpm version on customed kernel
* Switch from oslosphinx to openstackdocstheme
* import installation guide pages from openstack-manuals
* Fix alter\_enum\_add\_value
* New RPC to set HA network port status to DOWN
* Updated from global requirements
* Use flake8-import-order plugin
* Modify the execution of alter\_enum\_add\_value SQL
* objects: support tenant\_id filter for get\_\* if project\_id is present
* use core resource attribute constants from neutron-lib
* Add "default" behaviour to QoS policies documentation
* Use subqueryload in l2pop DB for binding ports
* of\_interface: allow install\_instructions to accept string actions
* API compare-and-swap updates based on revision\_number
* Change all config options in fullstack tests to be strings
* DVR: Fix neutron metering agent to notify hosts hosting DVR
* Update after python-neutronclient doc rearrangement
* Replace the usage of 'admin\_manager' with 'os\_admin'
* Add fullstack-python35 testenv in tox.ini
* import the networking guide content from openstack-manuals
* use service type constants from neutron\_lib plugins
* Remove 'description' attribute
* Common Agent loop: Catch delete\_port extension failures
* Fix list QoS rule\_types tempest API test
* Add missing description of Linuxbridge egress bw limit
* test\_floatingip: Add a case for SRC without FIP
* Enable some off-by-default checks
* Add new ovo field type class
* Replaced assertTrue(False) with fail()
* Fix tempest router creation
* DHCP Agent: Set dhcp-range netmask property
* tempest-api: Skip test if deployment has not enough agents
* Ingress bandwidth limit rule in Linuxbridge agent
* Correct the config group in check\_trunk\_dependencies
* use attribute functions/operations from neutron-lib
* Fix some tempest deprecation warnings
* functional: Replace unicode() with six.u()
* Integration of IPAllocation
* security group: pass update value to precommit\_update
* Using constants in local
* Fix bug when checking duplicated subnets for router interface
* Add missing info about supported ingress bandwidth limit rule
* functional-tests: Make addresses for tunneling unique
* Add provider info to network for update
* functional: Don't write strings to pipe
* python3: use binary mode to open file in test
* Make HA deletion attempt on RouterNotFound race
* dvr: Move normal/output br-int flows to table TRANSIENT
* Fix html\_last\_updated\_fmt for Python3
* Updated from global requirements
* Add support for list querying in resource cache
* Add revises\_on\_change to Binding DB models
* Use objects instead of SQLA deep copies in PortContext
* OVO: Allow port queries based on security\_group\_ids
* Clean up test cases in test\_iptables\_firewall.py
* tempest: Make \_create\_router\_with\_client obey enable\_snat=False
* Fix SG callbacks notification
* Fix race between create subnet and port requests
* use six.u rather than unicode for py3 compat
* DHCP Agent: Separate local from non-local subnets
* DHCP RPC: Separate local from non-local subnets
* Store segmentation\_id during segment create
* Stop binding attempts when network has no segments
* Pass the complete info in sg/rules db into PRECOMMIT\_XXX callback
* OVO: ensure decomposed plugin do not break with OVO
* Linuxbridge agent: detect existing IP on bridge
* docs: Fix indent level
* docs: reorganize developer reference for new theme
* docs: switch to openstackdocstheme
* Updated from global requirements
* Lazy load of resources in resource cache
* DVR: Add forwarding routes based on address\_scopes
* Add a missing \_LW()
* functional: Add support for python35 flavor
* net\_helpers: Set process streams to text mode
* Trigger port status DOWN on VIF replug
* Remove unreachable code in OVS mech driver
* Add "default" behaviour to QoS policies documentation
* Use super to make \_build\_routers\_list safer
* Fix test\_dvr\_gateway\_host\_binding\_is\_set
* Manually increment revision numbers in revision plugin
* Decompose SG RPC API DB methods
* Integration of Allocation/Endpoints OVO
* python3: use a list of IPDevice objects in tests
* Fix linuxbridge ebtables locking
* TC doesn't rise exception if device doesn't exist
* Fix usage of registry.receives in Nova notifier
* replace WorkerSupportServiceMixin with neutron-lib's WorkerBase
* use neutron-lib's callback fixture
* Add support for ingress bandwidth limit rules in ovs agent
* Don't log ipam driver on every IP allocation
* Remove unnecessary debug statement from OVO push
* Reduce extension logging on init
* python3: Do not pass MagicMock as ConfigOpts
* Retry ebtables lock acquisition failures
* Move info retrieval methods below notifier
* Move db methods to bottom of SG RPC class
* Add a dashboard for Infra reviews
* Add myself to the list of our Infra liaison
* Move retry decorator to DB methods
* Integrate Security Groups OVO
* Add libffi-dev to bindep.txt
* DVR: Fix DVR Router snat ports and gateway ports host binding issue
* Stop using nested transactions in OVO get/delete
* Switch to start\_all\_workers in RPC server
* Don't log about no notification on GET requests
* [log]: db models and migration rules
* Split allowed ICMPv6 types into two constants
* Mask password when logging request body
* Remove unused class 'QoSPolicyDefaultNotFound'
* Removed Mitaka times compatibility code from RPC callbacks
* Use e.exc\_type instead of calling str on exception
* Remove redundant code in QosServiceDriverManager
* Do not defer allocation if fixed-ips is in the port create request
* Set HA network port to DOWN when l3 agent starts
* Warn the admin of a potential OVS firewall\_driver misconfiguration
* Add QoS policy port binding OVO
* Integration of IPAllocationPool
* Stop arping when interface gets deleted
* Honor the common session options for the placement API
* Drop IPv6 Router Advertisements in OVS firewall
* Checks if net\_dns is None and returns so that we don't attempt to load None objects
* Don't iterate updated\_rule\_sg\_ids or updated\_sg\_members
* tests: use devstack-gate to deploy dstat for functional/fullstack
* Use rootwrap for fullstack test runner
* objects: exclude revision\_number from updatable fields
* Revert "Use vif\_type='tap' for LinuxBridge for consistency"
* Change allowed directions for QoS min-bw rule in SR-IOV
* Update pylint disable list to pass pylint 1.7.1 checks
* Updated from global requirements
* Fix incorrect comments in ip availability test
* Add alter\_enum\_add\_value function
* neutron-rpc-server fails with no plugins loaded
* Add libssl packages to bindep
* remove unused reraise\_as\_retryrequest
* Fix html\_last\_updated\_fmt for Python3

11.0.0.0b2
----------

* use MechanismDriver from neutron-lib + shim
* Removed ovsdbapp deprecation warnings
* Switch to olso.messaging:get\_rpc\_transport
* Extend QoS L2 drivers interface to handle ingress rule types
* Update minimum tox version to 2.3.2
* Configure root\_helper and root\_helper\_daemon in fullstack tests
* l3\_ha\_mode: call bulk \_populate\_mtu\_and\_subnets\_for\_ports
* Fix updating Qos policy to be default/not default
* api: work around Routes cutting off suffix from resource id
* Add relationship between QosPolicyDefault and QosPolicy
* ovs: bubble up failures into main thread in native ofctl mode
* Fix file permissions
* python3: fix log index for test case messages
* Switched to pyroute2.config.asyncio.asyncio\_config
* Change supported vif type in Linux Bridge
* use extra\_dhcp\_opt api-def from neutron-lib
* Provide fallback for disabled port security extension
* Fixed docs job failure
* api-tests: Common way to define required extensions
* Fixes import\_modules\_recursively for Windows
* Revert "Change list of available qos rules"
* Switch to constant for 'tap' VIF\_TYPE
* Update the host\_id for network:router\_gateway interfaces
* VXLAN multicast groups in linuxbridge
* Add "default" behaviour to QoS policies
* [OVO] Integration of RouterL3AgentBinding
* Updated from global requirements
* Fix security group rules created for dhcpv6
* devstack: Adapt to lib/neutron
* Use push-notificates for OVSPluginAPI
* Revert "DVR: Add forwarding routes based on address\_scopes"
* python3: return str from read\_stdout
* python3: convert range object to list before comparing with a list
* Drop 'notifies\_port\_ready' check for DHCP agents
* Fixed python3 failure in functional tests using net\_helpers
* objects: added update\_objects to OVO framework
* objects: update fields\_no\_update to reflect models
* Renamed tox targets for functional with python3
* use is\_port\_trusted from neutron-lib
* Add precommit calls to the QoSDriver class
* objects: don't allow to update create\_at and update\_at
* Updated from global requirements
* Allow port security updates even without security-groups enabled
* Fix functional test for ovsdbapp 0.4.0
* Update team members according to latest events
* Changing create\_server to be "non class method"
* DVR: Do not check HA state on DVR-only routers
* Send both gratuitous ARP REQUESTs and REPLYs
* Fix nullable data\_plane\_status reference in port OVO
* Use vif\_type='tap' for LinuxBridge for consistency
* Move get\_vif\_type hook point into mech\_agent
* Send port ID in network-changed event to Nova
* Allow fip associate to different tenant port if admin
* Add IPv6 default route to DHCP namespace
* Update to support the ovdsbapp 0.4.0 API
* Add "direction" parameter to QosBandwidthLimitRule
* Bulk up port status updating in ML2 RPC
* Separate port status update from getting details
* Updated from global requirements
* Add check for Bandwidth Limit Rules
* Handle PortNotFound when deleting a network
* Wait 2 seconds between gratuitous ARP updates instead of 1 second
* Enable segments plugin in gate
* Fix tempest test failing with segments extension
* use worker from neutron-lib
* Notify L2pop driver from update\_device\_(up|down)
* Eliminate SUBNET\_GATEWAY resource
* Use SUBNET instead of SUBNET\_GATEWAY event in L3
* Add BEFORE\_UPDATE subnet event
* Get orig subnet in precommit method
* Move subnet event to db\_base\_plugin\_v2
* Add missing unit test for segment db
* Change PATH for "ip addr list" command so it could work with cloud-user
* Add tempest test for l3-ha extension
* Add QoS backend/rule support table to documentation
* Adds an option to skip ports on ovs\_cleanup
* ovsfw: followup cleanups for the conjunction patch
* Updated from global requirements
* service: add callback AFTER\_SPAWN
* Disable QoS scenario tests differently
* test\_dhcp: Use a safer host name
* devstack: Add neutron-sriov-agent alias for lib/neutron
* Fix: set IPv6 forwarding when there's an IPv6 gw
* Trivial fix typos while reading doc
* Fix tempest router migration test when HA enabled, v2
* Revert "Fix tempest router migration test when HA enabled"
* Remove deprecated eventlet TimeoutError exception
* OVSBridge: add --strict to allow priority in delete\_flows
* Add the parameter sub-resource-ID to the test show/update resource function
* Updated from global requirements
* Fix error getting segment\_id in linux DHCP driver
* Change list of available qos rules
* TrivialFix: Remove dead code in iptables\_firewall
* tempest: Obey ssh\_timeout config option
* Clean MissingAuthPlugin from unit tests
* Move \_get\_marker\_obj() out of CommonDbMixin
* Fix errors in PrefixDelegation.remove\_stale\_ri\_ifname
* Fix tempest router migration test when HA enabled
* tests: removed 'retargetable' framework
* tempest: Obey identity\_feature\_enabled.api\_v2\_admin in a few tests
* Utils: make delete\_port\_on\_error more informative
* use neutron-lib port security api-def
* DVR: Add forwarding routes based on address\_scopes
* Add QoS bandwidth limit for instance ingress traffic
* l3\_db: Fix a regression in the recent CommonDbMixin change
* Metering to OVO
* Make api\_all\_exntesions hook readable
* use neutron-lib callbacks
* Stop using CommonDbMixin
* Update auto-addresses on MAC change
* Only add "on-link" routes for L2 adjacent subnets
* Refactor CommonDbMixin for removal
* Use unused argument in dns extension
* remove and shim callbacks
* Remove unused parameter in test\_extension\_driver\_port\_security.py
* Add Linuxbridge agent to no dhcp fullstack connectivity test
* Creating subnet for tagged network without GW
* Tempest: Edited bash commands to work with multiple OSes
* Prevent regression of IP loss on MAC update
* ProcessManager: honor run\_as\_root when stopping process
* Add deperecated reference to impl\_idl.Transaction
* [Pecan] Fix custom tenant\_id project\_id matching
* Eliminate lookup of "resource extend" funcs by name
* Register ovs config options before using them
* Fullstack: enable DHCP agent
* Monkey patch the os and thread modules on Windows
* Replace subprocess.Popen with CreateProcess on Windows
* Add network\_id in segment check log
* Remove unused functions from devstack/lib/ovs
* Use conjunction for security group rules with remote\_group\_id
* Use the ovsdbapp library
* fullstack: Compile openvswitch module for fullstack test
* fullstack: Don't let dhcp agents failover
* Use dirname in object recursive import
* Use HostAddressOpt for opts that accept IP and hostnames
* Stop extension warnings in UTs
* Remove EXTERNAL\_NETWORK callbacks
* Bulk up port context retrieval
* Stop DHCP agent scheduler warnings in UTs
* Fixup event transaction semantics for ML2 bulk ops
* Set MTU on tap devices in Linux Bridge agent
* Updated from global requirements
* Revert "Update auto-addresses on MAC change"
* docs: Update TESTING.rst about openvswitch requirements
* Make QoS policy object compatible with versions 1.2 and higher
* Correct param type description of supported\_rules of QoS driver
* Eliminate mixin references in DVRResourceOperationHandler
* Split out DVR DB into multiple classes
* DVR: move snat and csnat functions
* DVR: move delete\_floatingip\_agent\_gateway\_port
* DVR: move \_get\_device\_owner and floatingip CUD
* DVR: Move \_get\_floatingip\_by\_port to l3\_db
* Use NETWORK callbacks in get-me-a-network code
* sanity check: deprecate all version based checks
* Disable new N537 hacking check from next neutron-lib
* Ensure behavior of None for device\_id
* Remove deprecated send\_arp\_for\_ha option
* Add a skip check to make sure that vlan is actually in available\_type\_drivers
* Add a new configuration variable for api links
* Add devref for supporting use floatingip cross scopes
* Replace six.iteritems with dict.items(Part-2)
* Update auto-addresses on MAC change
* Stop loading OVOServerRpcInterface in ML2 testcase
* Agent-side receiver cache for ML2 OVO
* Delete segments using OVO code
* Don't load rels on detached objects
* Add api test to create vxlan network
* segments: make sure we pass lists into get\_objects
* tests: allow database layer to generate id for standard attributes
* Refactoring \_create\_test methods for OVO UTs
* Revert "Rally: decrease SLA for avg list of ports and nets"
* qos: removed silly tests validating that oslo.versionedobjects works
* Remove deprecated support for QoS notification\_drivers
* Rename method to better reflect what it does
* ml2: Remove no longer necessary subtransaction workaround
* Update operation dns notes url
* Update release page url
* devref: Remove resolved fullstack TODO items
* Floating IP association without subnet gateway IP
* Replace six.iteritems with dict.items(Part-1)
* Expose neutron api application as a wsgi script
* Allow to disable DVR api extension loading
* Add IPAllocations to the port fixed\_ips
* Integration of Router Extra Attributes OVO
* Eliminate lookup of model query hooks by name
* move make\_port\_dict back out of txn
* Integrate NetworkSegment OVO
* Add launchpad bug update support to abandon script
* Implement '-F' option for 'net-ip-availability-\*' command respond
* Exhaust VLAN allocations in physnet order
* Check permutations of router migrations
* Don't set use\_stderr to False for tests
* Reduce rpc calls in SR-IOV agent
* Dont try to apply iptables rules in a endless loop
* Handle CIDR IP address in allowed address pairs
* Allow self-sharing RBAC rules to be deleted without usage check
* Remove unused variable
* Use registry.receives decorator in neutron.db.l3\_db
* Use 'segment' instead of 'network' in log
* fix overaggressive 403->404 conversion
* Updated from global requirements
* ip\_lib: ignore gre and lo devices in get\_devices by default
* Ignore gre devices in namespaces when cleaning up devices
* Record queries for helpful failure msg in bounds test
* Add string validation on security group's name
* Pass MTU and AZ into network\_create\_precommit
* Don't override default values for oslo.db options
* tests: removed support for OS\_CHECK\_PLUGIN\_DEALLOCATION
* Stop direct access to CONF.debug
* Switch to neutron-lib hacking factory
* Add some bulk lookup methods to ML2 for RPC handling
* Allow offloading lookups in driver contexts
* Don't mock registry in revision\_plugin test
* Call expire\_all in revision tests before re-use
* Pecan: /v2.0/ views response with resources
* Deprecate watch\_log= argument for Daemon
* Refactor the usage of save\_and\_reraise\_exception
* docs: Update TESTING.rst with gate information about ovs
* policies: Add policy for rechecking failed jobs on Gerrit
* Adding missing neutron policies to policy.json
* fullstack: Test vms are pingable before testing data plane
* DVR: Create router to fip namespace connection based on gateway state
* Port data plane status extension implementation
* DVR: Don't clean snat-ns of DVR HA router when fullsync
* Exit on failure to load mechanism drivers

11.0.0.0b1
----------

* Add sanity check for conntrack
* Fix some reST field lists in docstrings
* New enginefacade for ports and sg groups
* extraroute\_db: Remove \_get\_extra\_routes\_dict\_by\_router\_id
* extraroute\_db: Clean up update\_router
* Add Apache License Content in index.rst
* Correct the mistake in ../conf.py
* Fix some grammatical errors in TESTING.rst
* DVR: properly track SNAT traffic
* Ignore gre devices when fetching devices in test\_cleanup\_stale\_devices
* DocFix: sriov\_nic\_agent supports qos
* Optimize the link address
* Assert contents of returned devices in test
* Tempest: Fixing L3 agent hosting router for DVR setup
* Flush objects by ourselves before processing before\_commit event
* Don't check for enable\_security\_group vs. firewall\_driver compatibility
* execute: don't call greenthread.sleep directly
* Fixed validation of create\_and\_list\_trunk\_subports rally scenario
* Fix SQL fixture to preserve engine facade settings
* Quota list API returns project\_id
* Log messages for keepalived-state-change in syslog
* Enable keepalived debug logs when debug=True
* Add sem-ver flag so pbr generates correct version
* ovs-agent: Clear in\_port=ofport flow earlier
* Print useful error on rootwrap daemon failure
* Fix tempest router timestamp test when HA enabled
* Fix TypeError in native of\_interface \_get\_dpid
* hacking: disable log translations check
* Disable dvr tempest tests using DISABLE\_NETWORK\_API\_EXTENSIONS
* Add net precommit create callback and req to update
* Inherit segmentation details for trunk subports if requested
* Removing workaround for bug 1656947
* Updated from global requirements
* Update QoS devref
* Improve validation of supported QoS rules
* deepcopy binding and binding levels avoid expiration
* Move notify\_security\_groups\_member\_updated to callback
* Handle auto-address subnets on port update
* use neutron\_lib's portbindings api-def
* Deal with port commonly when hypervisor is XenServer
* Egress sg\_rules should get 'prefix' from 'dest\_ip\_prefix'
* Move conntrack zones to IPTablesFirewall
* Use os-xenapi for neutron when XenServer as hypervisor
* TestTrackedResource: register core plugin in directory
* Retrieve fresh network DB data before getting it in ml2
* Remove stale floating IP addresses from rfp devices
* Use is\_loaded in manager.init
* Revert "Skip DHCP agent query in provisioning block setup"
* New enginefacade for networks, subnets
* Fix relationship event handler for flushes and nested
* Make RBAC entry removal enginefacade friendly
* Fix call a method of extension class
* Handle empty body in add\_router\_interface
* Remove unnecessary setUp function in testcase
* LOG.exception for mech dict extend failure
* Add an example for update in object\_usage
* Use new enginefacade for quota and provisioning blocks
* Port idlutils.get\_schema\_helper from ovsdbapp to neutron
* raise Exception instead of LOG.error on cookie/mask inconsistency
* Verify metering label exists before applying rule
* Remove a release note for reverted patch
* Avoid router ri.process if initialize() fails
* Throttle SIGHUPs to keepalived
* ExtensionTestCase: register correct core plugin
* Use router tenant for interface attach
* Load all eager relationships on 'before\_commit' event
* Update metering agent to use stevedore alias for driver
* Fix Quota error while running tests
* Clear QoS rules from ports without a qos policy
* Correct file mode
* Feature Classification Cleanup
* Delete segments on BEFORE\_DELETE instead of PRECOMMIT
* OVO for Quotas and Reservation
* Remove minimum\_bandwidth\_rule from rules supported by Linuxbridge agent
* Refactor OVSCookieBridge: always use bridge cookie
* delete\_flows shall only touch flows with the bridge cookie
* Log instance interface addrs in subport test
* Skip DHCP agent query in provisioning block setup
* Optimize pid property in AsyncProcess class
* Replaces uuid.uuid4 with uuidutils.generate\_uuid()
* Configure tempest.conf via test-config phase
* Stabilizing process monitor function test case
* Use oslo.context class method to construct context object
* Fix some reST field lists in docstrings
* Updated from global requirements
* Fix Python 3 compatibility in idlutils
* Bump default quotas for ports, subnets, and networks
* Write vrrp\_script before (re)starting keepalived
* Use BEFORE\_CREATE events for \_ensure\_default\_security\_group
* Apply QoS policy on network:router\_gateway
* Move NEUTRON\_\* definitions from plugin.sh into settings file
* Simplify RootHelperProcess.\_read\_stream()
* Switch RootHelperProcess from select.poll to select.select
* Reconcile quitting\_rpc\_timeout with backoff RPC client
* Use unique binding\_index for RouterL3AgentBinding
* Add precommit notifications for create/update port/network in ML2
* Rally: decrease SLA for avg list of ports and nets
* Revert "Stop skipping compute owner in Linux Bridge loop"
* Fix copy-paste error in hacking checks
* Update stadium stable dashboard
* teach logger mech driver vlan transparency
* Fix linuxbridge agent startup issue with IPv6
* Consume ServicePluginBase from neutron-lib
* OVO creation for RouterL3AgentBinding
* Disable RA and IPv6 forwarding on backup HA routers
* Updated from global requirements
* Pass parameters when create eventlet.wsgi server
* Remove network port special-case in provisioning block
* Downgrade callback abortable event log to debug
* Remove redundant/stale sections from neutron-teams doc page
* pecan: Make admin context if no context was created
* TrivialFix: Remove extra space from log
* Do not use -1 as an OpenFlow flow cookie
* Stop spilling tracebacks during normal operation
* Neutron Feature Classification
* Don't IPAddressGenerationFailure for DHCP ports
* Get rid of custom wrap\_db\_retry call in sync\_allocations
* Use correct retry mechanism in tags
* Fix link rendering for grafana dashboards
* Agent common config
* On update\_tags, clean up tags from the requested resource only
* Use warn\_on\_missing\_entrypoint from stevedore 1.20.0
* use neutron\_lib's provider\_net api-def
* Bump os-log-merger version in post\_test\_hook
* Don't add duplicate metadata rules after router update
* Render service plugins configurable
* Removed Netmtu\_db\_mixin from the tree
* Expose register\_objects function to register all known objects
* Use @registry.receives in neutron.services.segments.plugin
* Add PD support in HA router
* Remove dependency on strings for kill\_process
* Trim rally scenario sizes
* Let setup.py compile\_catalog process all language files
* Untangle WaitTimeout class from eventlet.TimeoutError
* qos: Pass correctly table\_id to openflow driver
* Switched gate to new neutron-\* service names
* Check for None in \_get\_agent\_fdb for agent
* Fix two spelling errors
* Generate index file containing oslo.log messages for all tests
* Remove deprecated method get\_interface\_mac
* Decouple hook and func registration from CommonDbMixin
* TrivialFix: Do not use synchronous\_reader argument
* Change the way to distinguish the port type
* Replaces yaml.load() with yaml.safe\_load() in neutron
* Switch to Pecan by default
* Init policy in pecan after hook as well
* Set OVS inactivity\_probe to vsctl\_timeout when adding manager
* Network OVO in neutron/tests/unit/plugins/ml2
* Change in-tree code to use moved get\_ip\_version()
* devref: docs about how to use NeutronDbObject
* Switch ns-metadata-proxy to haproxy
* Don't return null-byte separated string from ExternalProcess.cmdline()
* Guard against os-log-merger failure
* Update is\_default field only when specified in the request
* OVO for Tag
* devstack: use neutron\_service\_plugin\_class\_add for service plugins
* devstack: added new neutron-\* aliases for services
* devstack: switch to new NEUTRON\_\* variables
* Fixes crash when starting Neutron OVS Agent on Windows
* Make query in quota api lockless
* Lockless segmentation synchronization in ML2 type drivers
* OVO External Networks
* Decouple tests from default quota size option values
* Fix bashate warnings
* Added docstring for Pager for OVO
* use neutron\_lib's get\_random\_mac
* add 4094 to fix the range of available local vlans
* devstack: configure ml2 extension drivers using lib/neutron
* Get rid of delete\_subnet method in ML2
* Ensure ovsdb\_connection enabled before calling monitor
* Remove unnecessary overrides in Subnetpool OVO
* Switched rpc access policy to DefaultRPCAccessPolicy
* Stop skipping compute owner in Linux Bridge loop
* Spin off context module
* Clean up dsvm-scenario handler for gate\_hook
* Cleaned up the list of lieutenants and stadium points-of-contact
* Updated from global requirements
* Get rid of ML2 inheritance of delete\_network
* Use Sphinx 1.5 warning-is-error
* Bump to Nova V2.1
* Prepare trunk rules module to deal with the Ironic use case
* Stop killing conntrack state without CT Zone
* Fix trunk subport scenario test
* Deprecate nova\_metadata\_ip in favor of nova\_metadata\_host option
* Include metadata content for debugging
* [Fix gate]Update test requirement
* Use @registry.receives in neutron.services.trunk
* Don't use save\_and\_reraise\_exception when we never reraise
* Fix typo in test\_rules.py
* Use @registry.receives in neutron.services.qos.drivers.base
* Use registry.receives decorator in driver\_controller
* Use registry.receives decorator in neutron.db.dvr\_mac\_db
* Fix has\_registry\_receivers when super.\_\_new\_\_ is object.\_\_new\_\_
* Provide more useful repr for IPDevice
* Scan for mac through all devices
* Use registry.receives decorator in neutron.notifiers.nova
* Stop making IP-specific provider rules in SG code
* LB Trunk: Stop matching MAC of subport to port model
* Switch external network create event to precommit
* Use registry.receives decorator in neutron.db.db\_base\_plugin\_v2
* Updated from global requirements
* Convert gate\_hook to devstack-tools
* Remove unused enable\_snat attribute
* Fix has\_registry\_receivers for classes w/o \_\_new\_\_
* Use registry.receives decorator in neutron.db.availability\_zone.router
* Use registry.receives decorator in neutron.db.l3\_hamode\_db
* Use registry.receives decorator in neutron.db.l3\_dvr\_db
* Fetch trunk port MTU only on trunk validation
* iptables: stop 'fixing' kernel sysctl bridge firewalling knobs
* Use registry decorator in ML2 plugin
* Prevent double-subscribes with registry decorator
* Use registry decorator in external\_net\_db
* Switch to use idempotent\_id decorator from tempest.lib
* Adding a code coverage threshold
* Remove a NOTE that doesn't make sense anymore
* Add bashate support
* Cleanup \_find\_related\_obj
* tiny refine: capitalize mod\_name with string capitalize function
* Mark of\_interface option deprecated
* functional: Stop compiling OVS from source
* Clean up deprecated sqla model import paths
* gate\_hook: accept dsvm-scenario-[ovs|linuxbridge] venv name
* OpenFlowSwitchMixin: do not override delete\_flows
* Fix OVSBridge.delete\_flows when called with no args
* Remove obsolete comment
* Configure HA as False when creating a router for DVR tests
* Deprecate gateway\_external\_network\_id option
* gate-hook: Accomodate devstack-gate local.conf changes
* tempest: Skip QoS test until fixed
* Fix string case issue in rpc\_api documentation
* Avoid applying noop lambdas per object in db\_api.get\_objects
* Stop handling interface drivers that don't support MTU
* Provide hook for networking-sfc OVS agent code
* Registry decorator to bring subscribes to methods
* Add some debug statements to root-cause 1666493
* Allow no network to be passed into PortContext
* Avoid segment DB lookup in \_expand\_segment on port
* Make ML2 OVO push notification asynchronous
* Avoid loading network and all rels for subnet query
* Don't log about retrying failed devices if empty
* Allow no network to be passed into subnet context
* Enforce port QoS policies for all ports
* Pecan: Get loaded by paste deploy
* Macvtap: Check for no original port in is\_live\_migration
* Skip native DHCP notifications on status change
* Move dhcp\_release6\_supported to runtime checks file
* Disable process monitor for keepalived test
* Flavors: move dict extend out of txn
* Remove deprecated methods supported by neutron\_lib
* Fix typo in blueprints.rst
* Remove logging import unused
* Add a tempest scenario for floating-ip
* Invert device\_owner to avoid filtering too much
* Clean up ovsdb-native's use of verify()
* Simple logging de-dup logic to RPC version\_manager
* fullstack: Fix race between updating port security and test
* Adding cleanup of floating ips
* For typo in sqlalchemytypes
* Updated from global requirements
* Only log IDs of callbacks in debug message
* Add helper for driver to check if it owns router
* Enable dstat for in-gate functional and fullstack test runs
* [TrivialFix]Remove the file encoding which is unnecessary
* Don't configure neutron.conf as part of functional/fullstack gate
* Remove dependency on memory heavy python-requests
* Pass --concurrent flag to ebtables calls
* Revert "Linux Bridge: driver support for QoS egress minimum bandwidth"
* Switch to use test\_utils.call\_until\_true
* Fix typo in .pylintrc file
* Update devref for enhanced tag mechanism
* Use ipam AllocationOnAutoAddressSubnet class
* Simplify the QoS bandwidth test to increase reliability
* Raise InvalidInput exception on provider-net creation without seg\_id
* Fix error in openvswitch firewall doc
* Fix duplicated sg rules check for remote\_ip\_prefix
* Typo fix: underlaying => underlying
* Skip segment checks during network delete operations
* Open Pike DB migration branch
* Tag the alembic migration revisions for Ocata
* Deprecate get\_locked\_port\_and\_binding
* DVR: Look at all SNAT ports for a subnet match
* Don't delete\_port on binding deadlock
* Simplify notify transaction tests
* Remove ORM relationship between ports and networks
* Switch to 'subquery' for 1-M relationships
* Add DBError to \_is\_nested\_instance
* Enhance tag mechanism
* Update reno for stable/ocata

10.0.0.0rc1
-----------

* Use same session object for ml2 dict extend functions
* Skip reading config files from neutron.conf.d for the namespace proxy
* Turn nova notifier into a proper rate limiter
* Add Loki service plugin for optional DB havoc
* Use bytes for python3 friendly os.write
* Updated from global requirements
* Use addCleanup instead of tearDown
* Remove --omit argument in run\_tests.sh
* Integration of Provisioning Block OVO
* Pecan: Fix tags handling for pecan
* Move ovsdb\_nested transaction to ovs\_lib
* Add support for Keepalived VRRP health check
* Ensure that subnet update does not creat RPC client
* Revert "Don't disable Nagle algorithm in HttpProtocol"
* Increase coverage in agent/l3/dvr\_local\_router.py
* Use socket.AF\_INET6 in ip\_lib tests
* tempest: Pin Ubuntu image to one version
* Update bug triaging policy for documentation
* Remove duplicated and unused code in iptables\_firewall
* Terminate macvtap agent when physical\_interface\_mapping config not present
* Add IPv6 Prefix Delegation support for DVR
* Fix port update for service subnets
* Update in-tree code to use new neighbour functions
* tempest: Log server console output of failed SSH
* functional: Check for processes only if there are any
* Fix link in QoS devref
* Clear conntrack entries without zones if CT zones are not used
* Fix iptables rules for Prefix Delegated subnets
* policies: Replace Joe's graphite graphs with Grafana
* Init privsep on l3 agent start
* Display deprecation warning in test only once
* Kill the metadata proxy process unconditionally
* Always acquire network.id lock in dhcp port update
* Fix WaitTimeout string representations
* Remove baremetal notification from nova notifier
* Addressing L3 HA keepalived failures in functional tests
* Stop passing datapath as 'may\_exist' argument
* DVR: Add static routes to FIP namespace
* Refactor L3 scheduler (unify code paths)
* Retry on routerport delete race
* Do not raise an error deleting neighbour entry
* Clean up inconsistent syntax
* [Live Migration] Extend ml2\_port\_binding table
* Fix some pylint errors in IPAM tests
* Use weakrefs for common\_db\_mixin callbacks
* Add bulk pull OVO interface
* Handle attempt to enable br\_netfilter in namespace

10.0.0.0b3
----------

* Check arg type for SegmentTypeDriver functions
* Add missing port UPDATE event to ML2
* Fixes to allow OVO deserializion of ports/networks
* Add missing module-level SUBNET ref
* ovsfw: Refresh OFPort when necessary
* Fix a bad docstring in provisioning blocks module
* Transition qos notification driver into qos driver
* OVS: merge the required OpenFlow version rather than replace
* Fix typo in test\_l2\_lb\_agent.py
* Adjust psutil usage for psutil > 2
* Connectivity tests for OVS agent failures/restarts
* Allow all migration of routers
* Set access\_policy for messaging's dispatcher
* Elminate join for network owner filter
* Always add unique sort keys when sorting
* Allow the other nic to allocate VMs post PCI-PT VM creation
* trunk: Add tempest test validating subport connectivity
* Change neighbour commands to use pyroute2
* Routed networks IPv4 inventory in Nova GRP
* Correctly set project\_name
* Break circular import with use of common\_types
* ovsfw: Support protocol numbers instead of just tcp and udp
* Add KillFilter for python 3.5
* Register sqlalchemy events through hook for UT cleanup
* Fix empty string check for python 3
* Update docstring in validate\_provider\_segment
* Update docstring for base OVO
* Modify docref commands to reflect OSC transition
* Server-side push notifications for ML2
* Allow 0 in port range for securitygrouprule object
* Updated from global requirements
* OVO for Ipam(Allocation,Subnet,Pool)
* Remove get\_router\_cidrs method of dvr\_edge\_ha router
* Use plugin directory fixture
* openvswitch agent: add OVS\_RESTARTED event
* Stop using legacy facade
* XenAPI: Support daemon mode for rootwrap
* Fix importing old path for exceptions
* Pecan: Fix policy checks for lists
* Use ubuntu image for tempest scenarios from Neutron
* Catch invalid subnet service\_types on input
* Fullstack SG test for LinuxBridge agent
* Get rid of L3 HA override of \_update\_router\_db
* Neutron server was not compatible with member actions
* Get rid of create\_router override in l3\_ha mixin
* Add a ReST client for placement API
* Add OVO for AutoAllocatedTopology
* Fix typos
* Fix broken Windows compatibility in ovs\_lib
* Add IPLink class to Windows ip\_lib implementation
* Support ovsdb-client monitor with remote connection
* Protect against non-determinstic sort
* Remove deprecated min\_l3\_agents\_per\_router
* Include port\_security check in fullstack tests
* Revert "Setup firewall filters only for required ports"
* test\_l3: Enable native pagination and sort
* Revert "Protect against non-determinstic sort"
* Multiple tweaks for Ocata release notes
* L3: Add in missing translation
* Fix broken links in devref
* Rename a test method
* DVR: delete stale devices after router update
* Linux Bridge: driver support for QoS egress minimum bandwidth
* Use project\_id instead of tenant\_id in objects
* Remove references to defunct Stadium docs
* Use new enginefacade for dvr mac db
* DHCP: enhance DHCPAgent startup procedure
* Use writer for trunk database operations
* Add check for ha state
* DVR: fix csnat port missing after router update
* Manually add pk for alembic\_version table
* Only migrate ports on DVR migration
* Protect against non-determinstic sort
* Decompose router extra attr processing
* Use unique subnetpools in SubnetPoolPrefixDbObjectTestCase
* Fix netns\_cleanup interrupted on rwd I/O
* Don't emit SG rule AFTER events until TX closed
* Updated from global requirements
* neutron-lib: use L3 constant
* Use the session loader in keystoneauth1 for designate
* Fix delete\_network to delete ports one by one
* Cleanup unused helper function from test code
* Added UT for floating ips with dns
* Centralize creation of security group test obj
* Suppress annoying "Could not load" stevedore warnings
* adds support for vhost user reconnect
* Clean up \_get\_ports\_query
* Get rid of additional fixed\_ip filter join
* Remove advertise\_mtu config option
* Get rid of \_network\_model\_hook for external\_net
* Protect against '.delete()' for quota and revisions
* Don't use .delete() on a port in unit test
* Stop using .delete() in external net handling code
* Revert "Add ALLOCATING state to routers"
* Get rid of ml2 port model hook join
* Add retry to \_create\_ha\_port\_binding
* Correct the msg ipv6 enable in system
* Change default exception in wait\_until\_true
* Checking functionality of DVR
* l3scheduler: create ha\_vr\_id more robustly
* Remove python 3.4 support
* Get rid of l3 ha delete\_router inheritance
* Allow to pass suite flavor to gate\_hook to disable dvr tests
* Don't create default SG in transaction
* Kill neutron-keepalived-state-change gracefully
* gate\_hook: Add support for neutron-full with the ovs firewall
* Add filter check for quering
* Fix dir doc typo error
* Flavor and Service Profile to OVO
* DHCP: "reserved\_dhcp\_port" not well managed during startup
* Raise AssertionError instead of eventlet.timeout.Timeout when failing
* Adding debug trace to IPWrapper.get\_devices()
* Use gate\_hook to enable q-trunk for rally
* Update contacts and team list
* Replaces uuid.uuid4 with uuidutils.generate\_uuid()
* Reduce IP link show calls for SR-IOV scan loop
* Add DictOfMiscValuesField in OVO for dict usage
* SR-IOV: Remove physical\_device\_mappings depreciation warning
* Fix a typo in iptables\_manager.py
* DB: remove deprecated oslo\_db warnings
* Fullstack tests for DHCP agent HA
* Remove greenlet useless requirement
* Fix pylint warning in test\_l3\_hamode\_db.py
* Fix typo
* Add more protocols to the iptables module map
* Replace nc command with ncat
* Refactors QosAgentDriver
* Change the order of installing flows for br-int
* Updated from global requirements
* [TrivialFix] Fix comment typo error
* Don't create HA resources until needed
* Do not try and remove non-existent iptables chains
* Fix ext alias in revision API test
* Modify error word "procedence" to "precedence"
* Updated from global requirements
* [TrivialFix] Fix comment typo error
* neutron-lib: use CORE from neutron lib constants
* Use Port OVO in ml2/db and plugins/ml2/test\_db
* gate\_hook: Add a no-op rally case
* Remove Duplicate line in privsep.filters
* Use DB field sizes instead of \_MAX\_LEN constants
* Account for unwire failures during OVS trunk rewiring operations
* Change passing session to context in segments db functions
* Fix a bug in process\_spawn binding on ports
* team update: john-davidge doc liasion
* OVO for FlatAllocation
* Fix python3 issues with devstack
* iptables: don't enable arptables firewall
* Pecan: Fix subresource policy check
* Adopt privsep and read routing table with pyroute2
* Change passing session to context for TypeDriver
* of\_interface: Revert patching ryu
* Remove iptables nat and mangle rules for security group
* SR-IOV: remove ml2\_conf\_sriov.ini from oslo-config-generator
* Sort and Remove duplicate field types
* Remove test cases that moved to tempest
* Kill processes when cleaning up namespaces
* Don't return content when we set HTTP 204
* Set standard\_attr\_id as property in DeclarativeObject
* Add agent object in router info
* Bump revision of resource on tag add/remove
* Use subqueries for rbac\_entries and subnets<->network
* Use assertGreater(len(x), y) instead of assertTrue(len(x) > y)
* ovsfw: Raise exception if tag cannot be found in other\_config
* Proposing tidwellr and njohnston as service layer go-to contacts
* Propose mlavalle as neutron core and L3 second in command
* Use get\_random\_string from neutron-lib
* Moving pyroute and oslo.privsep deps into requirements.txt
* devref: suggest bug deputies to send brief reports to ML
* Ensure random object unique constraints aren't violated
* Update comment about foreign keys
* Document how to proceed with new platform features
* Update MTU on existing devices
* Added log messages while creating neutron objects
* Add subprojects database migration
* Fullstack test for DHCP agent
* get\_random\_object\_fields() for setting object attr
* Updated from global requirements
* Remove external\_fixed\_ips from Plural\_mappings in l3.py
* Clean-up L3 constant TODOs
* Unittests improvement

10.0.0.0b2
----------

* Restore extraroute dict after OVO change
* tests: change order of assertion in \_validate/compare\_resource
* Refactor ml2\_db to pass context
* Propose abhiraut as neutronclient core
* OVO for Allocation and Endpoint
* Correctly print --limit value passed via API
* Fix flake8 error in DHCPOptsTestCase class
* objects: add delete\_objects public method
* DVR: Fix race condition in creation of fip gateway
* Bulk creation of SecurityGroups
* Remove model\_base deprecations
* DSCP packet marking support in Linuxbridge agent
* Remove duplicated revises\_on\_change in qos db model
* Fix DHCP Port Creation on Service Subnets
* tempest: Fix qos extension check
* Unplug external device when delete snat namespace
* Revert "Squash revert to breaking changes"
* Optimize trunk details extension hook
* rally trunk port list
* Get rid of DVR override of remove\_router\_interface
* Check for unbound ports in L3 RPC handler
* devref: don't suggest to manually request stable branches
* Revert "lb-agent: ensure tap mtu is the same as physical device"
* Fix some slow unit tests
* DVR: Fix IPtables driver for metering with DVR routers
* Get rid of DVR override of add\_router\_interface
* Remove redundant "dvr" in test name
* Pass context and resource\_type in RPC callback
* Tempest tests uses only supported QoS rule types
* Get rid of DVR override of \_port\_has\_ipv6\_address
* Add filters support to constant queries test
* Remove deprecated dhcp\_domain from dhcp\_agent.ini
* SRIOV: don't block report\_state with device count
* OVO for VlanAllocation
* Correctly configure IPv6 addresses on upgrades
* Add janitor to cleanup orphaned fip ports
* Make UUIDField actually validate UUIDs
* Delete related conntrack when delete vm
* Add validation for security\_groups parameter in Port
* Pecan: Change Quotas to use original controllers
* Use Query.column\_descriptions instead of private property
* Remove fallback functions in agent/rpc
* Convert filters to empty dict if None in DB's get\_subnetpools()
* stadium guidelines: Document stable branch creation
* doc: Fix a warning
* Allow keystone v3 in the designate driver
* QoS: update the database before notifying the backend on delete
* Expose [agent] extensions option into l3\_agent.ini
* Include ovsdb\_connection option into all interface\_driver agents
* Eliminate DVR inheritance of router create/update\_db
* Use ExtensionDescriptor from neutron-lib
* Support alembic 0.8.9 in test\_autogen\_process\_directives
* Use Port OVO object in test\_l3\_ext\_gw\_mode
* Refactoring config opts for ml2 plugin openvswitch
* Don't compile OVS kernel modules for functional job
* Update bug tag contacts due to absconsions
* configure\_for\_func\_testing.sh: Remove neutron-legacy inclusion
* configure\_for\_func\_testing.sh: Source lib/neutron as well
* Functional tests: change assert to wait\_until\_true
* revise doc: support\_extension\_aliases to supported\_extension\_aliases
* Pecan: Remove get\_resources() from get\_pecan\_resources()
* Fix docs headers
* Update DB lieutenant to Ann Taraday
* Compare port\_rule\_masking() results with different approach
* Use to\_policy\_values for policy enforcement
* Skip larger than /64 subnets in DHCP agent
* Refactoring config options for mech\_sriov opts
* Delete conntrack when remote ipset member removed
* Migrate device\_owner for router's interface
* Remove allow\_pagination and allow\_sorting config options
* Integration of RouterRoute OVO
* tests: introduce update\_obj\_fields method in base objects test class
* Add notify for tag operations
* gate\_hook: Remove a stale comment
* Renamed all [AGENT] config sections into [agent]
* Reuse plugin's update method for changing trunk status
* Calculate IPv4 DHCP subnets once for metadata
* Lock in DHCP agent based on network\_id
* Fix OSprofiler support
* Introduce objects\_exist method in neutron/objects/base.py
* OVO: add SubnetServiceType object and code integration
* Revert "Deprecate SR-IOV 'physical\_device\_mappings' config option"
* Removed deprecated method
* ml2: Add original port to context on \_bind\_port
* Integrate Address Scope OVO into DB
* Add missing revises\_on\_change attribute
* Redirect ExtensionDescriptor to neutron-lib
* Remove PLURALS
* Show team and repo badges on README
* ovs-agent: Close ryu app on all exceptions
* Get rid of DVR inheritance of \_delete\_current\_gw\_port
* Solve unexpected NoneType returned by \_get\_routers\_can\_schedule
* fullstack: add some more security group tests
* Update network dict with segment and mtu info in \_create\_subnet\_db
* Capture NotFound Exceptions in subnet postcommit
* Revert "DHCP agent: advertise SLAAC prefixes"
* Get rid of floating IP bgp next\_hop query
* L3: Only send notifications if l3 plugin exists
* Pecan: Minor Fix in startup
* Squash revert to breaking changes
* Remove REVERSED\_PLURALS and get\_resource\_info()
* Remove legacy oslo.messaging.notify.drivers
* Fix InvalidInput exception output
* Revert "Fix file permissions"
* Adopt neutron-lib plugin directory
* DB: use get\_unique\_keys from oslo\_db
* ovsdb: don't erase existing ovsdb managers
* OVO for Provisioning Block DB Model
* ovs-agent: Catch exceptions in agent\_main\_wrapper
* functional: Remove unused l3 config
* Updated from global requirements
* Improve performance of \_modify\_rules
* Refactoring config options for plugin l2pop opts
* Refactoring config options for plugin macvtap opts
* Refactoring config options for l2 agent ext opts
* Refactoring agent metadata config
* Metering: sync only active routers hosted on the same host
* Fix security\_groups\_provider\_updated for linuxbridge
* Using a new security group in scenario tests
* Fix file permissions
* DB: remove deprecation warnings for BASEV2
* cors: update default configuration
* Add unit test in test\_allowedaddresspairs\_db
* Adjustment method execution order
* functional: Pass string tag to other\_config
* functional: Use VLAN tags from range <1; 4094>
* Replace create\_test\_segment with NetworkSegment object
* Remove unused LOG
* Get post-subnet actions out of transaction
* ProviderResourceAssociation to OVO
* sanity check: Check that ip\_nonlocal\_bind works with namespaces
* callbacks: Make the value of FLOATING\_IP match with api resource
* Move SR-IOV VIF type constants to the portbindings extension
* Use new enginefacade metering db
* Move DVR fip agent gw port create out of transaction
* Separate floating IP port creation from transaction
* Use callbacks to create DVR floating GW port
* Disallow specifying too long name and description for qos
* Move AgentStatusCheckWorker to PeriodicWorker
* Speed-up iptables\_manager remove\_chain() code
* Typo on side\_effect rendering the test useless
* Fix reset/start methods on AgentStatusCheckWorker
* Pecan:Add functional test for QuotasController
* Elimination duplication of lots of DVR tests
* Have qos object increment port/network revision
* Update devref examples about alembic migrations
* Trivial Fix - Update code to use Pike as the code name
* Stop using deprecated CORS.set\_latent()
* L3 scheduler: add retry indicators for bind\_router
* Install OVS from git if current version < 2.5.1
* Fix typos in standard\_attr.py & attributes.py
* Clean up agent status check debt
* Collect OVS Debt
* Disable 'accept\_ra' in DHCP agent namespace
* Replace assertEqual(None, \*) with assertIsNone in tests
* Fix ML2, base db plugin update\_subnet for transactions
* DVR: Fix func docstring and comments
* Move sysctl out of IPDevice class

10.0.0.0b1
----------

* Parse the output of ip route more robustly
* Add L3 HA test with linux bridge
* Fix "failed unplugging ha interface" error when deleting router
* Add a trunk rally test
* Updated from global requirements
* Fix typo in release note filename
* Use new enginefacade for servicetype\_db
* Remove floatingip address ignores ha\_state
* ovsfw: small cleanups to improve readability
* Use new enginefacade for tag
* Change import statement to not rename the module
* Add unit tests for ip\_lib.get\_routing\_table
* policy: cache extracted parent fields for OwnerCheck
* Changing arping command execute to accept 1 as extra OK code
* l3-ha: Send gratuitous ARP when new floating IP is added
* Make OVO exception NeutronDbObjectDuplicateEntry retriable
* Move OVO exceptions to neutron/objects/exceptions
* neutron-lib: complete usage of helpers
* Add check to address\_pair that items in list are dict
* Add rally hook to neutron devstack plugin
* Agent to OVO
* Retire deprecations for constants, exceptions, attributes
* Remove second -m protocol from iptables rules
* Truncate IPDevice's name to interface max size
* Change cfg.set\_defaults into cors.set\_defaults
* DHCP: Add missing path for marking ports as ready
* Stop using osprofiler options as if they are part of public API
* Register osprofiler options before setting engine hook
* Don't pass config object to send\_ip\_addr\_adv\_notif()
* Deprecate SR-IOV 'physical\_device\_mappings' config option
* Devref to explain nova-neutron interactions during live-migration
* Remove timeutils.clear\_time\_override in neutron
* Refactor OVSDB native lib to be more customizable
* Deprecate run\_tests.sh
* Removed deprecation warning for waiting\_until\_true
* Removed deprecated tests function
* Removed deprecated function import\_modules\_recursively
* Switch to new hacking 0.12
* Avoid UnboundLocalErrors in \_create\_bulk\_ml2
* Introduce context in methods for Router Extra Attributes OVO usage
* Pecan: Find subresource controllers by parent
* Removed dispose\_pool() from db/api
* Removed deprecation warning for converters and validators
* Removed get\_engine() from db/api
* Removed paginate\_query and sqlalchemyutils module
* Removed deprecated methods for AgentSchedulers
* Removed deprecated checks
* Removed update\_network from plugin.common.utils
* Removed network\_segment functions from ml2.db
* Removed deprecated class LocalVLANMapping
* Deprecate send\_arp\_for\_ha option
* Change IPAM DB API to use context instead of session object
* Add fullstack test for check DSCP marks outbounds
* L3-HA: remove unused deprecated code
* neutron-lib: use replace\_file from neutron lib
* Remove unused configuration variable
* Fix typo in comment
* Migrate to neutron-lib released API definition for trunk APIs
* Updated from global requirements
* Reduce rally executions of create\_and\_list\_ports
* Neutron lib adoption
* Use ensure\_tree from oslo\_utils.fileutils
* Remove last vestiges of oslo-incubator
* Updated from global requirements
* Updated from global requirements
* Pecan: No fields to plugin on GET member actions
* IP Conntrack Manager changes for FWaaS v2
* Only mark ports ready on synced networks
* Fix modify\_fields\_from\_db for vif\_details empty str
* Forbid contract migration scripts for Ocata
* Check if namespace exists before getting devices
* DHCP agent: advertise SLAAC prefixes
* Use new enginefacade for address\_scope\_db
* Replace a test with use of network object
* Add 'to\_primitive' for MACAddress and IPNetwork
* Update Lieutenant table with new entries
* Usage of new enginefacade for flavor db
* Don't depend on translated strings for error check
* Simplify resources module in RPC callbacks
* SR-IOV: Remove deprecated supported\_pci\_vendor\_devs option
* ipv6\_utils: delete get\_ipv6\_addr\_by\_EUI64
* Fix specs broken link
* Make README less verbose and to the point
* Make crystal clear how to contribute/approach the neutron community
* Refactor/prepare db common utils for neutron-lib
* Add OVO for dns Objects
* Fix test\_unwatch\_log() to cleanup after itself
* Updated from global requirements
* TrivialFix: Modify the spelling mistake
* Rename ipv6\_utils.is\_enabled()
* Handle db\_add in transaction for new objects
* [TrivialFix] Replace 'assertTrue(a in b)' with 'assertIn(a, b)'
* Correcting a spelling in README
* Refactoring config options for cache\_utils opts
* Updated from global requirements
* OVO for SegmentHostMapping
* Updated from global requirements
* Pecan: Bulk create with one item returns plural
* Log OVS IDL library errors to neutron logs
* Replace retrying with tenacity
* Removes the superfluous 'that'
* Add functional tests for OVSDB Connection
* Removed unnecessary file(openstack/common) in run\_stack.sh
* objects: add validate\_filters option for count() method
* ovsfw: Add a dl\_type match for action=ct flows
* Update metadata proxy when subnet add/delete
* OVO for Router Extra Attributes
* Validate type of allowed\_address\_pairs
* Pecan: Fix internal server error on QoS rule PUT
* Pecan: Don't prefetch resource fields on DELETE
* Generate OVSDB schema helper in a separate method
* objects: Remove tenant\_id from to\_dict() when project\_id is not set
* Updated from global requirements
* Cleanup coverage configuration
* Fix spelling errors
* Make ovs functional tests mutually isolated
* Pecan: rework notifier hook for registry callbacks
* set\_db\_attribute differs between vsctl and native
* Only send string values to OVSDB other\_config column
* test\_routers\_flavors: Skip if requirements are not met
* Add http\_proxy\_to\_wsgi to api-paste
* Only emit deprecation warning when deprecated value read
* Swap the order of arguments to \_check\_equal
* Cleanup of SecurityGroup classes
* Remove deprecation warnings for agents\_db
* Have RouterRoute object increment Router revision
* Allow to override Idl class in OVSDB Connection
* Drop MANIFEST.in - it's not needed by pbr
* Updated from global requirements
* fullstack: Add security group tests
* neutron-lib: use dict methods from helpers
* neutron-lib: use get\_hostname
* neutron-lib: use cpu\_count
* Make the HA router state change notification more faster
* Pecan: add http\_proxy\_to\_wsgi middleware
* Use BaseDbObjectTestCase in AddressScope UT
* Devref: fix repeated 'testing documentation' text
* Removes remaining Hyper-V plugin
* Added trailing slash in link to Networking API v2.0
* Add db\_add to OVSDB API
* Extend project\_id in object dicts (Newton only)
* Integrate SubnetRoute OVO
* Fix callers of \_make\_port\_dict()
* objects: Removed project\_id/tenant\_id field translation
* Remove deprecation warnings for l3\_hamode\_db
* Fix IPv6 PD with pluggable IPAM
* OVO for Router Route
* Improved readibility and fixed indentation
* neutron-lib: start using neutron-lib helpers
* Cleanup Newton Release Notes
* Fix periodic jobs: Add databases to bindep.txt
* Relocate DNS db models
* Updated from global requirements
* ovsfw: Fix warning message when fetching port's other\_config
* Relocate Agent DB model
* Add api test for create update network and port with dns
* Refactor code to deprecate get\_interface\_mac
* Objects: Add README for neutron/objects directory tree
* Add sample\_default for state change server config
* Ignore gre0 and gretap0 devices in netns cleanup script
* Get rid of double-join to rbac\_entries without filter
* Deterministic ordering of fixed\_ips
* Account for Py2/Py3 differences in fcntl.ioctl return value
* Enable release notes translation
* Handle label\_id's DBReferenceError when creating label-rule
* Add required extension to trunk\_details descriptor
* Relocate Segment DB Models
* Make Jakub Libosvar contact for ovs-fw tag
* Relocate Flavor and ServiceProfile DB models
* Fix typo in comment
* L3 DVR: always notify on ROUTER\_INTERFACE AFTER\_CREATE
* Fix \_list\_availability\_zones for PostgreSQL
* Relocate dvr model
* Fix the 'port\_id' attribute not exist error
* Relocate L3HARouter DB model
* Replace create\_test\_network with network object
* Relocate Tag DB model
* DVR: remove misleading error log
* Enable OVSDB Connection unit tests for py3
* Handle uuid references within an ovsdb transaction
* Remove deprecation warning for l3\_agent\_scheduler
* Expose OVS bridge related options into metering agent config file
* Refactoring config options for ml2 plugin drivers
* Remove recursion from import\_modules\_recursively
* Refactoring config options for l3 ha agent opts
* Relocate SegmentHostMapping DB model
* Relocate Router Extra Attributes DB Model
* Remove old oslo.messaging transport aliases
* Relocate router route DB model
* Disallow specifying too long name for meter-label
* Fix misleading error trace in trunk fullstack life cycle test
* Relocate Geneve DB models
* TestSanityCheck: drop test tables during cleanup
* Removed is\_deadlock from db/api
* Relocate external network db models
* fullstack: VLAN aware VMs test
* Introduce ovo objects for networks
* Schedulers: use consistent plugin, context args
* Fixed functional iptables firewall tests for newer kernels
* Relocate ProviderResourceAssociation DB models
* Introduce ovo objects for ports
* Relocate VlanAllocation DB model
* Ignore NULL fixed\_ips for duplicate floating\_ip check
* Relocate Metering DB models
* Relocate RouterL3AgentBinding DB model
* Updated from global requirements
* Relocate L3 DB Models
* Relocate Provisioning Block DB Model
* Process OVS trunk bridges associated to VM deletes
* Fix typo overriden => overridden
* iptables: fail to start ovs/linuxbridge agents on missing sysctl knobs
* Refetch subnet/network from DB in ML2 update ops
* Send a callback before attaching a subnet to a router
* Don't try to delete non-existent namespace
* Added bindep.txt to the project
* Don't swallow ImportError from load\_class\_by\_alias\_or\_classname
* Remove requests-mock from test-requirements
* Correct fix for IPv6 auto address interfaces
* Darek (@dasm) is our new release liaison for Ocata
* Make HenryG the Magnificent responsible for 'oslo' LP tag
* Add missing revision number altercations
* Fixes for missing IPs on subnets in DHCP agent
* Retry port update on IpAddressAllocationNotFound
* New option for num\_threads for state change server
* Handle add/remove subports events loss due to agent failures
* Fullstack: Add helper FakeFullstackMachinesList
* trunk: Log RPC communication
* tests: Move testtools to 3rd party libraries section
* Fix pep8 E501 line too long
* Fix dhcp\_release6 error when not supported
* XenAPI: add support for conntrack with XenServer
* Fix ML2 revision\_number handling in port updates
* Fix ML2 test extension driver API test cases
* Relocate PortBindingPort DB Model
* Relocate VxlanAllocation/VxlanEndpoints DB model
* Support new osprofiler API
* Include entity in provisioning block logs
* API tests: Check MTU sanity of trunk/subport
* Use assertItemsEqual to compare dicts
* Fix wrong use of six.moves.queue.get()
* Allow more time for DB migration tests
* Update trunk metadata during wire/unwire operations
* Ensure trunk status is acknowledged during OVS subport operations
* Clean-up Tempest test networks with project\_id
* Add MAC address to subports in trunk\_details
* Updated from global requirements
* Install dibbler.filters rootwrap file
* tests: catch eventlet.Timeout exception
* Add basic status transition trunk scenario test
* Remove deprecated class NeutronController
* Fix typos in test\_ipam\_pluggable\_backend.py & base.py
* Do not retry default security group creation
* Fix a release note typo for implicit provider loading deprecation
* Revert "Do not retry default security group creation"
* Try to reuse existing IPs when a port update specifies subnet
* Make DHCP agent use 'revision\_number'
* Stop oslo\_messaging from error logging CallbackNotFound
* Don't immediately restart in DHCP agent on port change
* Always cleanup stale devices on DHCP setup failure
* Reduce log level for extensions not being supported
* Add admin api tests for project-id
* Do not retry default security group creation
* Increase subnet count for rally test
* Lower concurrency on rally port job
* Add to rally quotas to handle worst case quota race
* Fix linuxbridge trunk subport RPC event handler
* OVS agent: configure both OF10 and OF13
* Improve tunnel\_sync
* Disable DHCP on agent port removal
* Garbage collect HasStandardAttributes subclasses in StandardAttrTestCase
* fullstack: execute qos tests for all ovsdb/of interface permutations
* Change the prefix for trunk subports device\_owner
* Fix devref typo
* Keepalived global\_defs configuration entries required to avoid DNS lookup
* DHCP: enhance DHCP release log
* Make neutron-db-manage ready for ocata development
* Update reno for stable/newton
* Fix useless use of \_nxm variant in an OVS field name

9.0.0.0rc1
----------

* Added missing translation marker for an error
* Add metadata proxy router\_update callback handler
* Fix events misnomer in callback registry debug trace
* Fix metering-agent iptables restore failure
* Add fullstack test with OVS arp\_responder
* Don't raise RetryRequest for port in delete\_subnet
* Retry setting mac address on new OVS port 10 times
* Forbid importing neutron.tests.\* from outside tests subtree
* Raise level of message to info
* ovs agent, native ARP response: set Eth src/dst
* Remove unused phys\_net parameter form EmbSwitch class
* Expire DB objects in ML2 infinity loops
* Stop olso\_messaging from error logging CallbackNotFound
* Add API test to ensure IPs can be added by subnet
* Revert "Don't allocate IP on port update when existing subnet specified"
* Add common way to extend standard attribute models
* Fix migration of legacy router to DVR
* Catch DBReferenceError in IPAM and convert to SubnetNotFound
* Don't warn in VLAN Plumber on tagless children
* Skip warnings during DHCP port actions if no error is raised
* Include timezone in timestamp fields
* LinuxBridge: Use ifindex for logical 'timestamp'
* Correct floating IP extra attributes updating issues
* Refactor for floating IP updating checks
* Prevent use filter(lambda obj: test(obj), data)
* Catch RPC errors in trunk skeleton
* Make DHCP notifier use core resource events
* Disable DHCP on test\_create\_port\_when\_quotas\_is\_full
* Capture SubnetNotFound from update\_port call
* Add retry decorator to provisioning blocks module
* Tag the alembic migration revisions for Newton
* Utilize retry\_if\_session\_inactive in dvr\_mac\_db
* Handle racey teardowns in DHCP agent
* Demote error trace to debug level for auto allocation operations
* Fix TypeError in sanity check logging format
* Don't allocate IP on port update when existing subnet specified
* Prevent duplicate LLA iptables rules
* Remove erroneous newton milestone tag
* Preventing iptables rule to be thrashed
* tests: Don't raise TimeoutError when waiting for ping
* Mark quota operations as retriable
* Pass not IPDevice but port\_name into OVSBridge's add\_port()
* devstack: the last fix of is\_kernel\_supported\_for\_ovs25 condition
* Ensure there are fdb\_entries before iterating
* Fix Rollback port's device\_owner
* Protect security group operations with the retry decorator
* Don't work with native DB port objects in DVR code
* of\_interface: Use vlan\_tci instead of vlan\_vid
* Set device\_owner for trunk subports
* Only do deferred ip allocation on deferred ports
* Accept and return project\_id for API calls
* trunk: Remove ovs constants from trunk utils module
* Skip can\_be\_trunked validation for subports
* ovsdb-handler: Follow up patch
* Make l2/l3 operations retriable at plugin level
* Reduce log level for ryu in OVS agent log
* Use ConfigParser instead of SafeConfigParser
* Replace assertEqual(None, \*) with assertIsNone
* Emit router payload only during failures
* tests: don't override base object test class attributes
* objects: expose database model for NeutronDbObject instances
* Defer setting 'ha'/'distributed' flags in L3 code
* Updated from global requirements
* Add sg\_id in the AFTER\_DELETE event of sg\_rule delete
* Fix sudo errors in test\_\_set\_trunk\_metadata\_with\_None\_params
* Add release note for blueprint vlan-aware-vms
* Make optional the validation of filters
* Mark unaddressed ports with none in ip\_allocation field
* Fix misnomer in \_set\_trunk\_metadata
* stadium: remove neutron-release from release job for stadium projects
* LinuxBridge: Pass host into get\_devices\_details\_list
* Downgrade binding skip in mech\_agent
* Use singleton for Nova notifier
* trunk: Handle subports notification in ovs agent side
* objects: don't call DeclarativeObject's \_\_init\_\_ twice for rbac objects
* Move retry decorator in auto allocate
* Add retry decorator to RBAC module
* Mark agents db mixin operations retriable
* Add sanity pings to restart tests to ensure connection
* Implementation of vlan-aware-vms for Linux Bridge
* Add Trunk Plumber module for Linux Bridge
* Move 'get\_tap\_device\_name' to utils module
* devstack: finally fix the is\_kernel\_supported\_for\_ovs25 condition
* tests: remove self.db\_obj from objects tests
* devref: cleaning up release guidelines for stadium subprojects
* Add missing index on inserted\_primary\_key in migration
* l2pop fdb flows for HA router ports
* OVSDBHandler for trunk ports
* Prepare retry decorator to move to plugin level
* devstack: fix kernel version matching to detect ovs compilation support
* Neutron versions api now has its own middleware pipeline
* Use correct exception in L3 driver controller
* pylint: remove 'openstack' from ignore list
* Fix SR-IOV qos extension calls to clear\_rate functions
* Don't use nested transaction in provisioning blocks
* Rollback port after failed to add it to router
* Quotas: add in missing translation
* Ensure UnknownProvisioningError can be printed
* DHCP: remove deprecated config dhcp\_lease\_time
* Standardize release note page ordering
* DHCP: device manager: two new methods - plug and unplug
* Detect DBReferenceError when deleting flavor
* Add API test for L3 Flavors
* Reduce the number of debug traces emitted by registry callbacks
* Add a composite unique key to floatingip table in Neutron database
* Don't return ext net DB object in auto allocate
* Be more clear about DOWN\_STATUS for trunk resources
* Include timestamps in trunk API test comparisions
* Except if tracked resource registered as countable
* Convert OVO fields to primitives for to\_dict()
* Add link to review dashboard in the effective guide
* Fix wrong HA router state
* Config: change deprecation for max\_fixed\_ips\_per\_port to Ocata
* Only schedule routers from drivers that need it
* Remove FWaaS policy.json entries
* Update L3 agent extensions devref
* Remove duplicated tool
* Remove availability range code and model
* tests: refactor objects test cases to use db models instead of dicts
* gate\_hook: Compile ovs only with supported kernels
* objects: use correct object class name in NeutronPrimaryKeyMissing
* l3 ha: don't send routers without '\_ha\_interface'
* ovsfw: fix troublesome port\_rule\_masking
* Check MTU sanity of trunk port subports
* QOS-DB: remove deprecation warning
* Skip setup\_port\_filters for skipped\_devices
* Disallow specifying too long description for meter-label
* Use bridge\_lib's FdbInterface calls instead of execute util
* Expose revision\_number to trunk API
* Change 'revision' to 'revision\_number'
* macvtap: Mech driver detects invalid migration
* Remove workaround for bug/1543094
* Deal with unknown exceptions during auto allocation
* Revisit support for trunk segmentation types
* Set trunk status to DOWN when parent port is unbound
* db migration: Alter column before setting a FK on column
* Switch order for cleanup in NamespaceFixture
* Add binding\_index to RouterL3AgentBinding
* Add timestamp fields for neutron ext resources
* Make L3 agent use different request-id for each request
* Refactor \_ipam\_get\_subnets
* Fix AddrFormatError in DHCPv6 lease release code

9.0.0.0b3
---------

* Add name and desc to networksegments table
* Fix QoS standardattr migration foreign key step
* Ignore extra subnet IPs in DHCP agent
* Truncate microseconds before DB insertion
* Updated from global requirements
* Make milestone-review-dash script pull all Stadium projects
* Adding support of releasing DHCPv6 leases
* qos: require min\_kbps parameter for minimum bandwidth rule
* Mock call to sysctl for test\_get\_free\_namespace\_port
* split out l3-ha specific test from TestMl2PortsV2
* Add L3 agent extension API object
* Switch to neutron-lib for model\_base
* Do not warn under normal network circumstances
* Narrow down DBError to DBReferenceError in DHCP action handler
* Expose timestamp attributes on trunk API
* Remove non-pluggable IPAM implementation
* Expose description attribute on trunk API
* DVR: SNAT redirect rules should be removed only on Gateway clear
* Implement state management for trunks
* debtcollector for globals
* Retain port info from DSCP rule creation
* Use method get\_ipv6\_addr\_by\_EUI64 from oslo.utils
* Use plugin obj from neutron manager in the TestMl2PortsV2 unit test
* Add new configuration test in sanity check: vf\_extended\_management
* IPAM: fix the mode of ipam\_backend\_mixin.py
* Pecan: Handle member actions
* Get rid of flush() in create\_segment()
* Fixes DBDeadlock race condition during driver initialization
* Remove FWaaS entries from neutron setup.cfg
* fix port address allocation for auto-addr subnet
* DVR: Cleanup the stale snat redirect rules in router namespace
* objects: remove support for multiple db models in from\_db\_object
* Check for ha port to become ACTIVE
* Fix ipam\_driver config help
* Auto allocation: ensure that networks and subnets are cleaned up
* Add the l3 agent 'host' when logging routers
* Handle fullstack oslo deprecations
* fullstack: Use ovs-2.5 for tests
* Relocate Flat Allocation DB model
* Relocate subnet\_service\_types db models
* Remove unnecessary setUp and resource\_setup
* Delete unused pom.xml file from doc
* Remove unused config.CONF
* Remove unused logging import
* Add test cases for Invalid exception type
* Allow SR-IOV agent to start when number of vf is 0
* Add standard attributes to qospolicy
* Enable create and delete segments in ML2
* Use MultipleExceptions from neutorn-lib
* Move standard attr out of model\_base
* SR-IOV: add agent QoS driver to support egress minimum bandwidth
* Add QoS minimum bandwidth rule for instance egress traffic
* Remove vpn service plugin stevedore aliases
* Remove lbaas v1 service plugin stevedore aliases
* Generate new context for each DHCP RPC call
* Fix unbalanced-tuple-unpacking pylint error in conn\_testers
* Don't catch DBError in DHCP action handler
* Catch InvalidInput in DHCP port actions
* Wait for ovsdb\_monitor to be active before use it
* Fix deprecation warnings
* spelling error
* Updated from global requirements
* Make addbr safe to bridge add races
* Not check subnet with dhcp disabled when get\_isolated\_subnets
* Add Unit Test for Foreign Keys Not Found Error
* Deprecate allow\_sorting and allow\_pagination options
* functional: Make trunk tests more robust
* Fix passing error physical network for get\_mtu
* Fix indent
* Remove useless line for tenant\_id
* Implement check\_vlan\_transparency to return True in L2population mech driver
* Security group call back need cascading delete the related rules
* Clean import in code
* Set L3 agent standby if admin\_state\_up=False
* Fix internal server error during updating QoS rule
* Make OVS and LinuxBridge trunk drivers' is\_loaded() property more robust
* IP allocation with Service Subnets
* Include [agent] extensions option into ovs/linuxbridge agent files
* Using revision\_number to ensure no overlap in \*one\* network
* Fix the QoSPluginBase methods signature
* Implement check\_vlan\_transparency to return True in SR-IOV mech driver
* TrivialFix: Remove logging import unused
* TrunkManager for the OVS agent
* SR-IOV: remove unused supported\_pci\_vendor\_info variable
* Catch SubnetAllocationError during auto-allocated-topology provisioning
* Revisit the Stadium section of the developer guide
* objects: add support for per parent type foreign keys
* Fix bug in L3 agent extension manager
* Added the appropriate links in developer guide
* L3 DVR: use fanout when sending dvr arp table update
* Fix the attribute name: \_flavor\_plugin\_ref
* Use more specific asserts in tests
* Implement the DELETE method for get-me-a-network
* Update README to reflect ML2 Exception in Dir Tree
* Revert "Fix NoSuchOptError on identity config option lookup"
* Use row.uuid as getattr works for inserted row
* fullstack: test for IPv6 north-south traffic
* Add mechanism driver error details to MechanismDriverError
* Make auto allocate cleanup retry
* Updated from global requirements
* Increase default packet count to 3 in assert\_ping
* L2 Agent Extensions handle unimplemented methods
* Relocate GRE Db models
* docs: Small Open vSwitch devref tweaks
* Filter out external networks in NetworksSearchCriteriaTest
* Remove useless deprecation warning for tenant\_id
* Fix init method for HasStandardAttributes
* Imported Translations from Zanata
* TrunkStub.trunk\_deleted is called with NULL trunk object
* Fix NoSuchOptError on identity config option lookup
* Fix bridge assertion error when times are equal
* Avoid KeyError when accessing "dns\_name" as it may not exist
* Add tool to list moved globals
* Introduce ovo objects for network segments
* Add agent-side driver scaffolding for trunk functionality
* Revert "Publish segment id in port responses"
* Increase rally network/port count and add quotas
* Extensions: fix file mode permissions
* Update the homepage with developer documentation page
* ML2: Lower log level of "Host filtering is disabled" message
* Don't create another plugin instance in ML2 tests
* Relocate AddressScope DB model
* Enable ra on gateway when add gateway to HA router
* Remove override of \_compare\_server\_default in \_TestModelsMigrations
* Make callback manager Object Oriented friendly
* Switch to pluggable IPAM implementation
* Update "devref/quality\_of\_service" with QoS DSCP rule reference
* Removing unused file neutron/agent/l3/config
* Use only\_contrib option for nova\_client calls
* Adjust spacing in METADATA\_PROXY\_HANDLER\_OPTS
* Refactoring config options for plugin agent opts
* Reduce DB hit when checking for trunk-able ports
* Add API test for tag
* Added tests for checking expand/contract branch upgrade
* Don't pass argument sqlite\_db in method set\_defaults
* SR-IOV: deprecate supported\_pci\_vendor\_devs
* Add error informations for users when value is invalid in database
* Implement L3 Agent Extension Manager
* Correct floating IP updating with same port\_id issue
* Fixed neutron-db-manage without neutron/tests installed
* Clean imports in code
* Prevent duplicate SG rules in 'concurrent requests' case
* Relax bound constraint for trunk parent ports
* Fix potential problem in test\_router\_add\_interface\_port
* Fix test\_router\_add\_interface\_delete\_port\_after\_failure
* Remove stale configuration l3\_agent\_manager
* Add RPC layer for Trunk Plugin and driver plumbing
* Make auto-allocate plugin handle sneaky DB errors
* Broken extensions should not show up in the extension list
* Introduce ovo objects for security groups
* Add debug option to verify iptables rules
* Avoid IPAM driver reusing a session that has been rolled back
* Fix neutron\_lib.constants DeprecationWarning from db.models\_v2
* Use dispose\_pool() from oslo.db
* Get rid of get\_engine() in db/api.py
* models: move AllowedAddressPair model under neutron/db/models
* Refactor setting OSprofiler for db calls
* Raise 501 instead of 500 when updating meter-lebel and rule
* Updated from global requirements
* Constrain remaining tox targets
* Check content type by completely match instead of partial match
* Allow bound ports to be trunked if the driver can support it
* Publish segment id in port responses
* Fix some spelling errors in net\_helpers.py
* Refactoring config options of l3 agent keepalived
* Fix check\_asserttruefalse syntax validator
* Relocate Security Group DB models
* Add floating IP test to ensure backwards compat
* Always start transactions in quota cleanup methods
* Refactoring config options for services opts
* Fix a spelling error
* isolate test\_db\_find\_column\_type\_list
* Include db\_models document to avoid errors
* Adds a default reload callback to ProcessManager
* tests: added missing space in a skip test message
* Set secure fail mode for physical bridges
* Avoid allocating ports from ip\_local\_port\_range
* lb-agent: handle exception when bridge slave already removed
* Ensure ML2's create/update\_port methods not in transaction
* Add flush command to iproute in ip\_lib
* Better utilize the L3 Namespace class
* Fix typo in l3-agent namespace code
* ovs-agent: Seperate VLAN mapping outside of the agent
* Updated from global requirements
* Check the router gateway IPs prefixlen existence
* pep8: fixed F821 violation in a unit test
* Add devref for Relocating DB models
* Handle deleted ports when creating a list of fdb entries
* Remove unused params named "context" in filter\_attributes
* Set bridge\_name in OVS trunk port's vif\_details
* ml2: allow retry on retriabable db error by precommit
* Rollback router intf port update if csnat update fails
* Enable DeprecationWarning in test environments
* Check target\_tenant when create rbac policy
* Delete HA network if last HA router is migrated
* Add linux bridge trunk server side driver
* Enable CRUD for Subnet Service Types
* Make revision bump robust to concurrent removals
* Fix duplicate routerport handling
* Cleanup DB retry logic in ML2
* Refactoring config options for extension opts
* Refactoring security group config options
* Don't use versions in \_DeprecateSubset
* Add RouterPort bindings for all HA ports
* Log full exception before retry in decorator
* L3 agent: check router namespace existence before delete
* Consider baremetal device\_owner as compute for nova notify
* Delete conntrack entry with remote\_ip on the other direction
* Do not remove the HA/legacy router gateway secondary IPs
* DHCP Auto Scheduling for routed provider networks
* Restore old assert\_ping behavior
* DVR: Clean stale snat-ns by checking its existence when agent restarts
* Remove neutron-lib warnings
* Ensure most of ML2's core methods not in transaction
* Add scaffolding for trunk plugin/server-side driver integration
* Remove neutron lib warnings from ipv6\_utils
* Check for l3 agents count before router update
* Updated from global requirements
* Introduce state management for trunk resources
* Refactoring config options for wsgi opts
* Add a space after openvswitch error message
* Remove local subports validator
* objects: introduce count() API to count matching objects
* Rename DB columns: tenant -> project
* Fix for creation of network environment twice
* Use neutron-lib add\_validator for registration
* objects: introduce a util function to handle tenant\_id filter
* tests: check that trunk sub\_ports field is properly populated
* Fix indexerror in delete\_csnat\_port
* Add a unique key to port\_id in routerports table
* Refactoring cfg opts for ml2 plugin linuxbridge
* Port device events for common agent
* Fix module import for ovs\_vsctl\_timeout option
* Change external\_network\_bridge default to ''
* Fix link reference in OVS agent devref
* Support callbacks for L3 plugins without an agent
* Remove deprecated default subnetpools
* Fixes the midonet test\_l3 unit test failures
* fixed a typo in src code
* Suppresses a warning when no agents are configured
* Introduce bulk push to rpc callback mechanism
* Enable sorting and pagination by default
* Added API extensions to detect sorting/pagination features
* stadium: adopt openstack/releases in subproject release process
* L2-Adjacency support
* corrected the link in README.rst
* Neutron-lib: use the L3\_AGENT\* definitions from neutron-lib
* Fix a typo in neutron/services/trunk/rules.py
* Refactoring config options of agent/common/ovs\_lib
* Add a callback registry event for the init process - before spawning
* Refactoring config options for cmd
* Don't use file() to write object hashes
* Fix L3 NAT DB signature mismatch
* Add in missing translations for exceptions
* Fix that api\_workers=0 doesn't spawn any api workers
* Use revision to discard stale DHCP updates
* modify the home-page info with the developer documentation
* Filter HA router without HA port bindings after race conditions
* Fix updating allocation\_pools on subnet update
* trunk: avoid redundant refetch of subports on create
* tests: enable test\_get\_objects\_queries\_constant for trunk ports
* Don't use exponential back-off for report\_state
* bug tag: Add 'api-ref' for API reference
* Add link in README.rst
* Set prefix on floating\_ip\_mangle rules
* Remove 'released-neutronclient' tag from official bug tags
* Increment revision numbers on object changes
* Print out specific filter that failed in object filtering unit test
* objects: loading synthetic fields from defined ORM relationships
* objects: forbid updates for project\_id field for subnets
* tests: stop using ml2 plugin full import paths in tests
* Add API tests for router and DHCP port status
* Skip DHCP provisioning block for network ports
* Wait for vswitchd to add interfaces in native ovsdb
* Add flavor/service provider support to routers
* Add some negative policy router interface tests
* Add notifications for trunk CRUD and standardize payload
* Refactoring config options for common config opts
* Prevent port update from binding a host where IPs won't work
* policies: Add tempest tag for launchpad bugs
* Fix for check\_vlan\_transparency on mech drivers not called
* Refactor DNS integration out of DB core plugin
* Fix typo in method description
* Filter out subnets on different segments for dhcp
* Add information about using file based sqlite for unit tests
* Deprecate implicit loading of service\_providers from neutron\_\*.conf
* Remove deprecated network\_device\_mtu option
* objects: Add update\_fields method in base class
* Remove unused code in neutron/agent/linux/utils.py
* Pass timeout in milliseconds to timer\_wait
* Prohibit deletion of ports currently in use by a trunk
* Mark DBConnectionError as retriable
* Add subresources support for PECAN
* Refactoring config options for l3 agent config
* Improve the segmentation ID validation logic
* Revisit (add|remove)\_subports request body
* objects: Adjust Subnet fields, add tenant\_id and segment\_id
* Use is\_valid\_port from oslo.utils
* Validate device to mac instead of port id to mac
* Updated from global requirements
* Don't interrupt device loop for missing device
* Enable passive deletes on trunk deletion
* Removed smoke tags from \*SearchCriteriaTest test cases
* Calculate MTU on every network fetch instead of on create
* Fix wait\_until\_true condition in dhcp test
* Add callbacks for networks and subnets in ML2
* Check compatibility when auto schedule ha routers
* Remove execute permission which is added by mistake in midonet
* Ensure test\_cleanup\_stale\_devices fails gracefully
* Add new attributes to trunk model
* Generalize agent extension mechanism
* fullstack: Add hybrid plug support
* Use db\_api.retry\_db\_errors in quota engine
* Update ovsdb release notes re: new OVS ports
* objects: better apply filters for objects/db/api/get\_object query
* Use DEVICE\_OWNER\_COMPUTE\_PREFIX from neutron-lib
* Imported Translations from Zanata
* Fix misuse of assertTrue in L3 DVR test case
* Pecan: Define plugin crud methods in base class
* Fix broken URLs in bugs.rst (core-reviewers.html -> neutron-teams.html)
* objects: Convert filters to string for list values
* fullstack: Log testrunner again
* QoSTest: skip if qos extension is not available
* Add support for Python 3.5
* Only ports on routed networks are deferred
* Fill in trunk\_details on port resource
* Fix a pylint error in an L3 agent unit test
* DVR: Fix ItemAllocator class to handle exceptions
* Add RouterPort binding to ha interface creation
* objects: Add RBAC to Subnet OVO
* Improve cleanup logic for trunk tests
* Updated from global requirements
* Add retry decorator to dhcp\_ready\_on\_ports
* delete event payload
* Add function to return all hosts with mapped segments
* Handle non existing network in segment creation

9.0.0.0b2
---------

* Hacking: add unit test for LOG.warn validations
* Allow unique keys to be used with get\_object
* Add object versioning to QoS DSCP
* Replace device owners hard coded strings to neutron\_lib constants
* Add function to remove constraints from database
* Add dhcp to Fdb extension's permitted device owners
* Use context from\_environ to load contexts
* Use from\_dict to load context params
* Add a hacking rule for string interpolation at logging
* Add check that factory started in dispose
* Delete gw port on exceptions
* Avoid duplicate ipset processing for security groups
* DVR: handle floating IP reassociation on the same host
* Refactor usage of dict.values()[0]
* qos basic scenario
* Check for provisioning blocks before updating port up
* Rename dvr portbinding functions
* Emit registry events on subport addition/removal
* Ensure deferred IP fails when host is provided no IP allocated
* Extension to tell when deferred binding is in effect
* Fix typo in message string causing server exception
* Deprecate option min\_l3\_agents\_per\_router
* Address outstanding TODO for callback event
* Allow tox to be run with python 3
* Incorporate tweaks to subport validator
* Allow auto-addressed ips deletion on port update
* Delete default route if no gateway in external net
* Add information about contract creation exceptions in devref
* ML2: don't use IntegrityError for duplicate detection
* Grammar error fixed
* Fixed Typo in contribute.rst
* Refactoring config options for dhcp agent
* Revert "Support unique labels for alembic branches"
* DVR: Ensure that only one fg device can exist at a time in fip ns
* New engine facade from oslo\_db: Step 2
* When deleting floating IP catch PortNotFound
* Notify nova with network-vif-plugged in case of live migration
* Skip TrunksSearchCriteriaTest if the extension is not available
* Don't catch DBDuplicate in default SG creation
* Catch missing binding record in provision handler
* Pull stadium projects from governance.o.o in utility script
* exclusive\_resources: use set remove instead of discard
* Add an independent function to map segment to hosts
* List only admin\_state\_up auto-allocated resources
* Change tunnel MTU calculation to support IPv6
* Fix broken link
* ML2 remove extra checks in ovs\_dvr\_neutron\_agent
* Updated from global requirements
* Fixed typos
* Fixes a link error
* next() is incompatible in test\_network\_ip\_availability.py
* Run 'ip netns list' according to 'AGENT/use\_helper\_for\_ns\_read'
* Remove unused LOG
* Fix order of arguments in assertEqual
* Reuse common code in securitygroups\_rpc module
* Release note: fix a typo in add-time-stamp-fields
* Imported Translations from Zanata
* Update the template for model sync test docs
* Add sorting and pagination tests for trunk resources
* Enable CRUD for trunk ports
* OVS-agent: Switch the default to "native" of\_interface
* Use tempest.lib tenants\_client
* Stable Branch URL Fixed
* Support unique labels for alembic branches
* create\_router: Report the original exception
* ml2: postpone exception logs to when retry mechanism fails to recover
* Fix OVSBridge.set\_protocols arg
* Create segment\_host mapping after new network
* Fix spelling mistakes in the docs
* Adding the appropriate log hints where needed
* Lower ML2 message severity
*   spelling error:   modify assocations -> associations in files as follows:   neutron/agent/l3/link\_local\_allocator.py:38
* Make create\_object\_with\_dependency cleanup
* Restore MySQL and Postgresql functional testing
* functional: Use assertItemsEqual for db\_find outputs
* Adding FDB population agent extension
* pep8: Register checks with their code
* sriov: Fix macvtap vf interface regex pattern
* Mock threading.Thread to prevent daemon creation by unit tests
* Fix some typos
* Register the dict extend function when service plugin starts
* Remove notification for process event
* Add two more callbacks registry events
* Do not depend on Python error strings in parse\_network\_vlan\_range()
* Fix code that's trying to read from a stale DB object
* Remove 'origin/' in OVS\_BRANCH
* Only update SegmentHostMapping for the given host
* Move Nova notification logic out of API controller
* Create segment\_host mapping after new segment
* Skip INVALID and UNASSIGNED ofport in vlan restore
* objects: introduce NetworkPortSecurity object
* objects: Introduce the DNSNameServer OVO in the code
* Implementation details to support trunk ports
* Move wait\_until\_true to neutron.common.utils
* Imported Translations from Zanata
* Agent extension: fix comment
* enable OVSDB native interface by default
* Pecan: Implement pagination
* Not auto schedule router when sync routers from agent
* Updated from global requirements
* Remove the deprecated config "quota\_items"
* Fix simple typos
* Create auto allocated networks in disabled state
* Move DHCP notification logic out of API controller
* Pecan: move fields and filters logic to hooks
* DHCP Agent scheduling with segments
* Fixes port device\_id/device\_owner change in failed operation
* Remove the deprecated config 'router\_id'
* Separate exception class for retriables in callbacks
* Revert "OVS: don't throw KeyError when duplicate VLAN tags exist"
* Updated from global requirements
* Add revision\_number to standard attr for OVO
* Check for RetryRequest in MultipleException types
* Remove IP availability range recalculation logic
* Rename ml2\_dvr\_port\_bindings to make it generic
* Override 'create' for Trunk and SubPort
* Retry DBDuplicate errors in retry decorator
* Complete removing support for unsplit alembic branches
* Revert "move import to top and rename to make more readable"
* Make pep8 job great again
* Disable warnerrors=True in setup.cfg
* Move state reporting initialization to after worker forking
* Do not rewrite original exception for IPAM part 2
* Change addCleanup create\_tenant to delete\_tenant, fix gate
* Obsolete mac\_generation\_retries and deprecate the option
* Remove unnecessary flush for duplicate address detection
* Fix minor spelling error in debug log
* tests: clean up designate client session mock on test exit
* Remove unnecessary import from segment plugin
* OVS: UnboundLocalError on switch timeout fixed
* ovsfw: Fix variable names in UT
* ovs: set device MTU after it's moved into a namespace
* cache\_utils: fixed cache misses for the new (oslo.cache) configuration
* Syntax fix
* ml2 lb: do not program arp responder when unused
* Remove deprecated TODO notes in L2 agent extension manager
* Fix pep8 violations in fullstack qos test
* Don't return marker item when paginating backwards
* Fix release name in deprecating message for agent status checks
* Typo fix
* Fix bug with mac generation
* Mark port as ready after enabling dhcp at agent
* Add exponential gap to retry decorator
* Fix designate dns driver for SSL based endpoints
* Update Neutron documentation with \`project\`
* Provide DB isolation for WalkMigrations tests
* Refactor NetworkDhcpAgentBinding
* Tempest: fix a typo
* qos: support native sorting/pagination for policies and rules
* qos: added api sorting/pagination tests for policies
* Check for alembic Add/DropColumn exceptions in migrations
* objects: switch base plugin class to using subnetpool object
* l3: support native sorting/pagination for routers
* Added sorting/pagination tests for routers
* Added sorting/pagination tests for subnets
* DHCP: delete config option dnsmasq\_dns\_server
* Refactor update\_segment\_host\_mapping\_for\_agent for agentless topology
* OVS agent: remove unused variables
* Updated from global requirements
* Remove the plugin import from auto\_alloc extension
* Use neutron-lib constants
* qos: fix shared filter for policies
* objects: Add filter query hook to NeutronDbObject
* Extend utils create methods to accept check\_allow\_post
* tests: fetch unshared subnetpools only
* Cleanup Liberty to Mitaka upgrade corner cases not necessary anymore
* Fixes variable name confusion
* Use StringField for tenant\_id fields
* Remove useless str()
* Add router precommit events
* Allow self-unsubscribing callbacks
* Add data model for standard attr revision numbers
* DVR: Fix allowed\_address\_pair port binding with delayed fip
* Update networking-ovn project functionality
* Revert "Add index on trunk\_id in the subports model"
* Update Neutron server to use only keystoneauth
* Make segment aware IPAM compatible with ML2
* Fix of ping usage in net\_helpers.async\_ping()
* Remove MAC duplicate detection for generated macs
* Pecan: handle single fields query parameter
* Compute IPAvailabilityRanges in memory during IP allocation
* Clean up subports model
* After a migration clean up the floating ip on the source host
* Check for mysql SAVEPOINT error in retry decorator
* Check for StaleData errors in retry decorator
* Use session delete for IPs to trigger events
* Fix update of shared QoS policy
* Fixed variable shadowing in ipam\_backend\_mixin.py
* Add type information to ObjectNotFound message
* Add README for api-ref
* Use next available address for dhcp ports
* objects: in get\_object(s), filter by fields, not model attributes
* Refactor the rpc callback version discovery mechanism
* Add index on trunk\_id in the subports model
* Support for MultipleExceptions in db\_api decorators
* Convert multiple exception types in the API
* Add sanity check for idempotent id's in tempest tests
* Remove some options from neutron-db-manage
* tests: added sorting/pagination api tests for subnetpools
* Drop neutron/i18n.py in favor of neutron/\_i18n.py
* QoS DSCP fullstack tests
* Hacking: make use of neutron lib
* Return fixed\_ips from port update
* Deprecate the functions map after segment moving out of ml2
* Use callback to update SegmentHostMapping
* Match filter criteria when constructing URI for href based iteration
* Make service plugins' get\_plugin\_type classmethods
* OVS: don't throw KeyError when duplicate VLAN tags exist
* Revert "DVR: Clear SNAT namespace when agent restarts after router move"
* objects: Use common plugin \_model\_query in get\_object
* Tox: Remove neutron/openstack/common from excludes list
* Fix missing availability\_zone in dhcp and l3 conf
* qos: Add API test for shared policy
* Imported Translations from Zanata
* l3\_db: Make gw port in-use check overridable
* Fix server\_default comparison for BigInteger
* Update ml2 delete\_subnet to deallocate via ipam
* Make IPAM segment aware on port update
* Make sure AZAwareWeightScheduler base on weight of agent
* Provide router-id for ROUTER\_INTERFACE/BEFORE\_DELETE event
* L3 DB: only read dns 'dns-integration' once
* Force "out-of-band" controller connection mode
* Devref: Add inline codeblock to upgrade command
* oslo.cache: Remove memory alias for cache
* devref: remove references to oslo incubator
* Revert "Revert "Remove threading before process forking""
* Use IPv[46]\_BITS instead of IPV[46]\_MAX\_PREFIXLEN
* Adding basic connectivity scenario to Neutron
* Switch to oslo.cache
* [TrivialFix] Deprecate unused NeutronController class
* remove unused rpc method get\_active\_networks
* Added API tests for page\_reverse and href next/previous links
* Correct hyperlinks to sub\_projects documentation
* DB base plugin: correct typo id to subnet\_id
* Devstack support for macvtap agent
* Segments: remove log message indicating segments are not supported
* Updated from global requirements
* Move dragonflow to affiliated project list
* Fix getting dhcp agents for multiple networks
* Pass ha\_router\_port flag for \_snat\_router\_interfaces ports
* objects: stop using internal \_context attribute
* Fix get\_free\_namespace\_port to actually avoid used ports

9.0.0.0b1
---------

* DVRHA interfaces should be created in all cases
* Make IPAM segment aware on port create
* Updated from global requirements
* Guard against config\_dirs not defined on ConfigOpts
* Macvtap: Allow noop alias as FW driver
* Generalise the logic of resource auto rescheduling
* objects: support advanced criteria for get\_objects
* Fix wrong description in the class DhcpAgentNotifyAPI docstring
* Follow effective Neutron guidelines
* DB: remove deprecated warnings
* Dont use query if network\_ids is empty
* Fix two spelling mistakes
* ML2: use neutron-lib for PORT\_STATUS\_ACTIVE
* Use IPv6\_LLA\_PREFIX from neutron-lib
* RPC unit tests: remove UUID future warnings
* Use ICMPV6\_TYPE\_\* constants from neutron-lib
* Updated from global requirements
* fullstack: test for IPv6 east-west traffic
* Allow the service plugin to import the extension
* functional: fix OVSFW failure with native OVSDB api
* ovsdb: Don't skip ovsdb test cases in py34 suite
* ovsdb: Don't let block() wait indefinitely
* [qos] section is missing from neutron.conf
* oslo: remove usage of oslo.log verbose option
* Adopt to config\_dir option being a list and not a string
* OVS: compare names when checking devices both added and deleted
* Do not inherit test case classes from regular Neutron classes
* Fix validation of floating-ip association
* tests: guarantee unique networks in get\_list\_of\_random\_networks
* Pecan: bind attribute map to controllers
* Refactor QoS plugin to avoid code duplication
* Avoid shadowing the method's port argument
* OVO for VLAN aware VMs
* tests: cover port with existing sorting/pagination api tests
* Allow min\_l3\_agents\_per\_router to equal one
* How to support trunk ports with Open vSwitch Agent
* Introduce official lib tag for neutron-lib issues
* Pecan: tell the plugin about field selection
* Add segments to hosts mappings
* Remove using PROTO\_NAME\_IPV6\_ICMP\_LEGACY from neutron.common.constants
* Prevent adding duplicated sg rules with diff description
* Updated from global requirements
* Remove remaining BGP code from neutron
* DVR: Pings to floatingip returns with fixed-ip on same network
* Migration for qospolicyrbacs has hardcoded InnoDB
* Remove the inaccurate help message for min\_l3\_agents\_per\_router
* OSProfiler imports break decomposed plugins
* tests: validate sorting and pagination for networks
* Fix unit test for new list of icmpv6 allowed\_types
* Use unittest2 uniformly across Neutron
* Call ext\_manager.delete\_port on port removal
* devref: remove l2 agent extensions steps literal
* Fixed help messages for path\_mtu and global\_physnet\_mtus options
* Trivial fix - NETWORK\_TYPE validate
* Change log level when L3 agent is disabled
* Add quota tests in api tests
* Introducing the Subnet OVO
* unit: fix ValueError on TransactionQueue init with py34
* Add OSprofiler support
* fullstack: test for snat and floatingip
* Integrate the port allowed address pairs VersionedObject in Neutron
* Deprecate advertise\_mtu option
* Pecan: Backwards compatible/cleaner init
* fix wrong default value of qos.notification\_drivers
* Rename \_find\_router\_port\_by\_network\_and\_device\_owner
* DVR: Fix check multiprefix when delete ipv4 router interface
* fullstack: test for east west traffic
* Update unit tests to use correct method being used
* Deprecate neutron-debug
* functional: Fix ovsdb-monitor waiting for first events
* Fix broken URL in Mitaka Neutron release note
* Remove nested transaction from ipam driver
* Allow for excepted operations in migrations
* functional: Run OVSFW tests with ovsdb native interface
* Mock out poller in ovsdb unittests
* DVR: Moving router from dvr\_snat node removes the qrouters
* Pecan: remove deprecation warning
* Update for removing ofagent
* Ensure unit tests don't assume an IP address allocation strategy
* Updated from global requirements
* Segment: remove deprecation warning for converters
* Add negative API tests that try to remove the resources in use
* Respond negatively to tenant detachment of enforced QoS policies
* Removed invalid test due to invalid mocking
* Check if pool update is needed in reference driver
* Remove cliff requirement in test-requirements.txt
* sriov\_nic config options were declared under wrong group
* Make deepcopy of update body in API layer
* Refactoring config options for service
* Pecan: Handle hyphenated collection with shims
* Enforce UUID of port/subnet ID for router interfaces
* Make exception translation common and add to pecan
* Remove unhelpful test of oslo.service ServiceLauncher
* Remove a SGs API test following sync to Tempest
* Avoid testing oslo.service library internals
* Restart dsnmasq on any network subnet change
* Add service-type extension to flavors plugin
* Add method to get service provider names by resources
* Enable flavor plugin as a default service plugin
* Add setting default max\_burst value if not given by user
* Remove the file i18n.py and other related cleanups
* Fix for 'ofport' query retries during neutron agent start
* Segment extension: remove deprecated warnings
* Add provisioning blocks to status ACTIVE transition
* devref: Cleanup OVS vHost User Guide
* Refactoring config options for quota
* Trivial Fixes for 'sub\_project.rst' devref document
* Add retry support to pecan
* Remove openstack-common.conf
* Enable IPAM drivers to allocate from more than one subnet
* Associate subnets to segments through subnet API
* Insert validation with request params for HTTP DELETE
* OVS Mech: Set hybrid plug based on agent config
* Remove deprecated references to attributes
* SR-IOV driver and SimpleAgentMechanismDriverBase
* Delete a magic number of security\_group\_rule quotas test
* Pecan: skip all notifications on failures
* Remove tools/pecan\_server.sh
* DVR: Ensure fpr and rfp devices are configured correctly
* Changing VPNaaS bug contact name
* Check for existence of snat port before deleting it
* Move address scope specific code out of iptables\_manager
* Use correct session in  update\_allocation\_pools
* Revise ICMPV6\_ALLOWED\_TYPES
* Revert "Remove threading before process forking"
* Basic Extension and CRUD for Segments
* Classes lack metaclass decoration
* DVR: Use existing IPDevice to add address on FIP VETH
* Fix SR-IOV binding when two NICs mapped to one physnet
* Add exponential back-off RPC client
* Fix prefix delegation deleting addresses for ports
* Fix the sriov agent config group name
* DVR: Clear SNAT namespace when agent restarts after router move
* Delete post\_test\_hook.generate\_test\_logs
* Add logging for some functional tests
* Fix functional tests logging
* Word about notification\_driver
* New engine facade from oslo\_db: Step 1
* OVS: Add support for IPv6 addresses as tunnel endpoints
* DVR: Fix TypeError in arp update with allowed\_address\_pairs
* Remove threading before process forking
* Add API to retrieve default quotas
* fullstack: Use noop firewall
* Don't load DNS integration in l3\_router\_plugin
* Annotate alembic migration for VLAN trunking
* Fix update target tenant RBAC external path
* Preserve backward compatibility with OVS hybrid plugging
* Avoid eventlet monkey patching for the tempest plugin
* Policies: additional go-to contacts for IPv6 bugs
* Added PecanResourceExtension
* Resigning as "go to contact" for DVR bugs
* Pecan: Fix Shim status codes
* Do not rewrite original exception for IPAM
* update networking-odl lieutenant
* Mock mechanism manager instead of the test driver
* add PROTO\_NUM\_IPV6\_ICMP for \_validate\_port\_range
* Resignation from FwaaS duties
* Remove old fwaas remnants from neutron
* agentnotifiers: retried notifications refactor
* Avoid L3 agent termination without server
* Use paginate\_query from oslo\_db

8.1.0
-----

* Revert "Improve performance of ensure\_namespace"
* IPtables firewall prevent ICMPv6 spoofing
* Replaced this with "get-me-a-network"
* Remove BGP code from neutron
* Add device\_id index to Port
* Revert "Improve performance of ensure\_namespace"
* Updated devref documents for neutron-dynamic-routing
* Data models for vlan-aware-vms
* Pass through setattr to deprecated things
* Use converters and validators from neutron-lib
* Revert "Switch to inheriting hacking checks from neutron-lib"
* DVR: Use IPDevice class consistently
* Use constants from neutron-lib
* Decorate AvailabilityZonePluginBase properly
* Remove functional migration script about external tables
* add networking-fortinet in affiliated projects
* Allow OVSDB Connection to register certain tables
* Switch to inheriting hacking checks from neutron-lib
* Add test that ensures subnet is usable after update
* Use exceptions from neutron-lib
* Revert "ML2: Configure path\_mtu to default to 1500 bytes"
* Imported Translations from Zanata
* Object tests: couple of pep8 and list comparison improvements
* Add a missing address-scope extension check
* policies: changed owner for release-subproject tag to @ihrachyshka
* Address Scope added to OVO
* Tests: correcting typo in get\_random\_cidr
* Updated from global requirements
* Mark remaining negative subnetpool tests with 'negative' tag
* Removed smoke tags from all -api job tests
* Remove two exceptions already in neutron-lib
* Correct the interval between two reports
* Don't log warning for missing resource\_versions
* Imported Translations from Zanata
* tempest: enable hacking rule checks
* Return a 404 on quota delete if entry not found
* Move class properties to instances for dhcp/test\_agent.py
* Updated from global requirements
* LinuxBridge agent's QoS driver bw limit for egress traffic
* Add check that external gw port exist when metering-agent adds a rule
* Port allowed address pairs to OVO
* Neutron objects test: correct the db\_obj to obj\_fields where needed
* Fetch router port subnets in bulk
* QUOTAS: add in missing space to help text
* Revert "Deprecate 'ovs\_use\_veth' and 'veth\_mtu' options"
* DHCP: remove update\_lease\_expiration
* Imported Translations from Zanata
* release note to deprecate prevent\_arp\_spoofing option
* Modify an option for delete-port as recovery
* Don't update DHCP ports in a transaction
* Use switch-case instead of if-then-elif
* Match job name for scenario tests
* Clear DVR MAC on last agent deletion from host
* Move class properties to instances for dhcp tests
* Optimize get\_ports query by filtering on subnet
* Avoid calling \_get\_subnet(s) multiple times in ipam driver
* Be explicit about the APIs tested in the gate
* Move away from invoking api tests explicitly
* Updated from global requirements
* Add an option for WSGI pool size
* Make gate-hook structure more readable and extensible
* Don't disconnect br-int from phys br if connected
* Refactor test\_ipam functional testing module
* Avoid referencing code from master branch
* Support interface drivers that don't support mtu parameter for plug\_new
* Use tempest plugin interface
* Add 169.254.169.254 when enable force\_metadata
* Fix deprecation warning for external\_network\_bridge
* Add ALLOCATING state to routers
* Change wrong word "propogated" to "propagated"
* Delete conntrack entry on the other direction
* Skip l2\_ovs\_agent functional tests
* Added initial release check list
* Skip firewall blink test for ovs-fw
* Fix doc build if git is absent
* Cleanup stale OVS flows for physical bridges
* Updated from global requirements
* Revert "Add 169.254.169.254 when enable force\_metadata"
* Fix broken Tempest conf options in API tests
* Add functional test for device\_exists() with invalid namespace
* Add an option for WSGI pool size
* Add support for building ovs from git sources on stacking
* Make tunnel\_sync logging less verbose
* Notify resource\_versions from agents only when needed
* ADDRESS\_SCOPE\_MARK\_IDS should not be global for L3 agent
* Wrap all update/delete l3\_rpc handlers with retries
* Cleanup override of compare\_type from oslo\_db
* Notify resource\_versions from agents only when needed
* Values for [ml2]/physical\_network\_mtus should not be unique
* Use new DB context when checking if agent is online during rescheduling
* Remove Openflow Agent(OFAgent) mechanism driver
* Add RECLONE support for ovs
* ovsfw: Load vlan tag from other\_config
* ovsfw: Load vlan tag from other\_config
* Reuse to\_utf8() and jsonutils.dump\_as\_bytes()
* Postgresql: add do\_drop arg in alter\_enum function
* Imported Translations from Zanata
* firewall: don't warn about a driver that does not accept bridge
* Add uselist=True to subnet rbac\_entries relationship
* Add 169.254.169.254 when enable force\_metadata
* RPC: remove unused parameter
* Fullstack connectivity: test interface scenario added
* Only load timestamp service plugin in timestamp tests
* Deprecate 'ovs\_use\_veth' and 'veth\_mtu' options
* Get rid of unnecessary \_ha\_routers\_present check
* Clear DVR MAC on last agent deletion from host
* Iptables firewall prevent IP spoofed DHCP requests
* ovo: Introduce standard attributes to objects
* Tempest 11.0.0 is released
* Fix race conditions in IP availability API tests
* Switched from fixtures to mock to mock out starting RPC consumers
* Imported Translations from Zanata
* Imported Translations from Zanata
* Use new DB context when checking if agent is online during rescheduling
* Add quota tests in unit tests
* Refactor IPAM ip allocation method
* Fix zuul\_cloner errors during tox job setup
* When checking if there is a duplicate rule ignore the id field
* Revert "Add instrumentation devref, Part I"
* Return oslo\_config Opts to config generator
* Refactor and fix dummy process fixture
* Switches metering agent to stateless iptables
* Remove obsolete keepalived PID files before start
* Add IPAllocation object to session info to stop GC
* Ensure metadata agent doesn't use SSL for UNIX socket
* Fix Windows IPDevice.device\_has\_ip racefulness
* Switched from fixtures to mock to mock out starting RPC consumers
* Values for [ml2]/physical\_network\_mtus should not be unique
* Fix regexp for ss output
* Integrate the Extra Dhcp Opt VersionedObject in Neutron
* ADDRESS\_SCOPE\_MARK\_IDS should not be global for L3 agent
* Move all link-local cidr constants to a central location
* DVR: Increase the link-local address pair range
* Instantiate Enum() rather than subclassing
* Fix keepalived functional tests
* Always call ipam driver on subnet update
* objects: avoid validation in stringify for custom field types
* Remove unused PolicyFileNotFound exception
* Add custom OVO field type for MAC address
* ovo: Update object with data from db on update()
* Add ALLOCATING state to routers
* Fix race conditions in IP availability API tests
* DVR: Increase the link-local address pair range
* Make auto allocate plugin safe for unit/func tests
* Define context.roles with base class
* Ignore timestamp fields in model update
* standard attributes: expose created\_at/updated\_at on models
* Updated from global requirements
* SG protocol validation to allow numbers or names
* Define localstatedir for ovs compilation
* L3 agent: match format used by iptables
* Partial revert "DVR: Fix issue of SNAT rule for DVR with floating ip"
* Add semaphore to ML2 create\_port db operation
* OVS: Add mac spoofing filtering to flows
* Use right class method in IP availability tests
* Don't drop 'protocol' from client supplied security\_group\_rule dict
* L3 agent: match format used by iptables
* Make L3 HA interface creation concurrency safe
* Updated from global requirements
* ovo: Make return values from objects db api consistent
* ovsfw: Remove vlan tag before injecting packets to port
* Fix invalid mock name in test\_ovs\_neutron\_agent
* lb: interface name hashing for too long vlan interface names
* Imported Translations from Zanata
* QoS DSCP use mod\_flow instead of mod\_flows
* Change get\_root\_helper\_child\_pid to stop when it finds cmd
* API tests: Check extensions with proper functions
* Simplify chained comparison
* Improve handle port\_update and port\_delete events in ovs qos agent
* Cleaned up tox\_install.sh
* devref: Update ovs-firewall
* ovsfw: Remove vlan tag before injecting packets to port
* Updated from global requirements
* Use right class method in IP availability tests
* Fix zuul\_cloner errors during tox job setup
* Increase ports per network and add SLA for rally
* test\_network\_ip\_availability: Skip IPv6 tests when configured so
* Iptables firewall prevent IP spoofed DHCP requests
* objects: SubnetPool, SubnetPoolPrefix
* Don't disconnect br-int from phys br if connected
* De-dup user-defined SG rules before iptables call
* Ensure bridge names are shorter than max device name len
* Retry updating agents table in case of deadlock
* Improve error when exclusive resource allocation fails
* Cleanup stale OVS flows for physical bridges
* Avoids logging error on ML2 OVS agent start
* Allow to use several nics for physnet with SR-IOV
* Log fullstack allocation and release of exclusive resources
* Hacking rule to check i18n usage

8.0.0
-----

* Support Routes==2.3
* Rename first argument to extend\_dict hook correctly
* port security: gracefully handle resources with no bindings
* Switches metering agent to stateless iptables
* Wrap all update/delete l3\_rpc handlers with retries
* Allow to use several nics for physnet with SR-IOV
* Fix error format message
* Ignore exception when deleting linux bridge if doesn't exist
* Refactor and fix dummy process fixture
* Don't delete br-int to br-tun patch on startup
* Constraint requirements using mitaka upper-constraints.txt file
* functional: Update ref used from ovs branch-2.5
* Imported Translations from Zanata
* Don't delete br-int to br-tun patch on startup
* Delete Devref Enable Service for Network IP Availability
* DVR: rebind port if ofport changes
* Support Routes==2.3
* ovs-fw: Mark conntrack entries invalid if no rule is matched
* l3: Send notify on router\_create when ext gw is specified
* l3: Send notify on router\_create when ext gw is specified
* Remove obsolete keepalived PID files before start
* Imported Translations from Zanata
* SG protocol validation to allow numbers or names
* Linux Bridge: Add mac spoofing filtering to ebtables
* Remove redundant FLOATINGIPS declaration
* Retry updating agents table in case of deadlock
* Add fullstack cross-process port/ip address fixtures
* Make L3 HA interface creation concurrency safe
* Imported Translations from Zanata
* Effective Neutron: some notes about deprecation
* test\_network\_ip\_availability: Skip IPv6 tests when configured so
* api tests: Check correct extensions
* DVR: rebind port if ofport changes
* Remove deprecated methods from migration CLI file
* Fix typos in Neutron documentation
* Make network segment table available for standalone plugin

8.0.0.0rc2
----------

* api tests: Check correct extensions
* devref: Remove stale description about network\_ip\_availability
* Imported Translations from Zanata
* Add db migrations test framework with data
* Remove unnecessary executable permissions
* Removes redundant "and", "this" and "the"
* Tweak process to improve handling of RFEs
* port security: gracefully handle resources with no bindings
* Fix setting peer to bridge interfaces
* Add fullstack connectivity test with ovsdb native interface
* firewall: don't warn about a driver that does not accept bridge
* Fix fullstack LB agent not connecting to rabbit
* Ignore exception when deleting linux bridge if doesn't exist
* Fix setting peer to bridge interfaces
* Note fullstack depends on released neutronclient
* Updated from global requirements
* Skip fullstack L3 HA test
* Imported Translations from Zanata
* Clean imports in code
* Add OVS flow tests
* Adopt oslo.log default\_log\_levels
* Common utils: remove deprecated methods
* Fix test failure against latest oslo.\* from master
* Fix reference to uninitialized iptables manager
* AGENTS: remove deprecated methods
* Fix reference to uninitialized iptables manager
* DVR: Fix issue of SNAT rule for DVR with floating ip
* Remove deprecated method from agent utils file
* ovs-fw: Mark conntrack entries invalid if no rule is matched
* Add fullstack logging
* Fix alembic 'No handlers could be found for logger...'
* Move db query to fetch down bindings under try/except
* Close XenAPI sessions in neutron-rootwrap-xen-dom0
* Watch for 'new' events in ovsdb monitor for ofport
* conn\_testers: Bump timeout for ICMPv6 echo tests
* Port Security added to OVO
* Adds Enum fields for different types
* Removes host file contents from DHCP agent logs
* Removing 'force\_gateway\_on\_subnet' option
* Imported Translations from Zanata
* Fix a couple of problems with random hex string generation
* Fix latest doc error
* milestone-review-dash detect current milestone
* Remove deprecated methods from common file
* DB: remove method \_get\_tenant\_id\_for\_create
* use separate device owner for HA router interface
* QOS: Provide get methods for policy & network/port binding
* Fix spelling mistake
* Fixes typo
* Imported Translations from Zanata
* functional: Update ref used from ovs branch-2.5
* neutron-db-manage: revision: fail for --autogenerate and branch
* Enforce alembic branch when creating scripts manually
* Ovs agent can't start on Windows because of validate\_local\_ip
* Fix wrong use of list of dict in \_check\_driver\_to\_bind
* Fixed typos in wsgi.py
* Imported Translations from Zanata
* objects: introduce object for extra dhcp options
* Imported Translations from Zanata
* Ovs agent can't start on Windows because of validate\_local\_ip
* Update reno for stable/mitaka
* Skip fullstack L3 HA test
* objects: minor cleanup in base class
* Close XenAPI sessions in neutron-rootwrap-xen-dom0
* Remove local variable named 'meh'
* Move qos\_dscp migration to the Newton alembic branch
* Add Newton branch to neutron-db-manage
* Accept icmpv6 as protocol of SG rule for backward compatibility
* conn\_testers: Bump timeout for ICMPv6 echo tests
* DSCP QoS rule implementation
* objects: fixed base to\_dict implementation
* Updated from global requirements
* Watch for 'new' events in ovsdb monitor for ofport
* Update devstack plugin for dependent packages
* Move db query to fetch down bindings under try/except
* Accept icmpv6 as protocol of SG rule for backward compatibility
* Outerjoin to networks for port ownership filter
* Imported Translations from Zanata
* Update devstack plugin for dependent packages
* Remove test\_external\_network\_visibility
* Outerjoin to networks for port ownership filter
* Update .gitreview for stable/mitaka

8.0.0.0rc1
----------

* tests: register all objects before validating their hash versions
* Handle synthetic fields in NeutronDbObject
* Prevent all primary keys in Neutron OVOs from being updated
* Add uselist=True to subnet rbac\_entries relationship
* De-dup conntrack deletions before running them
* Imported Translations from Zanata
* Fix auto\_allocated\_topology migration with PostgreSQL
* Removes host file contents from DHCP agent logs
* Fix add\_is\_default\_to\_subnetpool migration
* Add custom SQLAlchemy type for MACAddress
* DVR: Handle unbound allowed\_address\_pair port with FIP
* Improve release notes for dvr fixes
* Use context manager in bind NetworkDhcpAgent
* Add custom SQLAlchemy type for CIDR
* Add custom SQLAlchemy type for IP addresses
* Fixes force to set ondelete=CASCADE in create\_foreign\_keys()
* Fixes "OVS Agent doesn't start on Windows"
* RBAC: Fix port query and deletion for network owner
* DVR: Agent side change for live migration with floatingip
* DVR:Pro-active router creation with live migration
* Return oslo\_config Opts to config generator
* Update testing coverage document
* devref doc config option separation
* Added test cases for DVR L3 schedulers
* Update Neutron with temporary registry pattern from VersionedObjectRegistry
* Reset RNG seed with current time and pid for each test started
* Create a hook in base object to modify the fields before DB operations
* Add API test ensure tenant can't delete other ports
* Add IPAllocation object to session info to stop GC
* SG PRECOMMIT\_CREATE should be triggered only once
* fullstack: use SIGTERM when stopping ovs agents
* Extend dicts with original model in create/update
* Imported Translations from Zanata
* Fix dict.keys() incompatibility in py34 in dhcp test
* Update network object in DHCP agent with router interface changes
* Block delete\_(network|subnet) transactioned calls
* Imported Translations from Zanata
* ADD API tests for network ip availability
* Pecan: Allow unauthenticated version listing
* L3HA: Do not wrap create/delete in transaction
* Add metrics notifier to Pecan
* Fix latest doc errors that crept in
* Add remote vs local FAQ for callbacks
* Revise deputy instructions to include deprecation warnings
* Add deprecation tag
* Remove test\_external\_network\_visibility
* register the config generator default hook with the right name
* Stops update\_network handling updates it shouldn't
* Fix PUT tag failure
* Remove unused pngmath Sphinx extension
* fullstack: increase test timeout
* DHCP: Downgrade 'network has been deleted' logs
* Fix the context passed to get\_subnets in \_validate\_routes
* Add reno for deprecation of max\_fixed\_ips\_per\_port
* ML2: Downgrade 'no bound segment' warning
* Delete 118~ API tests from Neutron
* Using LOG.warning replace LOG.warn
* policies: add an official 'l3-bgp' bug tag
* linuxbridge: added missing space in option help text
* Check tap bridge timestamps to detect local changes
* Remove unused Tempest AdminManager
* Construct exceptions before passing to retryrequest
* Copy tempest.common.tempest\_fixtures in to Neutron
* Queries for DVR-aware floating IP next-hop lookups
* Adds unit tests for external DNS integration
* Fixes external DNS driver failure with Python 3.4
* Updates external DNS service if IP address changes
* Add logging statements to help debug L3 sync
* Only clear dns\_name when user specifies parameter
* Catch DB reference errors in binding DVR ports
* Add BGP Callback and agent RPC notifcation implementations
* Set DEFAULT\_NETWORK\_MTU to 1500 and use it
* Downgrade network not found log in DHCP RPC
* Downgrade "device not found" log message
* Add global\_physnet\_mtu and deprecate segment\_mtu
* Ensures DNS\_DRIVER is loaded before it is checked
* Add Nova notifier hook calls to pecan
* Add fip nat rules even if router disables shared snat
* Add timestamp changed-since for core resources
* Security groups: ensure correct ID is passed to exception
* Pecan routing for agent schedulers
* Use testscenarios for OVS flow tests
* Tag the alembic migration revisions for Mitaka
* Remove unused -constraints tox targets
* constraints: fixed typo in tox\_install.sh
* security-groups: Add ipv6 support to ovs firewall
* Fix tempest lib import in API tests
* Delay description association proxy construction
* Release notes: fix broken release notes
* Fix API test for external subnet visibility
* Release notes: prelude items should not have a - (aka bullet)
* Use floating IP to connect different address scopes
* Add a description field to all standard resources
* Add timestamp for neutron core resources
* Skip racey BGP tests
* Continue the fwaas decoupling and cleanup
* Remove obsolete todo
* Nit: Occurances of OpenStack
* Make all tox targets constrained
* reno: Fix bad yaml in reno that ruins html output
* Mock out database access for QoS policy object interface tests
* Fix branch order when upgrading to alembic milestone
* Fix pecan collection->plugin map for extensions
* Autogenerate macvtap agent config file
* Updates to Bug Deputy section of Bugs DevRef
* hacking: remove oslo.\* import check
* devref: added details on the new l2 agent API mechanism
* Revert "Revert "Functional test for address scope""
* Correct Pecan extensions test

8.0.0.0b3
---------

* Add Queries For BGP Route Lookups
* Fix docs tox target for local runs
* Improve logging for port binding
* Allow auto-allocate's dry-run API call to work for regular users
* Make OVS agent tunnel configuration logging less scary
* make/update\_subnetpool\_dict call \_dict\_extend
* Check if plugin supports starting rpc listeners
* Make run\_ofctl check for socket error
* unbreak unit test caused by c5fa665de3173f3ad82cc3e7624b5968bc52c08d
* Add filter for resource tag
* Add tag mechanism for network resources
* Make API framework more flexible for various extensions
* Moved CORS middleware configuration into oslo-config-generator
* Objects DB api: added composite key to handle multiple primary key
* IP Availability: remove unused imports
* BGP: remove unnecessary configuration setting
* Add support for QoS for LinuxBridge agent
* RPC Callback rolling upgrades reporting, and integration
* Set veth\_mtu default to 9000
* Provide dry-run flag to validate deployment requirements
* Use network RBAC feature for external access
* Deprecate network\_device\_mtu
* Catch DBDuplicateEntry errors in RBAC code
* DVR:Remove unwanted check in \_get\_dvr\_service\_port\_hostid
* Make agent interface plugging utilize network MTU
* Removed static reference to LinuxBridge in logging
* Add API extension for reporting IP availability usage statistics
* Updated from global requirements
* Filter HA routers without HA interface and state
* Translations: use neutron.\_18n instead of neutron.18n
* Collect details on ARP spoof functional failures
* Revert "Functional test for address scope"
* Remove effectively empty directories
* Added agent specific API support to L2 extensions
* Qos policy RBAC DB setup and migration
* macvtap: Macvtap L2 Agent
* ML2: Increase segment\_mtu from 0 to 1500 bytes
* Switch to using in-tree tempest lib
* Catch DBReferenceError in HA router race conditions
* Catch PortNotFound after HA router race condition
* Change the exception type from ValueError to IpamValueInvalid
* Fix test\_get\_device\_id() failure on OSX
* Make \_\_table\_args\_\_ declarative in RBACColumns
* Fix tox -e docs
* Override addOnException to catch exceptions
* BGP Dynamic Routing: introduce BgpDriver
* Update default gateway in the fip namespace after subnet-update
* Update docstring in test/tools.py
* Pecan: filter items need type conversion
* Pecan: use reservations in quota enforcement hook
* Add use\_default\_subnetpool to subnet create requests
* Ensure DVR unit tests use '/tmp' directory
* API test for get-me-network
* ovs-fw: Enhance port ranges with masks
* Fix sanity check --no\* BoolOpts
* Correlate address scope with network
* Fix generate\_records\_for\_existing in migrations
* Revert "tests: Collect info on failure of conn\_tester"
* Updated from global requirements
* Revert the unused code for address scope
* Deprecate 'force\_gateway\_on\_subnet' configuration option
* Fix 'TypeError: format requires a mapping' in OVS agent
* Allow non-admins to define "external" extra-routes
* Don't assume simplejson in pecan exception catch
* IPAM: add missing translation
* Functional test for address scope
* deprecated: Raise message
* Allow address pairs to be cleared with None
* Document the ability to load service plugins at startup
* .testr.conf: revert workaround of testtools bug
* Add fullstack resources for linuxbridge agent
* Pecan: get rid of member action hook
* Pecan: replace dashes with underscores on controller lookup
* Fix for adding gateway with IP outside subnet
* Allow other extensions to extend Securitygroup resources
* Adopt Grafana to plot Neutron Failure Rates
* BGP Dynamic Routing: introduce BgpDrAgent
* Add missing character
* stadium: revise the introduction to the document
* stadium: Add a guideline about contributor overlap
* Security group: use correct logging format
* Update devstack hooks to work with pecan jobs
* Fix typo error for wrong msg format when CallbackFailure
* Stop using non-existent method of Mock
* Fix GROUP BY usage for PostgreSQL in migrations
* Add bug tag for auto allocated topology
* macvtap: ML2 mech driver for macvtap network attachments
* Don't disable Nagle algorithm in HttpProtocol
* Preserve subnet\_create behavior in presence of subnet pools
* Open vSwitch conntrack based firewall driver
* Add VLAN tag info to port before applying SG initial setup
* QOS: get rid of warnings for unit tests
* Remove NEC plugin tables
* DHCP: release DHCP port if not enough memory
* Cleanup unused conf variables
* Make DHCP agent scheduler physical\_network aware
* Deprecate ARP spoofing protection option
* tests: Use constants for icmp and arp in conn\_testers
* Add to the neutron bug deputy directions
* L3 agent: log traceback on floating ip setup failure
* Add the rebinding chance in \_bind\_port\_if\_needed
* Pecan: implement DHCP notifications in NotifierHook
* Pecan: Always associate plugins with resource
* Remove deprecation warnings
* Get rid of UnionModel for RBAC
* Add necessary executable permission
* Updated from global requirements
* Add precommit\_XXX event for security group and rules
* Give the qos extension a friendly name
* tests: Collect info on failure of conn\_tester
* Address masking issue during auto-allocation failure
* Fix typo 'indepedent' in alembic\_migration.rst
* BGP Dynamic Routing: introduce BgpDrScheduler model
* macvtap: Common functions and constants
* Fix typo of dnsmasq
* add arp\_responder flag to linuxbridge agent
* Switch "dsvm-functional:" into same pattern as constraints
* Add BGP Dynamic Routing DB Model and Basic CRUD
* fullstack: Gracefully stop neutron-server process
* Remove VPN installation plumbing
* Remove vpnaas tests from the Neutron API tree
* Make netns\_cleanup to purge resources of selected agent only
* Add extension requirement in port-security api test
* ML2: delete\_port on deadlock during binding
* Start using neutron-lib for shared constants and exceptions
* Remove fwaas tests from the Neutron API tree
* Remove office-hours from Polcies docs index
* Add the ability to load a set of service plugins on startup
* ML2: Configure path\_mtu to default to 1500 bytes
* Support MTU advertisement using IPv6 RAs
* Pecan: wrap PUT response with resource name
* Pecan: Controller and test refactor
* stadium: Add a guideline related to project scope
* stadium: Propose kuryr as an independent project
* stadium: Separate proprietary interface projects
* stadium: Add python-neutron-pd-driver
* stadium: Group lbaas repos together
* Remove PTL office hours
* Bring back dvr routers autoscheduling
* Fix getting agent id in linuxbridge agent
* RPC Callback rolling upgrades logic
* OVO common enum class for IPv6 modes
* Move check\_dvr\_serviceable\_ports\_on\_host() to dvr scheduler
* L3: enable plugin to decide if subnet is mandatory
* Implement 'get-me-a-network' API building block
* Test helpers to facilitate testing BGP dynamic routing
* Fix logging error for Guru Meditation Report
* HA for DVR - Neutron Server side code changes
* IP\_LIB: fix indentations
* idlutils: add in missing translations
* sub\_project\_guidelines: Document the procedure to make a branch EOL
* sub\_project\_guidelines: Remove "add tarball to launchpad" step
* sub\_project\_guidelines: Update after direct-release default
* Only restrict gateway\_ip change for router ports
* Make add\_tap\_interface resillient to removal
* Updated from global requirements
* Remove flavors from the list of extensions provided by core plugin
* Log warning message if get\_subnet\_for\_dvr fails
* devstack: Fix check for blank prefix arg
* ML2: Call \_dict\_extend in create\_(net|port) ops
* Pecan: add tenant\_id to quota resource
* Prevent binding IPv6 addresses to Neutron interfaces
* Moving Common Agent into separate module
* Add hacking check for assertEqual HTTP code
* Pecan: Fix association of plugins with resources
* Add missing periods
* Postpone heavy policy check for ports to later
* LB agent: Downgrade network not available message
* Imported Translations from Zanata
* Call Ryu's clean up function when ovs\_neutron\_agent.main terminates
* Protect 'show' and 'index' with Retry decorator
* Update related router when subnetpool change scope
* Only ensure admin state on ports that exist
* stadium: Update list of Neutron sub-projects
* ML2: Update help text for path\_mtu
* Correct dev documentation for has\_offline\_migrations command
* Reno note regarding OVS DVR agent failure on startup
* Fix regression in routers auto scheduling logic
* Compile OVS for functional tests
* Trigger dhcp port\_update for new auto\_address subnets
* Correction of spelling
* Get tempest via zuul-cloner if needed and it is available
* Fix typo in SecurityGroup HTTP error message
* DHCP: fix regression with DNS nameservers
* Add address scopes support to the L3 agent
* Get rid of marshall\_fdb\_entries
* Correct insufficient name for external process in manager log
* Fix port relationship for DVRPortBinding
* Fix params order in assertEqual
* Address i18n related deprecation warnings
* nova-notifier: Change warning to debug
* Warn about a gotcha in the sub-project process
* ML2: update port's status to DOWN if its binding info has changed
* Fix remove\_router\_from\_l3\_agent for 'dvr' mode agent
* DHCP: add in missing space at the end of the line
* Fix bug when enable configuration named dnsmasq\_base\_log\_dir
* DVR: avoid race on dvr serviceable port deletion
* Remove bindings of DVR routers to L3 agents on compute nodes
* Only prevent l3 port deletion if router exists
* Unmarshall portinfo on update\_fdb\_entries calls
* Remove dead method delete\_dvr\_port\_binding
* SR-IOV: Agent remove listen to network delete event
* Use a thinner try/except in \_build\_cmdline\_callback
* Fail if required extensions are missing
* Add UniqueConstraint in L3HARouterAgentPortBinding
* Delete Tempest fork, import from tempest and tempest\_lib
* Add relationship between port and floating ip
* Update translation setup for neutron subprojects
* Fix required extensions mix-up
* Uniquely identify tunnel interfaces for fullstack tests
* DVR: Remove unwanted call to \_get\_routers while arp update
* lb: ml2-agt: Separate AgentLoop from LinuxBridge specific impl
* item allocator should return same value for same key
* Set default value for dnsmasq\_local\_resolv to False
* Improve autonested\_transaction
* Rename confusing dvr\_deletens\_if\_no\_port
* Bump AgentExtRpcCallback version to 1.1
* Raise RetryRequest on policy parent not found
* create\_object should not add an ID if not present in the DB model
* Add generated port id to port dict
* Updated from global requirements
* Support api\_workers option when using pecan
* Elevate context for router lookups during floating IP association
* Update alembic migration documentation
* Add separate transport for notifications
* Neutron review tool use message instead of topics for bugs
* Increase default IPv6 router advertisement interval
* Remove stale ofport drop-rule upon port-delete
* Updated from global requirements
* l3\_db: Check dns-integration extension
* Add dns\_db to models/head.py
* devref: Fix a typo in i18n.rst
* Replace exit() by sys.exit()
* Add missing index entry for external dns integration
* l2pop rpc: Add a unit test for dualstacked port
* Pecan: remove deprecated warning
* RPC worker support for pecan server
* Don't decide web\_framework before config parse
* Remove unwanted NOTE from dvr\_local\_router
* DVR: Fix Duplicate IPtables rule detected warning message in l3agent
* Make advertisement intervals for radvd configurable
* Fix module's import order
* neutron-db-manage: add has\_offline\_migrations command
* Add popular IP protocols for security group
* Decorate methods in ExtensionDescriptor with abstractmethod
* Updated from global requirements
* Remove obsolete plugin stuff
* External DNS driver reference implementation
* Move helper methods to create resorces to test\_base
* db\_api: handle db objects that don't have 'id' as primary key
* Introduce new queries to return DVR routers for a host
* Refactor remove\_router\_interface() for DVR
* sriov-mech: Introduce a new VIF type for PF vnic type
* Ensure that tunnels are fully reset on ovs restart
* OVS agent should fail if it can't get DVR mac address
* Python3: Fix using dictionary keys() as list
* Add network\_update RPC into SR-IOV agent
* Add L3 Notifications To Enable BGP Dynamic Routing
* Fix check in \_validate\_ip\_address() to fail on OSX
* Remove floatingip address only when the address has been configured
* Use tools\_path/venv environment variables in install\_venv
* fix \_validate\_shared\_update for dvr router ports
* Rename new\_network to new\_network\_id
* DVR: Add action specific functions for arp\_entry\_update
* Fixed qos devstack service name (should be q-qos) for -plus gate hook
* bump the min tox version to 2.3.1
* Updated from global requirements

8.0.0.0b2
---------

* Add more log when dhcp agent sync\_state
* Imported Translations from Zanata
* Fix docstring for check\_dvr\_serviceable\_ports\_on\_host
* Fixes typos Openstack -> OpenStack
* Add tests for RPC methods/classes
* OVS agent set max number of attempts to sync failed devices
* Don't sync all devices when some fail
* Make Neutron attempt to advertise MTUs by default
* Optimize get\_ports\_on\_host\_by\_subnet() dvr rpc handler
* Do not remove router from dvr\_snat agents on dvr port deletion
* Make object creation methods in l3\_hamode\_db atomic
* Remove dead method \_get\_router\_ids
* DVR: Optimize getting arp entry info
* Add support for neutron-full and api jobs using pecan to gate\_hook
* Updated from global requirements
* Move L2populationDbMixin to module-level functions
* Fix L3 HA with IPv6
* Fix the duplicated references
* Add opnfv tag to the list of auto-complete tags
* Refactor router delete processing
* Revert "Change function call order in ovs\_neutron\_agent."
* Remove LinuxBridge manager get\_local\_ip\_device arg
* devref: added more details on rolling upgrade for notifications
* Filter by device\_owner instead of iterating by all subnet ports
* Make security\_groups\_provider\_updated work with Kilo agents
* Introduce new query to return all hosts for DVR router
* fix get\_ha\_sync\_data\_for\_host for non-dvr agent
* dhcp: handle advertise\_mtu=True when plugin does not set mtu values
* Retry port create/update on duplicate db records
* doc: Update Ryu Ishimoto's IRC nick
* Make neutron pecan server an option instead of binary
* DVR: when updating port's fixed\_ips, update arp
* Fix Linux bridge test\_report\_state\_revived failure on OSX
* Prevent PD subnets with incorrect IPv6 modes
* Added Keystone and RequestID headers to CORS middleware
* Unify exceptions for assign router to dvr agent
* Unify using assertIsInstance
* HACKING: update HACKING.rst file to include latest changes
* devstack: use stevedore entry point for flavor service plugin
* Do not prohibit VXLAN over IPv6
* Updated from global requirements
* tests: stop validating neutronclient in neutron-debug tests
* Remove 'validate' key in 'type:dict\_or\_nodata' type
* ML2: verify if required extension drivers are loaded
* Add --dry-run mode to code review abandon tool
* Fix typo in test path in Testing.rst
* Fix floatingip status for an HA router
* Fix URLs for pep8, and unit tests jobs
* Static routes not added to qrouter namespace for DVR
* Pass environment variables of proxy to tox
* Pecan: fix quota management
* Pecan: Fixes and tests for the policy enforcement hook
* gate\_hook: add support for dsvm-plus job type
* Scope get\_tenant\_quotas by tenant\_id
* Add 'ovs' to requirements.txt
* Fix params order in assertEqual
* Use admin context when removing DVR router on vm port deletion
* eliminate retries inside of \_ensure\_default\_security\_group
* Register RA and PD config options in l3-agent
* Provide kwargs for callback abort
* Pecan controller loads service plugins
* Make sure datapath\_type is updated on bridges changed
* Log INFO message when setting admin state up flag to False for OVS port
* Fix regression with unbound ports and l2pop
* L3 agent: paginate sync routers task
* Remove duplicate for check\_ports\_exist\_on\_l3agent
* ML2: Simplified boolean variable check
* Pecan: Streamline request body processing
* make floating IP specification test robust to races
* Fix get\_subnet\_for\_dvr() to return correct gateway mac
* Updated from global requirements
* Ensure agent binding modules are loaded
* portbindings: use constants for extension keys
* Add README with links on how to create release notes
* Ensure that decomposed plugins do not break
* LBaaS tests code removal
* Make neutron-debug command follow cliff command convention
* Rename \_get\_vm\_port\_hostid in dvr to reflect the right functionality
* DVR: Rename dvr\_vmarp\_table\_update
* Remove unnecessary argument in limit manage
* remove openstack-common.conf
* Move notifications before DB retry decorator
* Create a routing table manager
* Fix uuid passing in disable\_isolated\_metadata\_proxy
* Fix incorrect classmethod declaration
* Add unit test cases for linuxbridge agent when prevent\_arp\_spoofing is True
* Adopt oslotest BaseTestCase as a base class for DietTestCase
* Use oslo.utils.reflection extract the class name
* Utils: Add missing translation to exception
* Unify assertEqual for empty usages
* SR-IOV: Fix macvtap assigned vf check when kernel < 3.13
* Delete metadata\_proxy for network if it is not needed
* Remove references to model\_base through models\_v2
* Allow get\_unused\_ip method to skip v6 and fix iter
* Revert "Revert "Revert "Remove TEMPEST\_CONFIG\_DIR in the api tox env"""
* Fix meter label rule creation
* Remove l2pop \_get\_port\_infos method
* Remove L2populationDbMixin parent
* devstack: don't enable qos service with the plugin
* Add test for Neutron object versions
* SR-IOV agent: display loaded extensions
* Imported Translations from Zanata
* Allow tox to pass more arguments to ostestr command
* Add systemd notification after reporting initial state
* Avoid duplicating tenant check when creating resources
* Add extension\_manager and support for extensions in linuxbridge agent
* Fix API tests
* Rule, member updates are missed with enhanced rpc
* radvd prefix configuration for DHCPV6\_Stateful RA
* DVR: Rename dvr\_update\_router\_addvm function
* Support rootwrap sysctl and conntrack commands for non-l3 nodes
* Remove openstack.common.\_i18n from Neutron
* Kilo initial migration
* Check missed ip6tables utility
* Keep py3.X compatibility for urllib
* Updated from global requirements
* Misspelling in message
* Mitigate restriction for fixed ips per dhcp port
* dhcp: Default to using local DNS resolution
* Fixing the deprecated library function
* Remove unused variable use\_call in ovs-agent
* Wrong usage of "an"
* Wrong usage of "a"
* Trival: Remove unused logging import
* Allow to control to use constraint env for functional jobs
* DVR: optimize check\_ports\_exist\_on\_l3\_agent()
* Don't call add\_ha\_port inside a transaction
* Call \_allocate\_vr\_id outside of transaction
* Change log level from error to warning
* Fix Security-rule's port should not set to 0 when Protocol is TCP/UDP
* Add constant to L3 extension for floating ips
* dibbler: fix import order
* Add address scope to floating IPs in RPC response to L3 agent
* Add firewall blink + remote SG functional tests
* Add test cases to testing firewall drivers
* Ignore non rules related qos\_policy changes
* Remove check on dhcp enabled subnets while scheduling dvr
* Run functional gate jobs in a constrained environment
* update docstring for get\_ports\_on\_host\_by\_subnet
* Correct state\_path option's help string
* Updated from global requirements
* Restore \_validate\_subnet/uuid\_list not to break subproject gates
* Delete test\_restart\_l3\_agent\_on\_sighup
* DVR: Remove get\_port call from dvr\_update\_router\_addvm
* DVR:Fix \_notify\_l3\_agent\_new\_port for proper arp update
* Add tests that constrain db query count
* Don't raise if polling manager is running when stopped
* Add abstractmethod to FirewallDriver abstract class
* Add a link of availability zone document into releasenote
* Corrected wrong ethertype exception message
* Misspelling in message
* Use the constant HOST\_ID instead of 'binding:host\_id'
* Force L3 agent to resync router it could not configure
* Provide pointer for ML2 extension manager to effective guide
* Add notes on loading strategies for ORM relationships
* Enable Guru Meditation Reports for other refarch agents
* Updated from global requirements
* Catch known exceptions during deleting last HA router
* Add new troubleshooting bugs tag
* Add to deprecate OFAgent in release note
* Refactor the subnetpools API tests
* Clean up code for bug1511311
* Kill the vrrp orphan process when (re)spawn keepalived
* reject leading '0's in IPv4 addr to avoid ambiguity
* Remove duplicated code in attribute.py
* QOS: add in missing translation
* Separate the command for replace\_port to delete and add
* Fix comparison of Variant and other type in test\_model\_sync
* Add check that list of agents is not empty in \_get\_enabled\_agents
* Remove unused parameter from \_update\_router\_db method
* Use a joined relationship for AZ info on routers
* Cleanup all the release notes
* Improve tox to show coverage report on same window
* Tune \_get\_candidates for faster scheduling in dvr
* Updating devref for networking-onos project
* Use a joined relationship for AZ info on networks
* Correct return values for bridge sysctl calls
* Batch db segment retrieval
* Separate rbac calculation from \_make\_network\_dict
* Add explicit address family to AddressScope
* DVR: handle dvr serviceable port's host change
* Adding a VNIC type for physical functions
* Add functional test for availability\_zone support
* OVS: Reorder table-id constants
* Deprecated tox -downloadcache option removed
* API: \_validate\_ip\_address should not raise an exception
* Removing adv svcs dependencies on neutron
* Return availability\_zone\_hints as list when net-create
* Decompose OFAgent mechanism driver from neutron tree completely
* Ignore possible suffix in iproute commands
* Add option for nova endpoint type
* Force service provider relationships to load
* Add linuxbridge job to the dashboard
* ML2: Add tests to validate quota usage tracking
* Updated from global requirements
* Add explanations and examples to TESTING.rst
* Added CORS support to Neutron
* L3 DB: set get\_assoc\_data to be an internal method
* ovs\_vhostuser: fix vhostuser\_socket\_dir typo
* fix call which is only specific to enhanced\_rpc
* select router with subnet's gateway\_ip for floatingip
* Refactor OVS-agent tunnel config validate
* Make keepalived add\_vip idempotent
* Fix timestamp in RBAC extension
* Document relationship between ways of documenting new stuff
* lb: Correct String formatting to get rid of logged ValueError
* Skip keepalived\_respawns test
* Add release note covering keystoneauth and v3
* Pull project out of request in addition to tenant
* Don't emit confusing error in netns-cleanup
* Add address scope to ports in RPC response to L3 agent
* Updated from global requirements
* Avoid full\_sync in l3\_agent for router updates
* move usage\_audit to cmd/eventlet package
* Use keystoneauth instead of keystoneclient
* Deprecate \_ builtin translation function
* Use \_ from neutron.\_i18n
* Using substitution for Python String
* Tox: Remove fullstack env, keep only dsvm-fullstack
* Fix some inconsistency in docstrings
* Set timetable for removal of oslo.messaging.notify.drivers
* Delete stale neutron-server manual
* Final decomposition of the nuage plugin
* Final decomposition of Brocade vendor code
* Trivial typo fix in LinuxBridge dashboard
* Add a script to create review dashboard for a milestone
* Remove Neutron core static example configuration files - addition
* test\_migrations: Avoid returning a filter object for python3
* Cleanup veth-pairs in default netns for functional tests
* Reuse constants defined in attributes
* Add availability\_zone support for router
* Fix default RBAC policy quota
* Moved fullstack test doc content to TESTING.rst
* Allow multiple imports for both ways of doing i18n
* [policy] Clarify bug deputy does not require core bit
* Run NOT NULL alterations before foreign key adds
* Do not autoreschedule routers if l3 agent is back online
* Add instrumentation devref, Part I
* Updated from global requirements
* Hyper-V: remove driver from the neutron tree
* Fix typo in Docstring
* Remove lbaas cruft from neutron gate\_hook
* Make port binding message on dead agents clear
* Notify about port create/update unconditionally
* HACKING: fix edge case with log hints
* I18n related guideline for subprojects
* Optimize "open" method with context manager
* L3: add missing space to log message
* Revert "Revert "OVS agent reacts to events instead of polling""
* XenAPI: Fix netwrap to support security group
* Move i18n to \_i18n, as per oslo\_i18n guidelines
* Clean up FIP namespace in DVR functional tests
* devref: Rolling upgrade mechanism for rpc-callbacks
* Remove version from setup.cfg
* DVR:don't reschedule the l3 agent running on compute node

8.0.0.0b1
---------

* Add native of\_interface fullstack tests
* Disallow updating SG rule direction in RESOURCE\_ATTRIBUTE\_MAP
* l3\_db: it updates port attribute without L2 plugin
* In port\_dead, handle case when port already deleted
* Change check\_ports\_exist\_on\_l3agent to pass the subnet\_ids
* lb: avoid doing nova VIF work plumbing tap to qbr
* Remove Neutron core static example configuration files
* Update 'Contributing Extensions' devref for Mitaka
* HACKING: align the underline text and header
* Imported Translations from Zanata
* Remove transparent VLAN support from base plugin
* Automatically generate neutron core configuration files
* Support Unicode request\_id on Python 3
* Stop using deprecated timeutils.total\_seconds()
* Correct unwatch\_log to support python <= 2.7.5
* Move a note to bridge\_lib
* Add Guru Meditation Reports support to Neutron services
* Fix alignment in message and remove unused module
* Update toctree of neutron document
* Don't drop ARP table jump during OVS rewiring
* Remove useless lb-agent remove\_empty\_bridges
* Delete HA network when last HA router is deleted
* Change instances of Openstack to OpenStack
* force releasenotes warnings to be treated as errors
* Add availability\_zone support for network
* fix some misspellings
* Freescale ML2 driver code complete decomposition
* Add Incomplete state to list of acceptable states for RFE bugs
* Fix typo for OVSDB
* Clarify how we milestones are assigned
* Support for IPv6 RDNSS Option in Router Advts
* tox: pass TEMPEST\_CONFIG\_DIR envvar into api target environment
* Wait for the watch process in test case
* Add UnionModel support to filter query generator
* Minor doc fix in alembic\_migrations.rst
* Some minor misspellings in comment block
* Optimize router delete execution
* Deprecate l3-agent router\_id option
* Make Neutron resources reference standard attr table
* devref: add upgrade strategy page
* Remove duplicate deprecation messages for quota\_items option
* Log error instead of exception trace
* Refactor OVS-agent init-method
* neutron-db-manage: mark several options as deprecated
* ovs: Make interface name hashing algorithm common and extend it
* Check gateway ip when update subnet
* Use diffs for iptables restore instead of all rules
* IPAM: add in missing exception translations
* Remove BigSwitch plugin and driver
* Add Access Control bug tag
* Add index entry to vhost documentation
* Make fullstack test\_connectivity tests more forgiving
* Fix get\_subnet\_ids\_on\_router in dvr scheduler
* Remove misplaced copyright attribution
* Fix misspelled word in docstring
* neutron-db-manage: expose alembic 'heads' command
* Reorganize and improve l3\_agent functional tests
* Make sure we return unicode strings for process output
* Use compare-and-swap for IpamAvailabilityRange
* Replace neutron-specific LengthStrOpt with StrOpt
* Fix use of fields argument in get\_rbac\_policies
* Updated from global requirements
* Fix dashboard graphite URLs
* Fix Neutron flavor framework
* Keep reading stdout/stderr until after kill
* Updated from global requirements
* Fix the end point test for client
* IPAM: fix 'enable-dhcp' with internal driver
* Update HA router state if agent is not active
* Send 50% less debug information when executing cmd
* Fix alignment in message
* Datapath on L2pop only for agents with tunneling-ip
* Add hosted agents list to dhcp agent scheduler
* Add vhost-user support via ovs capabilities/datapath\_type
* Remove deprecated use\_namespaces option
* Resync L3, DHCP and OVS/LB agents upon revival
* Ensure metadata agent doesn't use SSL for UNIX socket
* Updated from global requirements
* Add networking-infoblox sub-project
* Firewall: fix typo
* Fix the indentation issue
* Elaborate how priorities are assigned to blueprints
* Don't add default route to HA router if there is no gateway ip
* Add a better description for notification\_driver
* Use DEVICE\_OWNER\_\* for 'network:\*' constants
* Add the missing arg of RetryRequest exception in \_lock\_subnetpool
* Update networking-powervm sub-project docs
* Remove unused delete\_dvr\_mac\_address method
* Add fullstack testing doc content
* Fix releasenotes/../unreleased.rst
* Avoid race condition for reserved DHCP ports
* Revert "Move dhcp\_lease\_duration into DHCP agent config options list"
* sub\_projects.rst: Update midonet functionalities
* Switch to using neutron.common.utils:replace\_file()
* Trivial fix in ml2 conf
* Remove the useless l3plugin check in l3\_rpc.py
* Fix some reST field lists in docstrings
* Use DEVICE\_OWNER\_COMPUTE constant everywhere
* Fix broken references in doc
* Skip bindings with agent\_id=None
* Updated from global requirements
* Use admin context when requesting floating ip's router info
* Cleanup dhcp namespace upon dhcp setup
* Use SIGUSR1 to notify l3 agent of changing prefix file
* Last sync from oslo-incubator
* Remove SysV init script for neutron-server
* Refactor test\_server functional tests
* Undeprecate force\_gateway\_on\_subnet option
* Move dhcp\_lease\_duration into DHCP agent config options list
* Add transaction for setting agent\_id in L3HARouterAgentPortBinding
* Check missed IPSet utility using neutron-sanity-check
* Change the repos from stackforge to OpenStack
* Revert "Revert "Remove TEMPEST\_CONFIG\_DIR in the api tox env""
* Require tox >= 2.0
* Use assertFalse(observed) instead of assertEqual(False, observed)
* Fix heading markers for better docment toc view
* Clarify that RFE bug reports should not have an importance set
* Remove TEMPEST\_CONFIG\_DIR in the api tox env
* Revert "Remove TEMPEST\_CONFIG\_DIR in the api tox env"
* Lower l2pop "isn't bound to any segement" log to debug
* DVR: remove redundant check
* Disable IPv6 on bridge devices in LinuxBridgeManager
* More graceful ovs-agent restart
* sriov: add extensions option to configuration file
* Fix dvr\_local\_router.floating\_ip\_added\_dist failure after agent restart
* Don't use duplicate filter names for functional testing
* Replace get\_all\_neutron\_bridges by get\_deletable\_bridges
* Revert "OVS agent reacts to events instead of polling"
* configure\_for\_func\_testing.sh: Fix arguments for get\_packages
* Add call to pluggable IPAM from ml2 delete\_subnet
* Add "unreleased" release notes page
* Final decomposition of opendaylight driver
* Adding security-groups unittests
* Don't snat traffic between fixed IPs behind same router
* Remove MidonetInterfaceDriver
* Update internal snat port prefix for multiple IPv6 subnets
* Use get\_interface\_bridge instead of get\_bridge\_for\_tap\_device
* Move LinuxBridge related features to bridge\_lib
* Reduce duplicated code in test\_linuxbridge\_neutron\_agent
* Document the neutron-release team
* Updated from global requirements
* Trivial fix in l3 agent
* IPAM: make max fixed IP validations DRY
* Fix misuse of log marker functions in neutron
* More instructions for neutron-db-manage revision --autogenerate
* Add in missing spaces at end of line
* Do not use log hints for exceptions
* Fix notification driver package
* Adding a function prefix before parenthesis
* Make command log in neutron utils.execute() a single line
* move import to top and rename to make more readable
* Move update\_fip\_statuses to Router class
* Replace subnetpool config options with admin-only API
* Add new config option for IPv6 Prefix Delegation
* Correction and clarification to subproject stable guidelines
* Make '\*' the default ml2 flat\_networks configuration
* Add PyPI link for networking-calico
* Deprecate new= argument from create\_connection
* OVS agent reacts to events instead of polling
* Remove default=None for configuration bindings
* Log hints should only be used for log messages
* Add reno for release notes management
* Add a note about the Neutron Bugs team in Launchpad
* Update deprecated messages
* Switch to using neutron.common.utils:replace\_file()
* Change function call order in ovs\_neutron\_agent
* Ensure to decode bytes or fail
* Optimize delete\_csnat\_router\_interface\_ports db query
* Make string representation of DictModel generic
* Add IRC part for effective neutron
* PortOpt cleanups
* Fix QoS VALID\_RULE\_TYPES location in devref
* Docs: clarify that AnySubnetRequest is optional
* Update neutron-debug to use stevedore aliases
* Fix incorrect passing port dict in pluggable IPAM
* Per-branch HEAD files for conflict management
* Replace internal oslo\_policy mock with public fixture
* sub\_project\_guidelines.rst: Clarify stable branch creation for subprojects
* Use a more pythonic string construction
* Add ops tag to bugs policy
* IPSet Manager: make code more pythonic
* Imported Translations from Zanata
* Remove deprecated nova\_\* options
* Fixed a bunch of typos throughout Neutron
* Decompose ML2 mechanism driver for Mellanox
* Add text for deprecated parameter
* Clarify with example mentioning gratuitous whitespace changes
* Removes the use of mutables as default args
* Decompose ML2 mechanism driver for OVSvApp
* Fix usage of mutable object as default value
* Make the Neutron Stadium documentation toplevel
* Add notes about stable merge requirements for sub-projects
* Fix incorrect capitilization of PyPI
* Updated from global requirements
* Log end of router updates for PD and delete branches
* Don't update metadata\_proxy if metadata is not enabled
* Imported Translations from Zanata
* DHCP agent: log when reloading allocations for a new VM port
* Update specs backlog directory
* Log the exception in linuxbridge\_neutron\_agent as exception
* Replace utils.exec for IpNeighComm LinuxBridge drv
* Formatting exception messages
* Optimize get\_bridge\_for\_tap\_device
* Optimize interface\_exists\_on\_bridge
* Correct indentation in linuxbridge\_neutron\_agent
* Use oslo\_config new type PortOpt for port options
* Updated from global requirements
* DVR: only notify needed agents on new VM port creation
* Ensure l3 agent receives notification about added router
* Imported Translations from Zanata
* Support migrating of legacy routers to HA and back
* Use string formatting instead of string replace
* Delete fipnamespace when external net removed on DVR
* Better tolerate deleted OVS ports in OVS agent
* Remove GBP as a Neutron sub-project
* get\_device\_by\_ip: don't fail if device was deleted
* Allow to specify branch for creating new migration
* Mark for removal deadcode in neutron.common.utils
* Adds base in-tree functional testing of the dhcp agent (OVS)
* Fix \_restore\_local\_vlan\_map race
* DVR: notify specific agent when deleting floating ip
* Move test\_extend\_port\_dict\_no\_port\_security to where it belongs to
* Fix the latest glitches that broke docs generation
* Add effective note on DB exception to be aware of
* Minor improvement in port\_bound operation
* Introduce an API test for specified floating ip address
* Clarify what gerrit repositories can target neutron-specs
* Fix error code when L3 HA + DVR router is created or updated
* Spawn dedicated rpc workers for state reports queue
* Fix l2pop regression
* Remove deprecated sriov agent\_required option
* Remove deprecated namespace deletion options
* Deepcopy port dict in dhcp rpc handler
* Don't remove ip addresses if not master
* Include alembic versions directory to the package
* Fix formatting of hyperlinks provided in the office-hours doc
* Remove IBM SDN-VE left-overs
* Remove the port-forwarding sub-project from the list
* Set security group provider rule for icmpv6 RA in DVR
* Properly handle segmentation\_id in OVS agent
* ovs: remove several unneeded object attributes from setup\_rpc()
* Set ip\_nonlocal\_bind in namespace if it exists
* Remove SUPPORTED\_AGENT\_TYPES for l2pop
* DVR: Notify specific agent when update floatingip
* Move some projects url from cgit/stackforge to cgit/openstack
* Remove non-existent enable\_tunneling conf from fullstack
* Update notes about the Neutron teams
* Validate ethertype for icmp protocols
* Refactor \_populate\_ports\_for\_subnets for testability
* Split the FIP Namespace delete in L3 agent for DVR
* Add stevedore aliases for interface\_driver configuration
* Register oslo\_service.wsgi options correctly
* ovs\_neutron\_agent: display loaded extensions
* Improvements to the blueprint management process
* Add a note to ban agents from connecting to the DB
* Revert "DVR: Notify specific agent when update floatingip"
* Imported Translations from Zanata
* Fix DVR downgrade exception / error code
* Fix AttributeError on port\_bound for missing ports
* The exception type is wrong and makes the except block not work
* Fix rendering
* DVR: Notify specific agent when update floatingip
* Do not try to delete a veth from a nonexistent namespace
* Do not accept abbreviated CIDRs
* Spelling and grammar corrections
* Cross link sub-project release processes
* Lower the log level for the message about concurrent port delete
* Updated from global requirements
* Update RFE documentation to clarify when the tag is not appropriate
* Cache the ARP entries in L3 Agent for DVR
* Revert "Make OVS interface name hashing algorithm common and extend it"
* Enable specific extra\_dhcp\_opt to be left blank
* Python 3: skip test\_json\_with\_utf8 on Py3
* test\_create\_network\_segment\_allocation\_fails: Assert the status
* The first word of the error message should be capitalized
* Create ipset set\_name\_exists() method
* Add section for code review in effective neutron
* Add -constraints sections for base CI jobs
* Python 3: make post\_test\_hook work with more tox targets
* Remove useless code in L3 HA unit tests
* Move retries out of ML2 plugin
* Include external bridge deprecation warning in string
* Tweak RFE guidelines
* Fix link in devref guide
* Add ml2 extension drivers examples
* Improve performance of ensure\_namespace
* Kill conntrackd state on HA routers FIP disassociation

7.0.0
-----

* Mock oslo policy HTTPCheck instead of urllib
* Avoid DuplicateOptError in functional tests
* Make test\_server work with older versions of oslo.service
* Always send status update for processed floating ips
* Fix inconsistency in DHCPv6 hosts and options generation
* L3 agent: use run\_immediately parameter to sync after start
* test\_db\_base\_plugin\_v2: Skip a few tests on some platforms
* Fix error returned when an HA router is updated to DVR
* Remove disable\_service from DBs configuration
* Replaced deprecated isotime() function
* DVR: notify specific agent when creating floating ip
* Fix the bug of "Spelling error of a word"
* Fix iptables modules references in rule generation
* Remove the embrane plugin
* Fix functional test\_server tests
* Add deadlock warning to 'effective neutron'
* Quick optimization to avoid a query if no ports have fixed ips
* Add OpenFixture and get rid of 'open' mocks
* Use assertTrue(observed) instead of assertEqual(True, observed)
* Imported Translations from Zanata
* QoS SR-IOV: allow to reset vf rate when VF is assigend to VM
* Add track\_quota\_usage conf into neutron.conf
* Only lock in set\_members on mutating operations
* Add pointers to access Neutron test coverage details
* Consume ConfigurableMiddleware from oslo\_middleware
* Remove excessive fallback iptables ACCEPT rules
* Consume sslutils and wsgi modules from oslo.service
* test\_create\_router\_gateway\_fails fixes
* Code refactor for generating integer in testcase
* Effective: avoid mocking open() if you can
* Cleaned up remaining incorrect usage for LOG.exception
* Remove usage of WritableLogger from oslo\_log
* Fixed multiple py34 gate issues
* Removed release\_port\_fixed\_ip dead code
* Validate local\_ip for linuxbridge-agent
* Removed neutronclient option from metadata agent
* Adding headers to the devref docs

7.0.0.0rc2
----------

* DHCP: protect against case when device name is None
* Add testresources used by oslo.db fixture
* Add the functional-py34 and dsvm-functional-py34 targets to tox.ini
* Improvements to the RFE management process
* Mock oslo policy HTTPCheck instead of urllib
* Add py34 tags to the list of official tags
* Updated from global requirements
* Fix rule generation for single and all host rules
* Fix iptables comments for bare jump rules
* Add another patch scoping bullet point to effective\_neutron
* Removed a pile of debtcollector removals from neutron.context
* L3 Agent support for routers with HA and DVR
* Python 3: add classifiers
* Adding Effective tips for plugin development
* Add networking-bgpvpn lieutenants
* Update gate dashboard URLs
* Add some test guidelines to 'effective neutron'
* Fix capitalization nit in patch 230218
* DHCP: protect against case when device name is None
* Execute ipset command using check\_exit\_code
* Add note in database section of 'effective neutron'
* Correct MAC representation to match iptables output
* Add note about negative feedback to 'effective neutron'
* Add a note about agent/server compat to 'effective neutron'
* Add a patch scope section to 'effective neutron'
* Add a logging guideline to 'effective neutron'
* Fix missing parent start() call in RpcWorker
* Remove OneConvergence plugin from the source tree
* Use assertIsNone(observed) instead of assertEqual(None, observed)
* Document self.assertEqual(expected, observed) pattern
* Move gateway processing out of init\_router\_port
* Use assertIn and assertNotIn
* Deprecate max\_fixed\_ips\_per\_port
* Don't register agents for QoS l2pop fullstack test
* The option force\_metadata=True breaks the dhcp agent
* Updated from global requirements
* Do not log an error when deleting a linuxbridge does not exist
* The option force\_metadata=True breaks the dhcp agent
* Decomposition phase2 for MidoNet plugin
* Updated from global requirements
* Changes in Neutron defect management
* Tag the alembic migration revisions for Liberty
* /common/utils.py py34 incompatibility
* Just call set-manager if connecting fails
* Fixes 'ovs-agent cannot start on Windows because root\_helper opt is not found'
* Use format to convert ints to strings
* Fixes 'ovs-agent fails to start on Windows beacause of SIGHUP'
* usage\_audit: Fix usage\_audit to work with ML2
* Pecan: Fix quota enforcement
* metadata: don't crash proxy on non-unicode user data
* Do not log an error when deleting a linuxbridge does not exist
* /common/utils.py py34 incompatibility
* Remove debtcollector.removals tagged ensure\_dir
* Consume service plugins queues in RPC workers
* Imported Translations from Zanata
* Add more commit msg tips to 'effective neutron'
* Remove local variables from IPDevice.exists
* Add availability\_zone support base
* Pecan: Fix quota enforcement
* metadata: don't crash proxy on non-unicode user data
* Add neutron-linuxbridge-cleanup util
* Effective Neutron: add link to low-hanging-fruit bugs
* Effective Neutron: add link to logging guidelines
* Add IPDevice.exists() method
* Simplify L3 HA scheduler tests
* Python 3: fix invalid operation on dict\_items objects
* Use format to convert ints to strings
* Add periodic agents health check
* Imported Translations from Zanata
* Fix db error when running python34 Unit tests
* Remove OpenContrail plugin from the source tree
* Correct cisco\_ml2\_apic\_contracts.router\_id length
* Remove is\_ha property from the router
* Remove log decorator deprecated in Liberty
* Deprecate branchless migration chains from neutron-db-manage
* Support new mitaka directory with revisions
* Fix the bug of "Error spelling of 'accomodate'"
* Just call set-manager if connecting fails
* Check idl.run() return value before blocking
* Use separate queue for agent state reports
* Remove remaining uses of load\_admin\_roles flag in tests
* Make OVS interface name hashing algorithm common and extend it
* Simplify extension processing
* Fix URL target problem
* Add devref for alembic milestone tagging
* Add compatibility with iproute2 >= 4.0
* Tag the alembic migration revisions for Liberty
* api test: Skip address-scope tests when the extension is not enabled
* Check idl.run() return value before blocking
* Check supported subnet CIDR
* Remove zombie pecan hook
* Adding trailing underscores to devref links
* Python 3: use "open" instead of "file"
* Imported Translations from Zanata
* Handle empty bridge case in OVSBridge.get\_ports\_attributes
* Devref for authorization policies enforcement
* Fixing traces of "Replace prt variable by port"
* Kill HEADS file

7.0.0.0rc1
----------

* Don't write DHCP opts for SLAAC entries
* Cleanup of Translations
* Cleanup of Translations
* Move ConfigDict and ConfigFileFixture to neutron.tests.common
* Turn device not found errors in to exceptions
* Fix quota usage tracker for security group rules
* Update default branch in .gitreview to stable/liberty
* SimpleInterfaceMonitor: get rid of self.data\_received flag
* Fixes 'ovs-agent fails to start on Windows beacause of SIGHUP'
* Forbid more than one branch point in alembic dependency chains
* Fix quota usage tracker for security group rules
* Fixes 'ovs-agent cannot start on Windows because root\_helper opt is not found'
* Imported Translations from Zanata
* Fix a few nits with the dashboard pages
* Open Mitaka development
* Fix the broken link in devref docs
* Eliminate autoaddress check for DNS integration
* Only get host data for floating ips on DVR routers
* Add neutron subproject & stable branch gerrit review links
* Link dashboards into generated documentation
* Add neutron/master review link to dashboard/index.html
* Create dashboard page with gate jobs statistics
* ml2: don't consider drivers with no bind\_port for qos supported rule types
* Adds configurable agent type
* Imported Translations from Zanata
* Updated from global requirements
* Relax service module check on service providers
* Get rid of ConfigParser code in ProviderConfiguration
* Rename check pipeline dashboards
* tests: don't validate respawn as part of ovsdb monitor functional test
* ovsdb monitor: get rid of custom \_read\_stdout/\_read\_stderr methods
* Change ignore-errors to ignore\_errors
* Change router unbinding logic to be consistent with data model
* delete\_port: ensure quota usage is marked as dirty
* Fix hostname roaming for ml2 tunnel endpoints
* Execute ipset command using check\_exit\_code
* Refactoring devstack script
* Fix adding tap failure if bridge mapping is not provided
* SubnetPoolsTest: Skip IPv6 tests appropriately
* Remove an invalid comment
* Fixes SNAT port not found for internal port
* Don't write DHCP opts for SLAAC entries
* Simplify join to rbac\_entries for subnets
* Update \_TestModelMigration
* Add --verbose to subset of cmds in neutron-db-manage
* Use pecan controllers for routing
* test\_networks: Stop assuming net-mtu extension
* Imported Translations from Zanata
* Add skeleton to 'Effective Neutron' devref
* Introduce kill\_signal parameter to AsynProcess.stop()
* Remove early yields in \_iter\_hosts in dhcp agent
* Optimize if statement in dvr\_local\_router.py
* Re-adds VIF\_TYPE\_VHOST\_USER to portbindings extension
* Introduce a separate RPC server
* Fix log statement to log correct variable first\_ip
* Remove pecan branch reference from .gitreview file
* ipam: Prevent none from being passed to delete
* Remove restriction of adding constraints to expand
* Delete unused file tests/unit/database\_stubs.py
* No network devices on network attached qos policies
* Revert "Revert "Pecan WSGI: prevent plugins from opening AMQP connections""
* Use tempest-lib's token\_client
* Revert "Pecan WSGI: prevent plugins from opening AMQP connections"
* Add constraint target to tox.ini
* Fix establishing UDP connection
* ovsdb: Fix a few docstring
* Remove requirements.txt for the ofagent mechanism driver
* Always return iterables in L3 get\_candidates
* Remove plural param to QUOTAS.count
* Return version info on version controller
* Log exception.msg before exception.message
* Fix pecan policy enforcement for GET requests
* Add missing resource discriminator in update resp
* Fix missing check for admin/adv\_service
* Clarify and add a TODO in the controller
* Set expected HTTP codes for create and delete
* Add basic bulk support to collection controller
* Prevent full sync in dhcp\_agent when possible
* Remove duplicated API server
* Add QoS fullstack test
* QoS agent extension and driver refactoring
* Add IPv6 Address Resolution protection
* Revert "AsyncProcess: try to kill tender"
* Remove out-of-tree vendor AGENT\_TYPE\_\* constant
* func: Don't use private method of AsyncProcess
* Remove unused ovs\_lib method reset\_bridge
* Fix TypeError caused by delete\_agent\_gateway\_port()
* sub\_project\_guidelines: Add richer documentation
* Fix typo: Large Ops, not Large Opts
* Fix query in get\_l3\_agent\_with\_min\_routers
* Do not specify host for l2population topics
* Add utility function for checking trusted port
* Fix typo in error message in NetcatTester
* docstring fix
* AsyncProcess: try to kill tender
* Enable servicing lbaasV2 vip by DVR
* Switch scheduler drivers to load based schedulers
* Fix BadRequest error on add\_router\_interface for DVR
* Fix missing value types for log message
* Tweak test\_keepalived\_respawns test logic
* Reservations: Don't count usage if resource is unlimited
* Restore reservations in API controller
* ovs: don't use ARP responder for IPv6 addresses
* Install sriov-agent.ini on 'setup.py install'
* Configure gw\_iface for RAs only in Master HA Router
* Remove useless log from periodic\_sync\_routers\_task
* Replace is\_this\_snat\_host validation with internal function
* Revert "Remove address scopes from supported extensions"
* Add l2pop support to full stack tests
* Add tunneling support to full stack tests
* Remove an unused DVR function
* Handle ObjectDeletedError when deleting network ports/subnets
* OVSAgentTestFramework: Remove \_bind\_ports
* Descheduling DVR routers when ports are unbound from VM
* Updated from global requirements
* Reduce the chance of random check/gate test failures
* Allow passing arbitrary ip route parameters to add/delete\_route
* Make ip address optional to add\_route and delete\_route
* Add list routes
* Fix dvr update for subnet attach multi subnets
* Make ip rule comparison more robust
* Remove hack for discovery novaclients extension
* Check ICMP codes in range [0,255]
* Remove address scopes from supported extensions
* Add test to check that correct functions is used in expand/contract
* SR-IOV: devstack support for SR-IOV agent
* Fix test\_external\_tables\_not\_changed
* Delete gateway conntrack state when remove external gateway
* Updated from global requirements
* Add non-model index names to autogen exclude filters
* Implement expand/contract autogenerate extension
* Cleanup the fip agent gateway port delete routines
* Add RPC command and delete if last FIP on Agent
* Delete FIP agent gateway port with external gw port
* Remove ebtables\_driver/manager dead code
* Stop device\_owner from being set to 'network:\*'
* Add oslo rootwrap daemon logging during functional tests
* ovs agent resync may miss port remove event
* tests: disable process monitor before managers
* Retry metadata request on connection refused error
* Add ability to use custom config in DHCP-agent
* Improve DB operations for quota reservation
* Qos SR-IOV: Refactor extension delete to get mac and pci slot
* Adds support to provide the csum option for the OVS tunnels
* Delete the useless variable agent\_host
* Handle process disappearing before we ask for its PPID
* Allow only GET on Root controller
* OVS agent: handle deleted ports on each rpc\_loop iteration
* Final decomposition of Cisco plugin
* Remove Cisco Meta and N1KV monolithic plugins
* Workaround test stream corruption issue
* Fix RBAC filter query for negative case
* Updated from global requirements
* Remove \_extract\_roles method from neutron.policy
* Fixed functional test that validates graceful ovs agent restart
* \_bind\_devices query only existing ports
* Stop logging deadlock tracebacks
* Don't log exceptions in GW update on router create
* Remove an unnecessary extension check for rbac
* OVS agent: flush firewall rules for all deleted ports at once
* Enable most unit tests for py34 job
* Changed filter field to router\_id
* Fix a wrong condition for the \_purge\_metering\_info function
* Don't log deadlock or retry exceptions in L3 DB
* Make sure service providers can be loaded correctly
* sriov: update port state even if ip link fails
* Retain logs for functional test cases

7.0.0.0b3
---------

* Don't setup ARP protection on OVS for network ports
* Don't setup ARP protection on LB for network ports
* Add support for PluginWorker and Process creation notification
* Implement external physical bridge mapping in linuxbridge
* Avoid DB errors when deleting network's ports and subnets
* Better message on allowed address pairs error
* Add info to debug test\_keepalived\_respawns gate failure
* Enable to update external network subnet's gateway-ip
* Make Neutron service flavor save service\_type
* Add tenant\_id to flavor service profiles attributes
* Remove implicit registration of \*-aas service providers
* Rename 'newapi' to 'pecan\_wsgi'
* Catch errors on 'port not found' while deleting subnet
* Process user iptables rules before INVALID
* OVS-agent: Introduce Ryu based OpenFlow implementation
* Deprecate external\_network\_bridge option in L3 agent
* Do not track active reservations
* Deprecate --service option for neutron-db-manage
* Add constraint target to tox.ini
* DHCP agent: allow using gateway IPs instead of uniquely allocated
* Resolve issue where router can't be removed from L3-agent in dvr mode
* OVS agent add functional tests of OVS status
* check\_changed\_vlans doesn't need registered\_ports as param
* [rpc] pull: removed a hack to avoid object backport triggered
* Enable py34 tests for pluggable ipam backend
* test\_migrations: Remove unnecessary midonetclient mocks
* Updated from global requirements
* Fix import path in neutron-sanity-check for ml2\_sriov opts
* Decentralize the managemement of service providers
* Remove requirements.txt for decomposed plugins/drivers
* Linuxbridge-agent: fix bridge deletion
* Correct neutron-ns-metadata-proxy command when watch\_log is False
* Split SR-IOV configuration file into driver and agent pieces
* Python 3: use a hash to sort dictionaries
* Implement TODO for version listing
* Fix hooks for dealing with member actions
* Fixed filters for functional tests
* Fix usage of netaddr '.broadcast'
* Add lieutenants contact for networking-calico
* Adding networking-calico to sub\_projects document
* Fix locale problem in execute()
* Remove duplicated codes in two test cases
* Fixes wrong neutron Hyper-V Agent name in constants
* Updated from global requirements
* Improve python code for missing suggestion
* Fix misnomer on network attribute
* Refactor IpRouteCommand to allow using it without a device
* Revert "Add support for unaddressed port"
* Improve logging upon failure in iptables functional tests
* handle gw\_info outside of the db transaction on router creation
* Remove ml2 resource extension success logging
* Replace "prt" variable by "port"
* Add optional file permission argument to replace\_file()
* Fixed the typo in the doc string of the class SubnetPoolReader
* Add flows to tunnel bridge with proper cookie
* Add lieutenants contact for networking-onos
* Adding networking-onos to sub\_projects document
* Add policy and policy rule belongs check
* Base on SqlTestCase to init db tables correctly
* Stops patching an object method which could be gone at cleanup
* Add enable\_new\_agents to neutron server
* Document prefix delegation testing issues
* Fix Prefix delegation router deletion key error
* Add Geneve type driver support to ML2
* Fix DVR log strings in agent
* devref: Add sub-project release notes
* Process update\_network in the openvswitch agent
* Removing the SDN-VE monolithic plugin
* [neutron-db-manage] Introduce contract and expand commands
* Fix DBDuplicateEntry when creating port with fixed\_ips on PD subnet
* Update template for ModelMigrationSync test
* Fix py34 No sql\_connection parameter is established error
* Switch to using os-testr's copy of subunit2html
* Add a functional test to validate dvr snat namespace
* Add snat ports cache to dvr router
* DHCP agent: add 'bridged' property to interface driver
* SR-IOV: deprecate agent\_required option
* SimpleInterfaceMonitor handle case when ofport is an empty set
* Make delete-vlan-bridge and delete-vlan functions clear
* Run py34 tests with testr
* Use directly neutron.common.constants constants in l3\_dvr\_db
* Make a couple of methods private
* Add IPv6 Prefix Delegation compatibility to ipam\_pluggable\_backend
* Validate router admin\_state\_up on upgrade to distributed
* Fix AttributeError in \_clean\_updated\_sg\_member\_conntrack\_entries()
* PLUMgrid plugin decomposition part II
* Quota enforcement: remove locks on \_dirty\_tenants
* L3 agent changes and reference implementation for IPv6 PD
* Decomposition phase2 of NEC plugin
* Allow py34 to run tests individually
* Add dns\_label processing for Ports
* Remove out-of-tree vendor VIF\_TYPE\_\* constants
* Move in-tree vendor AGENT\_TYPE\_\* constants
* devref: added guidelines on how to maintain sub-projects
* Stop logging STDOUT and STDERR on every shell out
* Defer freeing of conntrack zone ids until allocation fails
* Update the URLs to the Cloud Admin Guide
* Remove redundant logging statements from RootWrapDaemonHelper
* Rationalize neutron logs to help in troubleshooting router issues
* Move db agent schedulers test to a more appropriate place
* OVS agent don't hard code tunnel bridge name
* Make models\_v2 explicitly import rbac\_db\_models
* Make NeutronDbObjectDuplicateEntry exception more verbose
* Add empty policy rule to get\_rule\_type action
* test\_ovs\_neutron\_agent: Fix test\_cleanup\_stale\_flows\_iter\_0
* Support dhcp metadata service for all networks
* Move docstring to FakeMachineBase
* Update rootwrap.conf to add /usr/local/sbin
* Remove the ML2 Nuage driver code
* Template for ModelMigrationTest for external repos
* Only mark metadata packets on internal interfaces
* Python 3: do not do "assertFalse(filter(...))"
* ip\_lib: support creating Linux dummy interface
* Graceful OVS restart for DVR
* DHCP agent: clarify logic of setup\_dhcp\_port
* Add config option to specify ovs datapath
* Python 3: fix test\_ovs\_tunnel
* Python 3: use \_\_code\_\_ instead of func\_code
* IPv6 display suitable message when MTU is invalid on iface
* Update oslo messaging configuration section for fullstack
* Imported Translations from Transifex
* QoS: fix get bandwidth limit rules to filter them per policy
* Neutron RBAC API and network support
* Fixed broken link in neutron-server's documents
* Used namedtuple for ReservationInfo
* Move in-tree vendor VIF\_TYPE\_\* constants
* Remove VIF\_TYPES constant
* Added initial devstack plugin
* Fix qos api-tests after policy changes
* fullstack: use migration scripts to create db schema
* Only validate local\_ip if using tunneling
* qos: Delete bw limit rule when policy is deleted
* Do not query reservations table when counting resources
* Add support for unaddressed port
* Sync FK constraints in db models with migration scripts
* Add EnvironmentDescription, pass it down
* Dropped release name from migration branch labels
* Split DRIVER\_TABLES in external.py
* DVR: make sure snat portion is always scheduled when needed
* neutron-db-manage: sync HEADS file with 'current' output
* Fix \_ensure\_default\_security\_group logic
* Add missing tenant\_id validation in RESOURCE\_ATTRIBUTE\_MAP
* Graceful ovs-agent restart
* l2pop: check port mac in pre-commit to stop change
* Adding Ale Omniswitch to sub\_projects document
* Add high-level functional/integration DVR tests
* Add a fullstack fake VM, basic connectivity test
* Final decomposition of ML2 Cisco UCSM driver
* Fix query in get\_reservations\_for\_resources
* Move tests for non pluggable ipam backend
* fullstack: Skip NotFound in safe\_client cleanup
* Fix tenant access to qos policies
* Rename args for alembic 0.8.0
* Update sub projects git urls
* Stop using quota reservations on base controller
* Final decomposition of ML2 Nexus Driver
* manual add/remove router for dvr\_snat agent
* DVR: fix router rescheduling on agent side
* Python 3: fix test\_utils
* lb: stop handling Havana device updates
* quota: synchronize resync and count with other dirty\_tenants code
* Add logging to debug oslo.messaging failure
* Setup firewall filters only for required ports
* Updated from global requirements
* Quota enforcement: python3 compatibility
* Devref for quotas
* Reservations support
* Fix .gitreview to not point at a branch
* Don't fatal error during initialization for missing service providers
* NSX: Move DB models as part of core vendor decomposition
* doc: Improve table rendering using multi-row cells
* Rename function '\_update\_port\_down'
* Redundant tests removed from ovs-lib unit tests:
* Add network to SubnetContext
* Unskip firewall test
* NSX plugin: Moving away plugin extensions
* Get rid of exception converter in db/api.py
* Python 3: encode or decode i/o data of Popen.communicate()
* Updated from global requirements
* Use a conntrack zone per port in OVS
* Fix some issues around tempest in fullstack testing doc
* Add lieutenants contact for kuryr
* Add dashboard folder and graphite dashboard to doc
* lieutenants: Add Neutron infra lieutenants
* DVR: do not reschedule router for down agents on compute nodes
* Replace internal calls of create\_{network, subnet, port}
* ml2: Remove a redundant assignment in \_bind\_port\_level
* ml2: \_commit\_port\_binding: Don't use None to mean False
* Minor typo fix
* l3: not use L2 plugin \_get\_subnet unnecessarily
* l3\_db: not use L2 plugin \_get\_port unnecessarily
* Break down \_bind\_port\_if\_needed in ML2
* Pecan WSGI: prevent plugins from opening AMQP connections
* Remove 'action' argument from \_handle\_fip\_nat\_rules()
* Remove vmware plugin from neutron (etc part)
* Setup reference service providers for API test runs
* [neutron-db-manage] check\_migration: validate labels
* Python 3: fix neutron.tests.unit.api.test\_extensions
* Add configurable options for HA networks
* Add test that checks external tables are not changed
* [neutron-db-manage] remove old HEAD file when updating for branches
* Remove unneeded shebangs
* Python 3: hmac requires bytes key/msg
* Python 3: encode unicode response bodies
* Support for independent alembic branches in sub-projects
* Remove bigswitch mech\_driver entry point definition
* Updated from global requirements
* Python 3: specify a bytes to an argument for a format type 's' of struct.pack()
* Preserve DVR FIP rule priority over Agent restarts
* Treat sphinx warnings as errors
* Distributed router can not add routes
* Update fullstack multinode simulation image
* Fix docs job
* Improve callback registry devref documentation and usability
* Final decomposition of the ML2 NCS driver
* Fix update\_subnet for prefix delegation
* The unnecessary value "sgids" was deleted
* Fix DVR interface delete by port when gateway is set
* Skip FwaaS test that is failing due to race condition
* Destroy ipset when the corresponding rule is removed
* Python 3: compare response.body to bytes in namespace\_proxy test
* Forbid attaching rules if policy isn't accessible
* DVR: fix router rescheduling on server side
* Fix the low level OVS driver to really do egress
* SR-IOV: Add Agent QoS driver to support bandwidth limit
* Pass the extension driver exception to plugin
* Update documentation acording to last QoS/OvS changes
* OVS agent functional test for policy rule delete
* Add Kuryr to sub\_projects.rst
* Clean up test\_dvr\_router\_rem\_fips\_on\_restarted\_agent
* Fix \_update\_subnet\_allocation\_pools returning empty list
* devref: update quality\_of\_service
* Replace 'import json' with oslo\_serialization
* SR-IOV: Convert max rate from kbps to Mbps
* Add testing coverage .rst, missing test infrastructure to-dos
* Python 3: encode unicode response bodies
* Update port functional tests for qos agent
* Neutron-Ironic integration patch
* DVR: fix router scheduling
* TESTING.rst love
* Removed configuration option for qos agent driver selection
* Add delete\_port api to agent extension manager
* Functional test for QoS policy bandwidth rule update
* Support delegation of bind\_port to networking-odl backend driver
* Use oslo.log library instead of system logging module
* resources\_rpc: fixed singleton behavior for ResourcesPullRpcApi
* Add thread locks on port routines for qos ext
* Avoid dhcp\_release for ipv6 addresses
* SR-IOV: fixed singletion behavior for ESwitchManager
* Validate local\_ip for OVS tunnel
* Imported Translations from Transifex
* db\_base\_plugin\_v2: Avoid creating another session
* Consistent layout and headings for devref
* Use DeferredOVSBridge in setup\_default\_table
* Fix get\_objects to allow filtering
* QoS core extension: fixed dict extension when QoS policy is unset
* OVS agent QoS extension functional test for bandwidth limit rules
* Propagate notifications to agent consumers callbacks
* Add rpc agent api and callbacks to resources\_rpc
* neutron.api.rpc.callbacks interface rework
* Moved l2/agent\_extensions\_manager into l2/extensions/manager.py
* Moved extensions/qos\_agent.py into extensions/qos.py
* Introduce base interface for core resource extensions
* Do not delete fip namespace during l3 dvr agent resync
* Introduce ItemAllocator class
* Validate updated allocation pool before using it
* Remove quotes from subshell call in tools/split.sh
* Don't claim Linux Bridge ml2 driver supports bandwidth limit QoS rules
* Clean up QoS rules first, then QoS policies
* Pass the extension driver exception to plugin
* Remove a few obsolete options from midonet.ini example
* Rename a test method in test\_policy.py
* Revert "Add extension callbacks support for networks"
* Updated quality\_of\_service devref doc to reflect reality
* Broadcast service port's arp in DVR
* usage\_audit: Fix usage\_audit to work with ML2
* Revert "Remove VPN from API tests"
* Enable VPN plugin for API test
* Validate interface\_mappings on Linux bridge init
* Initialize ancillary\_port\_info dict as blank in OVS agent
* Enable fullstack multinode tests, add L3 HA test exemplar
* SR-IOV: Update eswitch manager to support rate
* Follow up with some cleanup for agent qos\_driver
* Gracefully handle duplicate rule creation
* Fix: Skip rescheduling networks if no DHCP agents available
* DB, IPAM & RPC changes for IPv6 Prefix Delegation
* Python 3: convert dict\_keys object to list
* Python 3: do not compare int and NoneType
* Remove VPN from API tests
* Fix typos in neutron code
* "FakeV4Subnet" class be inherited by following class
* Update OVS driver to work with objects
* Python 3: fix test\_ovs\_tunnel
* \_get\_dvr\_sync\_data: Return a list, rather than dict\_values for python3
* Fixing ICMP type and code validation
* Support subnetpool association to an address scope
* Add API tests for non-accessible policies
* Gracefully handle fetching nonexistent rule
* use single transaction to update qos policy associatation
* Replaces reduce with six.moves.reduce for py 2/3 compatibility
* Add oslo db retry decorator to the RPC handlers
* Python 3: Fix test\_security\_groups\_db
* Replace to\_dict() calls with a function decorator
* Add DNS and DHCP log into dhcp agent
* Install arp spoofing protection flow after setting port tag
* Move 1c844d1677f7 expand migration to appropriate branch
* Fix ipset can't be destroyed when last rule is deleted
* Guarantee there is only one bandwidth limit rule per policy
* Cleaned up some TODO comments for feature/qos that do not apply anymore
* L2 agent extension manager: read extensions list from config file
* objects.qos.policy: forbid deletion when attached to a port or a network
* Remove handle\_network/handle\_subnet from l2 agent extensions
* Move away nested transaction from \_ensure\_default\_security\_group
* Moved QOS\_POLICY\_ID into qos\_consts.py
* Introduce get\_ports\_attributes in OVSBridge
* Added missing [qos] section into neutron.conf
* Enable rule delete test
* objects: consolidate single transaction checks into test\_base
* objects.qos.policy: provide rules field, not type specific
* Unite qos\_rules and qos\_\*\_rules tables
* Switch controller to actually call the plugins
* Add extensions listing to the controller
* Add placeholder for notifier hook
* Add hook for policy enforcement
* Add quota enforcement hook
* Add ownership validation hook
* Add attribute population hook
* Add resource/plugin identification hook
* Add hook to create a context from the headers
* Add hook to translate exceptions into HTTP codes
* Add startup hook after pecan init for plugins
* Add keystone middleware wrapper to pecan app
* Fix accessing shared policies, add assoc tests
* qos: forbid creating rules when there is no access to policy
* Initial pecan structure
* Remove unnecessary executable permission
* NSX: Rename default\_interface\_name option
* Arista Drivers decomposition part II
* Python 3: pass bytes to base64.encode{string,bytes}
* Python3: pass bytes to binascii.crc32
* Fix order of calls in update\_port
* Check that VXLAN is not in use in LB VXLAN check
* Initialize port\_info dict as blank in OVS agent
* Ensure non-overlapping cidrs in subnetpools with galera
* SR-IOV: update pci lib to support rate limit
* SR-IOV: Fix SR-IOV agent to run ip link commands as root
* QosPolicy: made shared field required and with default value = False
* Python 3: Use '//' instead of '/'
* Prevent update alloc pool over existing gateway ip
* Moved out cisco n1kv mech driver and db models
* Updated from global requirements

7.0.0.0b2
---------

* sriov: implement spoofchecking configuration
* [qos] ovs: removed TODO for getting integration bridge from arguments
* Fixes a typo phys\_brs in place of phys\_br
* Update dhcp agent cache for network:dhcp ports
* Keep dns nameserver order consistency
* Extend vxlan\_group option to allow a range of group addresses
* Load the QoS notification driver from the configuration file
* Add pluggable backend driver for QoS Service notification
* Enable resource usage tracking for reference plugins
* Add plural names for quota resources
* Introduce usage data tracking for Neutron
* Create packages for quota modules
* Python 3: fix test\_attributes
* Add FUJITSU vendor plugin in sub\_projects
* Python 3: fix test\_dhcp
* test\_db\_base\_plugin\_v2: Improve DBReferenceError generation
* Fix a microsecond format of isoformat()
* Add update tests for policies and rules
* Updated from global requirements
* Python 3: fix test\_context
* Fix KeyError: 'L3\_ROUTER\_NAT' in l3 scheduler functional test
* Introduce mechanism to determine supported qos rule types for a plugin
* Cleanup IPAM tests
* get\_info: request object backport only if desired version is different
* rpc.callbacks.registry: validate that callback provider is registered
* rpc.callbacks.registry: validate type of callback result
* Add UT for agent\_extensions\_manager
* Don't set tenant\_id for rule objects
* Fix dhcp autoschedule test assertion logic
* Fix inconsistency of if/return logic in attributes.py
* Imported Translations from Transifex
* [neutron-db-manage] revision: properly bootstrap a new branch
* Add DB support for resource usage tracking
* QoS: Remove type attribute from QoS rules
* Don't enforce qos ml2 extension driver
* ml2: added qos\_profile\_id to get\_device\_details payload
* Add versioned object serialize/deserialize for resources RPC
* policy: made attach\_\* and detach\_\* methods more robust
* Decompose Apic ML2 mechanism driver
* Remove duplicate DHCP agent registration in unit test
* Python 3: do not index dict\_values objects
* L2 agent RPC add new RPC calls
* Add Cathy Zhang as networking-sfc Lieutenant
* Add error message when migrate from distributed router to centralized
* Avoid printing log options multiple times
* Support qos rules and fields parameters in GET requests
* Pass context when deleting bandwidth limit rule
* Add Pluggable IPAM Backend Part 2
* Create fip on subnet id
* Python 3: fix neutron.tests.unit.agent.dhcp.test\_agent
* Updated from global requirements
* Update port bindings for master router
* [qos] cleanup \_find\_object from neutron.db.api
* Revert "Mute neutron.callbacks notification logs."
* qos: kill get\_namespace() from service plugin
* Base infrastructure for QoS API tests
* Metaplugin removal
* Remove line number of link and useless link
* Disable port creation when invalid MAC address is provided
* Fix handling of port-range-min 0 in secgroup RPC and agent
* Fix a property comment in metadata\_agent files
* Add address scope API tests
* Python 3: enable more tests
* Add new ovs DB API to inquire interfaces name list in a bridge
* Tweak wording for project inclusion process
* Define fullstack router/network/subnet management fixture
* Fix race condition by using lock on enable\_radvd
* Fix note in devref/contribute.rst
* ensure\_dir: move under neutron.common.utils
* Add conntrack-tool to manage security groups
* Adding a cleanup for 'qlbaas-' namespaces in netns\_cleanup
* Bug-Fix for unexpected DHCP agent redundant
* Remove deprecated OVS and LB plugin DB tables
* ovs\_lib: Fix native implementation of db\_list
* Stop use of oslo\_utils.timeutils.strtime()
* Fix gateway port could not retrieve for subnet
* Port help text for dvr\_base\_mac from neutron.conf
* Add documentation for SRIOV NIC agent (previously missing)
* Python 3: fix neutron.tests.unit.agent.linux.test\_async\_process
* Adds garp\_master\_repeat and garp\_master\_refresh to keepalived.conf
* Added functional tests for L3 schedulers
* Always use BridgeDevice to manage linuxbridges
* Update OVS Agent to work with Agent Extension Mgr
* Instantiate qos agent driver
* objects.rule: enable database tests for QosRule
* Handle qos\_policy on network/port create/update
* Updated from global requirements
* Validate that context exists
* neutron-db-manage: fix check\_migration for branch-less migration directories
* Use only the lower 16 bits of iptables mark for marking
* Python 3: fix test\_provider\_configuration
* Add address\_scope\_db to neutron/models/head.py
* OVS agent factor our port stats processing
* Python3: Do not compare NoneType and integers
* Use oslo\_log.helpers.log\_method\_call
* Unplug the VIF if dhcp port is deleted
* Python 3: Wrap map() in a list call
* Devref documentation for client command extension support
* Alter unit test to match bug and cleanup ext logic
* Allow overriding of the neutron endpoint URL in metadata agent
* Allow passing table argument to construct IpRouteCommand
* Make external\_gateway\_nat\_rules easier to understand
* Remove perform\_snat\_action indirection
* Flavor Framework implementation
* Add breakages in public API of devref
* objects.qos.policy: support per type rule lists as synthetic fields
* Network RBAC DB setup and legacy migration
* [devref] db\_layer: expand on how new migration scripts look like
* Add oslo db retry decorator to non-CRUD actions
* QoS Service devref
* Implement QoS plugin
* Add oslo db retry decorator to non-CRUD actions
* Change prefix for namespace fixture
* Imported Translations from Transifex
* OVS-agent: Fix a docstring typo
* Python 3: do not use types.ClassType
* Create dvr base class and stop passing around snat\_ports
* Add qos section to ovs agent config
* Mute neutron.callbacks notification logs
* Small fixes in test\_qos\_agent UT
* Add unit tests and fixes for OVS Agent QoS Extension Driver
* Correct two spelling mistakes in Neutron devrefs
* Improve check\_migration command error message
* Avoid using logging in signal handler
* Galera multi-writers compliant sync\_allocations
* Fix SR-IOV mechanism driver tests directory
* Switch to the oslo\_utils.fileutils
* Fix a regression in a recent IPAM change
* Fix update\_port\_postcommit and port not found with DVR
* Tighten exception handler for import\_object
* Updated from global requirements
* bugs: Update info about current bug czar
* Add another Lieutenant contact for Dragonflow
* [neutron-db-manage] support separate migration branches
* Add OVS QoS extension agent driver
* Disable python3 tests failing due to Routes < 2.0
* Fix typo of 'receive' in test\_dhcp\_ipv6.py
* Fix typo 'adress'
* Add sub-project lieutenant for networking-midonet
* Lower log level for extending network/subnet/port
* Cleanup unused method get\_plugin\_version
* Remove db-access semaphore in ML2
* Moving out cisco n1kv extensions
* Remove self.snat\_ports, a dvr thing, from router base class
* Include comment in DHCP ip6tables rules
* Qos Agent Extension
* Fixed L3 agent manual scheduling for HA routers
* Ensure floating IPs only use IPv4 addresses
* Implement QoS policy detach from port and network
* Add API stub for QoS support rule\_type resource
* Lower log level of errors caused by user requests to INFO
* Reject router-interface-add with a port which doesn't have any addresses
* Fix bug that resources in attr\_map may point to same object
* Updated sub\_projects.rst for networking-vsphere
* Imported Translations from Transifex
* Enforce specific order for firewall.(un)filtered\_ports and devices
* objects.base: fixed object.delete()
* objects.qos.policy: fixed get\_\*\_policy and attach\_\* methods
* objects.base: reset changes after getting objects from database
* BaseObjectTestCase: rename test\_class into \_test\_class
* Cleanup rule models and objects
* objects.qos: fixed create and update for QosBandwidthLimitRule
* Use \_is\_this\_snat\_host and remove \_get\_gw\_port\_host
* Move more snat code to dvr class that does snat
* Add constants for vhost-user vif
* get\_vif\_ports: ignore non-Interface ports
* Add Pluggable IPAM Backend Part 1
* Fix duplicate entry catch for allowed address pairs
* Fix failures introduced by the new version of mock
* Arista ML2 driver should ignore non-vlan networks
* Ensure that update\_fip\_statuses gets called
* Make IPAM more pythonic
* Move DVR related method to proper class
* Introduce connection testers module
* Allow IPAM backend switch
* Correct fcntl.flock use in Pidfile.unlock
* Move update\_security\_group\_on\_port to SecurityGroupDbMixin
* Python 3: Fix a TypeError in policy.py
* In Arista ML2 driver Reconfigure VLAN on VM migration
* Add sub-project lieutenant for networking-plumgrid
* Fix issues with allocation pool generation for ::/64 cidr
* Add extra subnet route to ha router
* Remove lingering traces of q\_
* Make sure path\_prefix is set during unit tests
* Add IP\_ANY dict to ease choosing between IPv4 and IPv6 "any" address
* Python3: cast the result of zip() to list
* Track allocation\_pools in SubnetRequest
* Add ARP spoofing protection for LinuxBridge agent
* COMMON\_PREFIXES cleanup - patch 5/5
* List up necessary files for thirdparty-ci.rst
* Refactor init\_l3 to separate router port use case
* Devref for out-of-tree plugin/driver contribution
* Python3: do not add dict\_values objects
* portsecurity\_db\_common: Access db columns in a consistent way
* Python 3: do not index dict\_keys objects
* Remove unneeded OS\_TEST\_DBAPI\_ADMIN\_CONNECTION
* Update DVR agent to use get\_vifs\_by\_id
* DVR: cleanup stale floating ip namespaces
* COMMON\_PREFIXES cleanup - patch 1/5
* Fall back on empty path if prefix is missing
* Refactor IpRuleCommand to take more arguments
* objects.qos: added unit tests for QosPolicy neutron object
* objects.base: avoid db access if object does not have changes
* Start documenting potential API breakages in devref:neutron\_api
* QoS extension fixes
* Install more-specific ICMPv6 rule in DVR routers
* devref: document API status for neutron.openstack.common.\*
* Python3: do not use urllib.urlencode
* AgentExtensionsManager and AgentCoreResourceExtension
* Generic Resources RPC
* DVR: remove unused method
* Generic rpc callback mechanism which could be reused
* Update dhcp host portbinding on failover
* OVS native DBListcommand if\_exists support
* Introduce the AFTER\_READ callback for ports and networks
* Collapse create\_subnet into single method
* Downgrade log level for gone port on status update
* Add extension callbacks support for networks
* [qos] policy: add methods to interact with policy bindings
* Support Basic Address Scope CRUD as extensions
* First QoS versioned objects, ever
* Add bandwidth\_limit rule type constant
* Use EXT\_TO\_SERVICE\_MAPPING instead of ALLOWED\_SERVICES
* Change the half of the bridge name used for ports
* Fix log traces induced by retry decorator
* Remove unused linux bridge agent configuration options
* Add bandwidth\_limit rules as sub-collection of qos policy
* QoS: db models and migration rules
* Add Create/Destroy API to OVS QoS BW Limiting
* Fixing indentation and typo in comments
* docs: link quality of service doc stub to devref index
* Update PLUMgrid plugin information
* Improve fixture usage
* Move pylint dep from tox.ini to test-requirements
* Disable pylint job
* Remove bridge cleanup call
* Move windows requirements to requirements.txt
* Adds base in-tree functional testing of the ovs\_neutron\_agent
* fix spelling mistakes
* Register extraroute extension
* Increase ping count on ARP spoof test
* Read vif port information in bulk
* Do not mock arping in L3AgentTestFramework functional tests
* Fix Consolidate sriov agent and driver code
* Remove failing SafeFixture tests
* QoS service plugin stub
* Create the QoS API extension stub
* Switch to oslo.service
* Revert "Removed test\_lib module"
* Don't access mock's attribute directly especially when it's not needed
* Fix subnet updating failure on valid allocation pools
* Add documentation for Linux Bridge (previously missing)
* Add parent\_id to \_item calling from \_handle\_action
* Add logging of agent heartbeats
* populate port security default into network
* Revert "Fix 'router\_gateway' port status can't be updated"
* RootHelperProcess: kill can consume signal number
* Move NetcatTester to common/net\_helpers
* Make '\_create\_router' function handle Boolean kwargs correctly
* ip\_lib: Add flush() command to IpNeigh to clean arp cache
* Refactor NetcatTester class
* Use REST rather than ReST
* lb-agent: handle security group updates in main loop
* Add a double-mock guard to the base test case
* Remove duplicated mock patch of ip\_lib
* Consolidate sriov agent and driver code
* Restructure agent code in preparation for decomp
* Fix ip\_lib get\_gateway for default gateway on an iface
* fixing typo in gerrit query link in third party policies doc
* Use last address in v6 allocation pool generation
* Extend SubnetRequestFactory to access subnet dict
* Remove duplicated call to setup\_coreplugin
* Remove double mock of dhcp agent periodic check
* Remove double fanout mock
* Remove double callback manager mocks
* Remove ensure\_dirs double-patch
* Decompose \_save\_subnet
* Fix tenant-id in Arista ML2 driver to support HA router
* Log OVS agent configuration mismatch
* Avoid env variable duplication in tox.ini
* Skip ARP protection if 0.0.0.0/0 in addr pairs
* linuxbridge: clean up README file
* Fix tox errors in thirdparty-ci docs
* Removed test\_lib module
* Updated from global requirements
* Define SafeFixture base fixture
* Remove quantum untracked files from .gitignore
* Context class should initialise its own data
* Abstract sync\_allocations
* ovsdb: attempt to enable connection\_uri for native impl on startup
* Just use {0,1,2} rather sys.std\*.fileno()
* Make Daemon pidfile arg optional
* Different approach to indicate failure on SystemExit
* Move third-party CI policy under docs/policies
* Remove lbaas API tests, which are now in the lbaas repo

7.0.0.0b1
---------

* Only create one netaddr.IPNetwork object
* Provide work around for 0.0.0.0/0 ::/0 for ipset
* Fix >80 char lines that pep8 failed to detect
* Deprecate "router\_delete\_namespaces" and "dhcp\_delete\_namespaces"
* Make DHCPv6 out of bounds API test deterministic
* Don't process network\_delete events on OVS agent
* dhcp fails if extra\_dhcp\_opts for stateless subnet enabled
* Revert "Fix subnet creation failure on IPv6 valid gateway"
* Support oslo\_db 1.12
* Python 3: do not use itertools.izip
* Override opportunistic database tests to PyMySQL
* Extend default setenv instead of replacing it in tox.ini
* Fix FloatingIP Namespace creation in DVR for Late Binding
* Cleanup get\_plugin\_name() from the tree
* Bulk move methods to ipam\_backend\_mixin.py
* NSXv: update ini file to support dhcp\_lease\_time
* Use sets to calculate added/original/removed ips
* Add IPset cleanup script
* Optimize ipset usage in IptablesFirewallDriver
* Python3: do not set Request.body to a text string
* Prepare for full stack CI job
* Fix callback registry notification for security group rule
* Python3: do not use \_\_builtin\_\_
* Ease debugging alembic by passing proper scripts path in alembic.ini
* Use string exception casting everywhere
* l3 agent: do router cleanup for unknown routers
* Switch to oslo\_utils.uuidutils
* Fix subnet creation failure on IPv6 valid gateway
* Decompose \_create\_subnet\_from\_pool
* Move \_delete\_port
* Decompose create\_port and save\_subnet
* Retry port status update on StaleDataError
* Allow setting Agents description to None
* Fix RPC version to be a string
* Decompose DVR CSNAT L3 Agent from Compute Node L3 Agent
* cleanup openstack-common.conf and sync updated files
* Fix l3 agent to not create already deleted router
* Python3: do not use '+' on dict\_items objects
* Disable keepalived process in keepalived func test
* Python3: do not use im\_self/im\_func/func\_closure
* Add request factory for pluggable IPAM
* Python3: use dict.keys() instead of dict.iterkeys()
* NSX QoS ext: RXTX factor can be decimal
* Move \_add\_auto\_addrs\_on\_network\_ports
* DHCP agent: Set an "ipxe" tag to work with Ironic
* Add sanity\_check for keepalived ipv6 support
* Remove \_check\_ip\_in\_allocation\_pool
* Precision networking-bagpipe-l2 subproject
* Don't delete DVR namespace if there are still ports on this node
* Updated from global requirements
* Fixed the only sphinx warning in docs
* Fix SR-IOV mech driver to set port status to down when agent is required
* read\_hosts\_file\_leases shouldn't parse stateless IPv6
* Fix 'router\_gateway' port status can't be updated
* Update version for Liberty

7.0.0a0
-------

* Add networking-sfc to the list of affiliated Neutron projects
* Minor improvements to sub\_projects document
* Python 3: do not use cmp(), nor sorted(..., cmp=...)
* Move get\_inteface\_by\_ip from LinuxBridge class to ip\_lib
* Add policy files specific to NSX plugins
* Fix cisco\_csr\_identifier\_map.ipsec\_site\_conn\_id
* fix rootwrap debug filter for ping all
* Refactor rpc\_loop() in ovs neutron agent
* Add deadlock retry to API and ML2 RPC port update
* ovsdb: session.rpc never initialized
* Remove duplicated debug logging around locking
* Refactor scan\_ports() and update\_ancillary\_ports() in OVS Neutron Agent
* Python3: do not change the size of a dict while iterating over it
* Refactor TestRpcWorker and TestWorkerService
* Juno\_initial migration
* docs: added job to well known tox envlist
* API Extensions: inherit from the ExtensionDescriptor
* Remove fossilized remains
* Refactor update\_port in db\_base\_plugin\_v2
* Refactor \_update\_ips\_for\_port
* Python 3: use dict.values instead of dict.itervalues
* Put output of docs job into doc/build/html
* Remove get\_namespace from API extensions
* Ensure no "db" related functional/fullstack tests are skipped in the gate
* Use PyMySQL in MySQL related functional/fullstack tests
* Skip rescheduling networks if no DHCP agents available
* Reflect project moves from stackforge to openstack
* VMWare NSXv: Add distributed URL locking to ini
* Revert "Revert "Add VIF\_DELETED notification event to Nova""
* Decompose db\_base\_plugin\_v2.py with changes
* Remove duplicate tunnel id check in sync\_allocations
* Remove meaningless no\_delete from L3 test
* Revert "Revert "Set default of api\_workers to number of CPUs""
* OVSNeutronAgent pass the config as parameter
* Refactor \_update\_subnet\_allocation\_pools
* Stop sending gratuitous arp when ip version is 6
* Set .gitreview defaultbranch to feature/pecan
* Fix Enum usage in 589f9237ca0e\_cisco\_n1kv\_ml2\_driver\_tables
* Imported Translations from Transifex
* power grab
* Change ensure\_dir to not check directory exists first
* Document existence of br-tun and br-int in the OVS agent
* Correct indentation in neutron.api.v2.attributes
* Python3: replace 'unicode' with 'six.text\_type'
* Fullstack testing devref follow up
* Moving out the cisco n1kv section to stackforge
* Ensure no "agent" functional tests are skipped in the gate
* Remove useless pass from methods in type\_tunnel.py
* Make Vlantransparent extension inherit from ExtensionDescriptor
* Actually allow to pass TRACE\_FAILONLY to ostestr
* Switch to os-testr to control testr
* Introduce functions using arping executable
* Revert "Defer segment lookup in NetworkContext object"
* Added networking-plumgrid in plugin requirements
* Switch from MySQL-python to PyMySQL
* Context: Remove logic for read\_deleted and deprecate it
* Python 3: use next() instead of iterator.next()
* Consume oslo.policy
* policy: cleanup deprecation code to handle old extension:xxx rules
* Fix a regression in "Separate ovs-ofctl using code as a driver" change
* Break Pinger class to functions
* Handle SIGHUP: neutron-server (multiprocess) and metadata agent
* Allow update\_port\_status to take network param
* Make pep8 job succeed when /etc/neutron/neutron.conf is not installed
* Add a comment on \_check\_update\_has\_security\_groups
* Change defaultbranch in .gitreview
* Enable all deprecation warnings for test runs
* Remove get\_admin\_roles and associated logic
* Add documentations for VXLAN Tunnels
* Defer segment lookup in NetworkContext object
* Fix typos in docs
* Fixes bulk insertion of data to ml2\_port\_binding
* Add Neutron PTL Office Hours
* Python3: Enable all working tests in tox.ini
* Add get\_events to OVSDB monitor
* Update ipset members when corresponding sg member is empty
* Send 'security\_groups\_member\_updated' when port changes
* Remove full stack log noise
* ML2: Remove TYPE\_MULTI\_SEGMENT
* L3 agent should do report state before full sync at start
* Clean only floating-ip related connection states
* Refactor awkward logic in setup\_dhcp\_port
* Add a "light" base test class for DB tests
* Make \_val\_to\_py and \_py\_to\_val not private
* Decompose db\_base\_plugin\_v2.py part 2
* Fix typo in test class name
* Start linuxbridge neutron agent using a launcher
* Handle SIGHUP in ovs neutron agent
* test\_ovs\_neutron\_agent: Remove useless ofport=10 arguments
* test\_l3: Don't assume the order of subnets
* Python 3: do not index a dict\_values object
* versionutils: switch from incubator version to oslo.log
* Run RootHelperProcess always as root
* Changes in rally-jobs/README.rst
* Add more API tests for port-security extension:
* Decompose the NCS ML2 Mechanism Driver
* test\_db\_base\_plugin\_v2: Don't assume the order of fixed\_ips
* pylint: enable \`duplicate-key\` check
* Remove reference to non-existent fullstack fixture
* Enhance utils.ensure\_dir to be resilient to concurrent workers
* Use a single method to remove an address with its conntrack state
* Decompose db\_base\_plugin\_v2.py
* Add sub-project lieutenants
* Fix confusing parameters names
* Extra indent in test\_ovs\_neutron\_agent
* Make MockFixedIntervalLoopingCall class as a helper class
* Revert "Add VIF\_DELETED notification event to Nova"
* Wrap ML2 delete\_port with db retry decorator
* Remove extra indent in testcases
* Check for 'removed' in port\_info before reference
* Catch broad exception in methods used in FixedIntervalLoopingCall
* Add devref that explains fullstack testing and its direction
* Remove get\_dhcp\_port RPC method
* Refactor type\_tunnel/gre/vxlan to reduce duplicate code
* Imported Translations from Transifex
* Update rootwrap.conf to add /usr/local/bin
* Add route to metadata IP by default
* Python3: use six.iteritems() instead of dict.iteritems()
* Modify ipset functional tests to pass on older machines
* Add a non-mixin function for model queries
* Implement IPAM Driver loader
* Remove comment about hash seed in tox.ini
* Refactor mlnx mechanism driver to support infiniband only
* Remove unused \_uuid function alias from test\_iptables.py
* test\_ovs\_neutron\_agent: Remove unnecessary mocking
* Refactor type\_gre.vxlan tests to reduce duplicate code
* Removed duplicate keys in dicts in test
* Don't update floating IP status if no change
* Don't delete port from bridge on delete\_port event
* Enable random hash seeds
* Fix formatting of core-reviewers doc
* Get completely rid of contextlib.nested
* Fix indentation errors in tests
* Improve test\_set\_members\_deleting\_less\_than\_5
* Rename test\_periodoc\_resync\_helper to test\_periodic\_resync\_helper
* Sort \_get\_new/deleted\_set\_ips responses in unittests
* Ensure netfilter is enabled for bridges
* Cleanup stale metadata processes on l3 agent sync
* Imported Translations from Transifex
* Fix ovs agent restore local\_vlan\_map failed
* Use correct time delta function
* Do not assume order of security group rules
* ML2: Incorrect commented cisco mechanism driver name
* py34: don't run any tests except unit tests
* Move full-stack logs post-tests
* Fix PYTHONHASHSEED bugs in test\_security\_groups\_rpc
* Addressing follow up comments for OVS\_LIB fail\_mode setting API
* Move pool dispose() before os.fork
* Add RFE submission guidelines
* Switch to dictionary for iptables find
* Process port IP requests before subnet requests
* Remove time formatting in agent clock error
* Persist DHCP leases to a local database
* Flesh out the new RFE process and set deadlines for it's use
* Do not assume order of dictionary elements in init\_l3
* Introduce the Lieutenant system into Neutron
* Isolate use of fixed\_ips[0] to avoid confusion
* Use the correct name for the "Repository Creator's Guide"
* Do not assume order of convert\_kvp\_list\_to\_dict method responses
* Do not assume order of iptables\_firewall method responses
* Do not assume order of get\_sync\_data\_metering response elements
* OVS-agent: Remove optional flags from br\_tun.deferred() method
* OVS\_LIB support API for setting fail mode 'standalone'
* Remove hack for sending gratuitous arp from fip ns
* Force order of dhcp.needs\_resync\_reasons dictionary elements
* Remove use of contextlib.nested (api-tests)
* Use os.\_exit after forking
* test\_fork\_error: Fix incorrect test mock
* Skip external tables for neutron-db-manage --autogenerate
* Fix a typo in \_schedule\_network method
* Ensure non-overlapping cidrs in subnetpools without galera
* Add callback prior to deleting a subnet
* OVS-agent: Separate ovs-ofctl using code as a driver
* Imported Translations from Transifex
* Remove unnecessary brackets
* Ensure mac address added to iptables is always in unix format
* Remove use of contextlib.nested
* Adding loadbalanacerv2 device owner constant to neutron constants
* Python 3: use six.string\_types instead of basestring
* Fix minor errors in the Vyatta L3 Plugin:
* Remove middleware oslo-incubator module
* Match order of iptables arguments to iptables-save
* fix DHCP port changed when dhcp-agent restart
* VMware NSXV: update configuration file
* IPAM reference driver
* Python 3: Use six.moves.range
* ovs-agent: prevent ARP requests with faked IP addresses
* Use convenience method from db api to create nested transaction
* Remove a unused Context class
* Use namespace names in NetcatTester
* Optimize IptablesManager.\_find\_last\_entry
* Take Daemon stdin/stdout/stderr args as file objects
* Support for concurrent full-stack tests
* OVS-DVR: Suppress a confusing error log about csnat port
* OVS-DVR: Improve an error log about csnat port
* Replace ci.o.o links with docs.o.o/infra
* Refactor initialize() of sriov mech driver
* Centralized register\_OVS\_agent in tests
* Don't pass namespace name in disable\_isolated\_metadata\_proxy
* Add client id option support to dhcp agent
* Remove use of contextlib.nested
* Allow updating port 'binding:host\_id' be None
* Block subnet create when a network hosts subnets allocated from different pools
* Fix neutron tests
* Allow unit tests to be run independently
* SystemExit is ok for child processes
* When disabling dhcp, delete fixed ip properly
* Update build hooks
* Append @randtoken to L3 agent namespaces in full stack tests
* Add VIF\_DELETED notification event to Nova
* setup port filters when sg rules change
* tests: don't allow oslo.config to autodiscover config files
* mlnx MD: mlnx\_direct removal
* l2pop UT: Reduce code duplication in migration tests
* Add unit tests for ML2 DVR port binding and fix PortContext inconsistencies
* Make it clear the rfe tag is lower-case
* Remove H305 from tox.ini pep8 ignore list
* Allow users to run 'tox -epy34'
* Deprecate quota\_items, register resources upon REST initialization
* Support BP:ipv6-router in Neutron HA Router
* Catch ObjectDeletedError and skip port or subnet removal
* Randomize tunnel id query to avoid contention
* Remove skip of service-type management API test
* Imported Translations from Transifex
* Add capability to wait for IPv6 address in ip\_lib
* Remove from BridgeDevice homemade execute in namespace
* remove router interface on Arista L3 plugin fails
* Extenuate register\_dhcp\_agent code duplication in tests
* Fix typos related to IPv6 use-cases
* Refactor checks for device existence
* Updated from global requirements
* Check for missing network in \_bind\_devices
* Add missed actions into policy.json
* Reuse caller's session in ML2 DB methods
* ARP spoofing patch: Data structures for rules
* Limit router gw ports' stateful fixed IPs to one per address family
* VMWare NSXv: Metadata for distributed router
* VMware: update supported plugins
* Allow to define enable\_snat default value
* Update the specs process for Liberty
* changes log level to debug for help calls
* Remove use of contextlib.nested
* Fix fetching prevent\_arp\_spoofing from cfg in neutron-sanity-check
* VMware: add in router types for NSXv
* Reduce prefix and suffix length in ipsets
* Add port-security extension API test cases
* Add test for security groups
* Use iptables zone to separate different ip\_conntrack
* Fix dhcp \_test\_sync\_state\_helper asserting calls wrong
* Updated from global requirements
* Enhance configure\_for\_func\_testing.sh for \*aaS use
* Add IP version support to all ip\_lib code
* Imported Translations from Transifex
* Get all interfaces for get\_snat\_sync\_interfaces
* OVS-agent: Ignore IPv6 addresses for ARP spoofing prevention
* Remove un-used keys in keepalived tests
* Deprecate config-based Quota Driver
* Clarify stackforge/vmware-nsx is for VMware NSX suite
* Updated from global requirements
* l3 agent: fix grammar in router info not found warning
* Finally let L3 and DHCP agents cleanup namespaces by default
* Context: is\_admin==True implies is\_advsvc=True
* Fix port creation verification of the port-security extension
* Add some tests for floating ips
* Add notes about official sub-projects
* Updated ovsvapp\_agent.ini in neutron
* Don't use iterator in search for tunnel type
* Remove is\_active property from SimpleInterfaceMonitor
* Updated from global requirements
* Disembowel register\_l3\_agent code duplication in tests
* Ensure mocks for lla allocator \_write in test\_agent
* Fix \_device\_to\_port\_id for non-tap devices
* Imported Translations from Transifex
* Rename delete\_gateway method name
* Drop use of 'oslo' namespace package
* Remove 'IP' from device exception message
* Add icmpv6 to sg\_supported\_protocols
* Suppress exception when trying to remove non existing device in SNAT redirect

2015.1.0
--------

* Run radvd as root
* Add devices to update in RPC call security\_groups\_provider\_updated
* Run radvd as root
* Support multiple IPv6 prefixes on internal router ports for an HA Router
* Not creating HA router when not enough l3 agents
* Eliminate extra queries used to retrieve gw\_ports
* Don't update port with host id of None
* fix l3-agent restart with last runtime fip for dvr
* Refactoring to adhere to coding convention
* Replace unnecessary call to get\_sync\_routers
* Move test\_get\_user\_allocation\*returns\_none test to a proper class
* Replace BaseLinuxTestCase by BaseSudoTestCase
* Remove RecursivePermDirFixture useless cleanup
* Utilities for building/parsing netns names to facilitate testing
* Fix MismatchError to nondeterministic order for list of controllers
* Add missing interface to populate subnets method
* Don't resync on DHCP agent setup failure
* Refactor socket ssl wrapping
* Don't resync on DHCP agent setup failure
* Replace BaseIPVethTestCase by FakeMachine
* Return exception when attempting to add duplicate VIP
* Imported Translations from Transifex
* Allow plugin to specify router\_id
* Neutron to Drop Router Advts from VM ports
* Fix L3 agent functional tests random failures
* Mock report\_state during L3 agent functional tests
* Remove backward compatibility for check\_is\_admin

2015.1.0rc2
-----------

* Add weak reference test for callback manager
* Spawn RADVD only in the master HA router
* tests: confirm that \_output\_hosts\_file does not log too often
* Double functional testing timeout to 180s
* Restrict subnet create/update to avoid DHCP resync
* Only update MTU in update code for MTU
* Restrict subnet create/update to avoid DHCP resync
* Make sure OVS restarts when Exception occurred
* Updated from global requirements
* Remove dependency on weak reference for registry callbacks
* Ensure metadata network works with DVR
* Change callbacks logging from INFO to DEBUG
* Fix DVR functional tests resources leak
* Create bridges in ovsdb monitor functional tests
* Refactor RESOURCE\_ATTRIBUTE\_MAP cleanup
* remove metadata\_proxy\_local filters for rootwrap
* Add use\_slave DB api support
* Fix incorrect query for user ip allocations
* Fix typo acomplished => accomplished
* OOP naming cleanup in l3\_dvr\_db
* ARP spoofing patch: Low level ebtables integration
* Fix test discovery for api and functional paths
* Block allowed address pairs on other tenants' net
* tests: confirm that \_output\_hosts\_file does not log too often
* Fix super cleanUp for fullstack ProcessFixture
* Add security groups events
* Block subnet create with mismatched IP versions
* Remove neutron.tests.common.agents package
* L3 DB: Defer port DB subnet lookups
* lb-agent: ensure tap mtu is the same as physical device
* Only update MTU in update code for MTU
* Revive BaseLinuxTestCase.\_create\_namespace
* Defer creation of router JSON in get\_routers RPC
* ovs\_lib: Fix a race between get\_port\_tag\_dict and port removal
* Correct inconsistent enable\_snat management
* \_create\_subnet\_from\_implicit\_pool assumes external network extension
* Log caught exceptions while deleting a router
* Define FakeMachine helper for functional/fullstack tests
* Replace custom method call logger with oslo.log helper
* ML2: Change port status only when it's bound to the host
* Release Import of Translations from Transifex
* Simplify keepalived.virtual\_routes
* l2pop UT: Simplify migration tests
* l2pop UT: Expire cached db objects before reusing a session
* Correct typo for matching non-dict ovsdb rows
* Fixes race condition and boosts the scheduling performance
* Register ibm-db-alembic import for DB2 migrations
* Fixes race condition and boosts the scheduling performance
* ML2: Change port status only when it's bound to the host
* Remove double queries in l3 DB get methods
* Strip unnecessary overrides in extraroute\_db mixin
* Set loading strategy to joined for Routerport/Port
* Avoid double-hopping deletes for security group rules
* Set IPset hash type to 'net' instead of 'ip'
* Revert "Add ipset element and hashsize tunables"
* Set IPset hash type to 'net' instead of 'ip'
* Update .gitreview to point to stable/kilo
* Add Kilo release milestone
* Quota model: use HasTenantId mixin
* Clarify the init logic for the ML2 plugin
* Deal with TODO related to Security Groups RPC API's classes
* Add Kilo release milestone
* Add some more comments to models/frozen.py
* IPv6 SLAAC subnet create should update ports on net
* Two api tests for 'firewall insertion mode' feature
* OVS\_LIB API addition - change bridge controller connection-mode
* Imported Translations from Transifex
* Drop the ovs\_lib compat layer as per TODO note
* Removed ml2\_conf\_odl.ini config file
* IPv6 SLAAC subnet create should update ports on net
* Use 'port' instead of 'ports' to reference port from IPAllocation
* Enhance OVSDB Transaction timeout configuration
* Added config variable for External Network type in ML2
* Update decomp progress chart
* Provide details for configure multiple DHCP agents
* Stop running L3 functional tests with both OVSDB interfaces
* Fix formatting errors in TESTING.rst
* Pass correct port ID back to RPC caller
* Fix intermittent ipset\_manager test failure
* Fix mock return settings in test\_full\_uuids\_skip\_port\_id\_lookup
* Add full-stack test
* create\_resource should return maximum length str
* Add clock sync error detection on agent registration
* Log RPC initialization in L3 service plugin and ML2
* Add block name to switch config options for MLX plug-ins
* Fix the ImportErrors in l3 and dhcp scheduler functional tests
* Removed jsonrpclib dependency
* Additions to TESTING.rst
* Handle race condition on subnet-delete
* Move values for network\_type to plugins.common.constants.py
* allow OVSDB connection schema to be configurable
* Add OVSDB connection as a parameter to the transaction
* l3\_rpc: Fix a comment typo
* Fix native OVSDB db\_get handling for UUID columns
* Move iptables and ipset config registration into modules
* Kill hostname validation for subnet:dns\_nameservers
* Adds DVR functional test for multi-external networks
* context: reuse base oslo.context class for to\_dict()
* Fix routerid constraint migration
* Synced versionutils from oslo-incubator
* Removed ml2\_conf\_odl.ini config file
* Router is not unscheduled when the last port is deleted
* Remove L3 report\_state logging
* Double functional testing timeout to 180s
* Non-json body on POST 500's
* OVSDB python binding should use row.delete() to remove rows
* Revert connection option post full-stack tests
* Handle SIGHUP in dhcp and l3 agents
* Sync service from oslo-incubator
* Imported Translations from Transifex

2015.1.0rc1
-----------

* Add logging to dangling port to ml2 delete\_subnet
* Avoid synchronizing session when deleting networkdhcpagentbinding
* Update L3 Agent Scheduler API tests
* Revert "IPv6 SLAAC subnet create should update ports on net"
* Add missing config parameters in neutron.conf
* Moving VLAN Transparency support from core to extension
* Re-use context session in ML2 DB get\_port\_binding\_host
* Consider all address scopes in init\_l3
* Improves the  description string for the config parameter metadata\_workers
* Fix intermittent UT failures in test\_utils
* OOP cleanup: start protected method names with underscore
* Enhance TESTING.rst
* Remove check for bash usage
* Return from check\_ports\_exist\_on\_l3agent if no subnet found
* Open Liberty development
* Remove duplicated l3 router scheduler test cases
* Remove tests from HA routers test framework
* linuxbridge UT: Fix a regression of the recent ip\_lib change
* Fix dynamic arp populate error for dvr routers
* Reorganize plugin test modules
* Reorganize unit test tree
* Add ipset element and hashsize tunables
* Allow metadata proxy running with nobody user/group
* Skip example retargetable functional test
* Prepare for unit test reorg
* Remove orphaned nuage unit test module
* Add API tests for subnet-create with subnetpool
* Refactoring cleanup for L3 agent callbacks
* Imported Translations from Transifex
* Support multiple IPv6 prefixes on internal router ports
* Fix functional test using local timeout value
* Add index for port
* Always run dnsmasq as root
* Move network MTU from core REST API to extension API
* Refactoring of L3 agent notifications for router
* Fix docstring for l3\_dvr\_db.dvr\_vmarp\_table\_update
* Treat all negative quota values as -1
* Router test enhancements
* ovs\_neutron\_agent: Remove a redundant assignment of ovs\_status
* Move orphaned api test - deux
* IPv6 SLAAC subnet create should update ports on net
* Add API tests for Neutron DVR extension
* Add missing neutron/tests/unit/agent/common/\_\_init\_\_.py
* Allow metadata proxy to log with nobody user/group
* Move orphaned api test
* Implement default subnet pool configuration settings
* Define bridge/port fixtures for OVS/LinuxBridge/Veth backends
* Update core reviewer responsibilities
* Remove "Arguments dropped when creating context" logging
* Some cleanup in L3 HA code
* Fix reference to non-existent setup\_dvr\_flows\_on\_integ\_tun\_br
* Modify a different agent in test\_update\_agent\_description
* Move API tests to neutron.test.api
* Simple subnetpool allocation quotas
* Subnet allocation from a subnet pool
* Simplify retargetable test framework
* Increase max attempts to 2 for pings on ARP tests
* Revert "Add ipset element and hashsize tunables"
* Add API tests for subnetpool allocation
* Handle no ofport in get\_vif\_port\_to\_ofport\_map
* Update .coveragerc after the removal of Cisco Nexus monolithic plugin
* Make floatingip reachable from the same network
* Fix functional configure script
* Enable ARP spoofing prevention by default
* Support IPv6 Router
* Move final remnants of router processing to router classes
* Only call get\_engine().pool.dispose if \_FACADE
* Stop using deprecated DEFAULT group for lock\_path
* tests: don't rely on configuration files outside tests directory
* Set floating IP port status to "N/A"
* Add simple ARP spoofing protection
* Imported Translations from Transifex
* Add tests for the l3 agent namespaces manager
* Make L3 agent honor periodic\_interval setting
* Handle non-index lookups in native OVSDB backend
* Fix error raising in security groups method
* Update NEC plugin decomposition status
* Auto-update gateway port after subnet-create
* Allow update of ext gateway IP's w/out port delete
* Support Dual-Stack Gateway Ports on Neutron Routers
* Remove auto deletion of routers in unit tests
* No allocation needed for specific IPv6 SLAAC addr assignment
* Remove neutron.tests.sub\_base
* Fix test case for DHCP agent interface restart
* Store and log correct exception info
* Test to verify  shared attribute of network
* Enable Process Monitor by default
* Reload DHCP interface when its port is updated
* Don't eagerly load ranges from IPAllocationPool
* Revert "Fix validation of physical network name for flat nets"
* Enable services on agents with admin\_state\_up False
* Simplify base test cases
* Send only one rule in queue on rule create/delete
* Add full-stack tests framework
* Stop any spawned ProcessMonitor at test cleanup
* Add missing DeferredOVSBridge export
* Use router state in get\_ha\_device\_name and ha\_network\_added
* Added note about removing bridge from mappings
* Add language around re-proposing specs for new releases
* Follow up patch for Validate when DVR enabled, l2\_pop is also enabled
* Fix displaying of devref for TestModelsMigrations
* Use 1/0 as booleans for DB2
* Remove allow\_overlap from subnetpools API
* If configured, set the MTU for fpr/rfp intefaces
* Add L3 router plugin shim for Brocade MLX
* Moves ovs\_lib to agent/common
* OVS agent support on Hyper-V
* No IPv6 SLAAC addrs for create router intf without fixed\_ips
* Cisco UCS Manager ML2 Mechanism Driver
* Cisco Nexus1000V ML2 Mechanism Driver
* Rename/move/remove HaRouter methods
* lb-agent: use 'replace' instead of 'add' with 'bridge fdb'
* Add some useful notes in  devref/db\_layer.rst
* Fix a usage error of joinedload + filter in l3 scheduler
* Move process\_ha\_router\_added/removed from HA agent to router
* Ml2 Mechanism Driver for OVSvApp Solution
* Add eventlet monkey\_patch helper
* Move create\_dvr\_fip\_interfaces in to DVR
* Deprecate use\_namespaces option
* Add the default\_ipv6\_subnet\_pool config option
* Fix common misspellings
* Fix port status not being updated properly
* Fix handling of before/after notifications in linuxbridge agent
* Move external port processing to router classes
* Expose ha\_state per router to agent binding via API
* Decouple L3 and service plugins during DVR router migration
* Transform BaseLinuxTestCase methods in helpers
* Remove downgrade from existing migrations
* Fix minor nits in \_notify\_l3\_agent\_new\_port()
* Drop support for SQL Schema Downgrades
* VMWare NSXv: Metadata default gateway param
* Imported Translations from Transifex
* Move README.odl into opendaylight directory
* Fix missing spaces in strings split across lines
* Fix typos in neutron/db/migration
* Remove unnecessary 'IN vs ==' sql query branches
* Fix intermittent failure in TestNetworksFailover UT
* Fixes floating IP regression with multiple routers
* Add no\_delete flag to UT router context manager
* Updated from global requirements
* Send notification to controller about HA router state change
* Fix usage of 'default' parameter in 1955efc66455 migration
* Move metadata proxy shared options to neutron.conf
* Reuse nova batch notifier
* Allow plugin to specify security-group rules ids upon creation
* Add native OVSDB implementation of OVSDB API
* Break coupling between ML2 and L3 during delete operation
* Fix validation of physical network name for flat nets
* Validate when DVR enabled, l2\_pop is also enabled
* Fix create\_security\_group\_rule\_bulk\_native to return all created rules

2015.1.0b3
----------

* Prepare Base(OVS)LinuxTestCase transformation in helpers
* Improve DVR scale performance
* Remove redundant unit tests from OVS DVR Agent
* Hyper-V Agent decomposition
* Enable to apply policies to resources with special plural
* Add a missing mock in DHCPAgentWeightSchedulerTestCase
* Basic subnetpool CRUD
* Enable to specify context on POST requests during unittests
* Fix a usage error of joinedload + filter in dhcp scheduler
* Allow to request metadata proxy only from internal interfaces
* Remove unused L3 HA RPC method
* Replace keepalived notifier bash script with Python ip monitor
* Add sanity check for OVSDB native support
* Fix metering agent failure when chain missing
* Fix minor decomp progress chart issues
* Adding VLAN Transparency support for ML2 along with REST API changes
* DHCP Service LoadBalancing Scheduler
* Make DHCP tests cleanup neutron manager reference
* Include IPv6 SLAAC addresses implicitly for port update
* Api tests to cover network mtu attribute
* Run more Rally benchmark on every patch
* Fix DBDuplicateError handling in \_ensure\_default\_security\_group
* Add ML2 VLAN mechanism driver for Brocade MLX and ICX switches
* Include IPv6 SLAAC addresses implicitly for port create
* Don't delete HA router primary VIP on agent restarts
* Introduce External IPAM Interface
* Expose Rest Api access to mtu attributes
* Advertise mtu over dhcp
* Add MTU selection to ML2
* IBM SDN-VE Plugin decomposition
* Brocade Vyatta vrouter shim plugin for vendor decomposition
* Fix spelling error in neutron.conf
* OVS DVR UT: Remove an inappropriate str() conversion
* Handle DBDuplicateError exception properly when creating default sg
* Imported Translations from Transifex
* Schedule net to a DHCP agt on subnet create
* Revert "Set default of api\_workers to number of CPUs"
* Add portsecurity extension support
* Revert "fix check\_ports\_exist\_on\_l3agent in no subnet case"
* Move Unix domain socket helpers to a common place
* Move mlnx agent to be under ml2/drivers/mlnx
* iptables firewall: add framework for iptables firewall functional test
* Adding a cleanup for 'fip-' and 'snat-' namespaces in netns\_cleanup
* replaces enumeration method used to get a list of interfaces
* Remove unneeded DVRAgentRpcApiMixin from OVSDVRNeutronAgent
* Prevent updating mac address of bound port
* Update api tests from tempest
* Set TEMPEST\_CONFIG\_DIR in the api tox env
* Remove vendor entry point
* Add a netns-cleanup functional test
* Reduce db calls count in get\_devices\_details\_list
* Move internal port processing to router classes
* Brocade vendor code decomposition from neutron repo
* Refactor \_remove\_unused\_security\_group\_info
* Add MTU selection & advertisement settings to Neutron config
* ML2 cisco\_nexus MD: sync config and models with vendor repo
* fix check\_ports\_exist\_on\_l3agent in no subnet case
* Fix netns-cleanup broken by ProcessMonitor refactor
* Improve validate of remove\_router\_interface
* Set default of api\_workers to number of CPUs
* Refactor retry mechanism used in some DB operations
* Revert "Revert "Remove port from ovsdb after its deletion""
* Add rootwrap daemon mode support
* Break coupling between ML2 and L3 during create/update operations
* Fix incorrect comments
* Start metadata agent without trying to connect db
* Remove router binding with router-interface-delete
* Remove dead code
* Update contribute.rst with Big Switch decomp
* Migrate to oslo.log
* Fix l3\_agentschedulers\_db for consistency of code
* Return 404 when executing net-list-on-dhcp-agent with invalid agent\_id
* ofagent: Update after networking-ofagent release
* Use common agent.linux.utils.ensure\_dir method
* Stop using RPC namespace to unbreak rolling upgrades
* Add Mellanox decomposition progress to chart
* Arista L3 Service Plugin decomposition
* Fix pylint issue with type VS isinstance in event\_observers
* Raise QuotaResourceUnknown in the quota engine
* utils.execute: Add a debug-level log to record stdin
* Imported Translations from Transifex
* contribute.rst: Use consistent tags
* Add README and requirements.txt for VMware plugins
* Fix non-existent self.local\_subnets in DvrRouter class
* Added oslo.log dependency
* Don't notify dead DHCP agent of removed networks
* Prevent calling waitall() inside a GreenPool's greenthread
* Added check for emptyness where in\_ is being used
* Improve performance of \_get\_security\_group\_member\_ips
* NEC plugin code split
* Imported Translations from Transifex
* Change linux/ip\_lib code to better handle address families
* portsecurity\_db: Fix a usage of is\_attr\_set
* ofagent: Have a thin driver module
* Don't start transaction during floating IP delete
* linuxbridge UT: Mock get\_interface\_by\_ip
* linuxbridge UT: Do not create the same instance in each cases
* In Arista ML2 delete tenant without any resources
* Initial copy of api tests from tempest
* Fix tempest api testing
* Use an existing function in process monitor tests
* Fix dhcp config dir removed too soon
* FIP debug messages
* Add proccess monitor to keepalived
* Fix wrong log output in neutron/neutron/agent/linux/dhcp.py
* [contribute.rst] Current status of Freescale Codebase
* portsecurity\_db: Use is\_attr\_set instead of a home-grown equivalent
* Imported Translations from Transifex
* Imported Translations from Transifex
* Updated from global requirements
* Add script to copy neutron api tests from tempest
* ofagent: kill the left over after decomposition
* Use accessors instead of private attributes for Ml2 plugin
* Remove 'free' exclusions from pylint
* Refactor the ProcessMonitor API
* Networking OVS-DPDK plugin decomposition
* Fix DB2 upgrade problem for Remove Hyper-V plugin
* Big Switch Networks code split
* Reduce code duplication and fix argument order in test\_wsgi
* Replace IPv4 and IPv6 default addresses with constants
* VMware NSX: Update decomposition progress table
* Updated from global requirements
* Vendor decomposition to move CSR1000v support to the networking-cisco repo
* Move Neutron Policy pages into the tree
* Adding DB model changes for Nuage Plugin post decomposition
* Add ability to run pylint check on modified files only
* Fix test tautology for DVR
* Decompose the VMware plugin
* Remove references to 0.0.0.0/0 in iptable rules
* Updated from global requirements
* Change metadata driver unit tests to use monitored spawn
* Decouple L3 and VPN service plugins during router operations
* Move \_set\_subnet\_arp\_info to dvr\_router
* Refactor DVR \_arp\_entry methods
* Refactor management of namespaces in the L3 Agent
* Raise error upon deleting subnet with router ports
* Imported Translations from Transifex
* OVS UT: Remove useless return\_value for setup\_integration\_br
* Introduce ip address monitor
* Add cisco decomposition progress to chart
* oslo: sync all modules that depend on incubator log module
* test\_metadata\_agent: don't check implementation details
* Progress chart for MidoNet
* Extend test coverage for iptables\_firewall.py
* Default the Linuxbridge agent to enabling VXLAN
* Remove HyperVNeutronPlugin
* ml2 plugin: use attributes.{NETWORK, SUBNET, PORT} consistently
* ml2 extension driver: more tests, fix data argument inconsistency
* Use oslo\_config choices support
* Metaplugin decomposition
* ofagent: Vendor code decomposition
* contribute.rst: Fill in the current status of ofagent
* Missing entry points for cisco apic topology agents
* Prevent direct port-delete of FIP Agent GW and CSNAT
* PLUMgrid plugin decomposition
* Improve structure of Vendor Decomposition progress chart
* Removing a router twice from the same agent shouldn't cause an error
* Simplify prepare\_veth\_pairs in functional tests
* Add a functional test for iptables\_manager.binary\_name
* Add InvalidIpForNetwork and InvalidIpForSubnet exception
* ovs\_neutron\_agent should exit gracefully
* Ensure tests run under python2.7
* Validate string length at API level
* Capture progress chart for vendor decomposition
* Fixes formatting errors in devref documentation
* Imported Translations from Transifex
* Fix retrieval of shared firewall\_policies
* Password config options should be marked secret
* Check whether sudo is enabled in BaseSudoTestCase.setUpClass
* Revert "Remove port from ovsdb after its deletion"
* Add filter for provider network attributes in ML2
* tests: initialize policy in BaseTestCase
* policy: don't hack around oslo.config path search algorithm
* Make listing security groups faster
* Allow AsyncProcess to block on process start and stop
* Don't mock plugin in L3SchedulerTestBaseMixin
* Adds migration script for Hyper-V Plugin tables
* Make del\_fdb\_flow() idempotent
* Update default tox envlist to match voting gate checks
* Added a policy for retrieving the agent hosting a load balancer
* Avoid ObjectDeletedError while accessing deleted binding
* Correct db functional tests to support oslo.db 1.50
* Avoid DetachedInstanceError after session rollback
* Always fill UDP checksums in DHCP replies
* remove unused code in metadata agent code
* Move pylint checks to pep8 testenv
* Change L3 agent AdvancedService class to be non-singleton
* Passes the plugin context variable in the ML2 Extension Driver API
* devref: added guidelines to maintain service entry points
* VMware NSXv: Added router-type to database model
* Remove discover from test requirements
* Add callbacks-based system to Neutron
* Refactor Pinger class
* Create/Delete FIP Agent gateway port only if DVR Routers
* Move the assignment of existing\_floating\_ips before try block
* Fix misspellings words in neutron
* Ensure arping always exits
* Updated from global requirements
* wsgi: remove explicit monkey\_patch() call
* If providers exist in neutron.conf, don't look in services conf
* test\_ovs\_dvr\_neutron\_agent: Use consistent variable names
* Nuage core plugin decomposition
* devref: consider sphinx warnings as failures
* devref: don't link to nonlocal images
* devref: fixed class name for test\_migrations autodocumentation
* devref: updated documentation for oslo-incubator
* devref: updated documentation for advanced services
* Avoid fetching network in \_commit\_port\_binding
* VMware: Router Type Extension Support
* OVS UT: Change misleading constants in veth tests
* test\_l2population: Use a fake mech driver instead of ofagent
* l2population\_rpc: Make fdb\_add\_tun/fdb\_remove\_tun more flexible
* Make nova notifier work with sessions
* Fix parameters in exception handling
* adopt namespace-less oslo imports
* Do not run neutron-ns-metadata-proxy as root on dhcp agent
* Move Floating IP processing to Router classes
* Updated from global requirements
* Improve exception handling in \_process\_router\_update()
* Cisco Nexus ML2 Vendor decomposition
* Remove versioning import of novaclient
* Remove remaining uses of passing root\_helper
* Remove root\_helper arg from sanity checks
* Enable pylint unnecessary-pass
* Enable pylint no-value-for-parameter
* Enable pylint bad-super-call
* Enable 'free' pylint checks
* Remove reference to self.services\_sync
* Fix type of exception in ml2 l2pop
* VMware NSXv: Add configuration options to nsx.ini
* Mock link local allocator write so UT doesn't write a file
* VMWare NSXv: Add configuration params to nsx.ini
* Remove error logs for a common situation (non created ipsets)
* Default route missing for IPv6 subnets in HA Router
* Unify logic that determines liveliness of DHCP agent
* fix for \_get\_external\_device\_interface\_name trace
* ML2: remove underscore from public method
* Fix static strings with labels for DVR
* Get rid of rpc to fetch fip agent port on agent
* Combining sec groups member update RPC calls
* VMWare NSXv: id fields should be nullable
* Check if routing rule exists before adding
* Remove root\_helper arg from DHCP agent
* Remove root\_helper arg from AsyncProcess
* Remove root\_helper arg from linuxbridge
* Remove root\_helper arg from SecurityGroupAgentRpc
* Moved several services into neutron.cmd.eventlet
* Monkey patch all the code inside neutron/cmd/eventlet/..
* tests: monkey patch stdlib before importing other modules
* Don't monkey patch netns\_cleanup
* Remove root\_helper arg from IpsetManager
* Revert "Add the rebinding chance in \_bind\_port\_if\_needed"
* Remove root\_helper arg from IptablesManager
* Remove root\_helper arg from external\_process
* Add a functional test that checks HA router is configured on a restarted agent
* Update midonet plugin requirements
* Stop using passed root\_helper in ip\_lib
* OVS UT: Fix some confusions between local vlan id and segmentation id
* Un-break tox for unit tests
* Fix FIP agent gw port delete based on external net
* Skip DBDuplicateEntry exception in security group creation
* Hyper-V: Fixes security groups issue
* Fix the api job
* Setup br-tun in secure fail mode to avoid broadcast storms
* Delete qg device during DVR-SNAT router deletion
* Automate host configuration for functional testing
* ML2: Hierarchical port binding
* ML2: DB changes for hierarchical port binding
* Remove RPC dependency to create FIP agent gw port
* Fix typo in bash tool
* Remove remaining root\_helper args from plugins
* Fix usage drop\_constraint in 2a1ee2fb59e0 migration
* Fix index name in downgrade 26b54cf9024d migration
* Remove root\_helper arg from linux interface
* Remove root\_helper arg from L3 Agent
* OVS DVR: Remove dead code
* Updated from global requirements
* Fix AttributeError exception for API's test\_network\_lifecycle
* Remove root\_helper arg for ovs\_lib
* Raise timeout for test\_conntrack\_disassociate\_fip
* Cleanup in keepalived tests
* Add run\_as\_root option to utils.execute
* Revert "monkey patch stdlib before importing other modules"
* Remove unused RPC methods from l3\_rpc
* Tweak mocking logic for L3 plugin tests
* Move NCS mech driver to its new home
* Added policy for lbaas v2 agent extension resource
* keepalived: use sh instead of bash for notifier scripts
* Refactor to facilitate DVR scale performance
* hacking: also catch 'import oslo.\*' imports
* Moved hacking unit test into proper location
* Stale VXLAN and GRE tunnel port/flow deletion
* Use ovsdb-api neutral column/value mappings
* Prepare to functionally test OVSDB interfaces
* NEC: Merge NEC plugin models into single module
* Remove remaining do\_delete from unit tests
* Typos fixed
* Scope state reporting rpc api using a messaging namespace
* Remove use of keepalived 'vrrp\_sync\_group' as it is unused
* Scope dvr rpc api using a messaging namespace
* Updated from global requirements
* Remove port from ovsdb after its deletion
* Add index on tenant\_id
* Remove deprecated DEFAULT.root\_helper
* Provide routes for neighbor IPv4 subnets
* OVS DVR: Use a right mac address value to compose a flow
* Refactor radvd control in the l3-agent
* monkey patch stdlib before importing other modules
* Don't crash when adding duplicate gre allocation
* Fix lack of device ownership enforcement for DVR routers
* Search in /sys/class/net for network devices
* Adopt rpc\_api devref to new oslo\_messaging namespace
* Fix minor nits with the devref's contribute section
* Remove VPN specific exception
* Correctly mock-out 'ip route...' calls in IPv6 test
* Cleanup dead code for dnsmasq
* Add mtu attributes to network model
* Add the rebinding chance in \_bind\_port\_if\_needed
* Add vlan\_transparent attribute to network model
* Check conntrack rule cleanup on floating IP disassociate
* l2-pop shouldn't notify agent about inactive ports
* Drop devstack-gate files from Neutron repo
* Use weak ref to avoid deleting fip namespace through agent
* Move DVR floating ip methods to dvr\_router
* Provide more details about testing strategies
* Add section for DevStack Integration Strategies to the DevRef
* VMware: consolidate NSX models
* Restore and fix vmware unit tests
* Move extra routes processing to router classes
* oslo: migrate to namespace-less import paths

2015.1.0b2
----------

* Fix breakage in all service repo unit tests, due to duplicate imports of exts
* Log entry when no Floating IP interface present
* Refactor logging in loop to only log debug messages once
* Nuke a useless lambda wrapper and call to iterkeys (review feedback)
* Nuke remaining service config and extensions from main repo
* Pass '--dhcp-authoritative' option to dnsmasq
* Imported Translations from Transifex
* ml2: Simplify \_process\_provider\_create
* Fix extra-dhcp-opt on stateless dhcpv6 subnet
* Updated from global requirements
* ML2: Use same port binding logic for DVR ports as non-DVR ports
* Improve robustness of network failover
* Decrease rpc timeout after agent receives SIGTERM
* Configures RADVD to send managed flag in RA for DHCP\_STATEFUL
* Make prevent\_l3\_port\_deletion handle missing port
* Backout 152195, which doesn't check the same token that it saves
* NSX DB models split, part 3 (and final)
* NSX DB models split, part 2
* Discriminate loaded extensions using their alias
* Refactor ml2 manager
* Extension moving tweaks, exceptions and extension path fix
* Log tenant ports if subnet could not be deleted
* Fixing several misspellings in neutron
* NSX DB models split, part 1
* Imported Translations from Transifex
* Enable super-on-old-class pylint check
* fixes error logging to use the right exception parent class
* Drop bw compact module for OpenDayLight
* Don't pass the port down to the floating ip processing
* Move agent.linux.utils tests to proper location
* Drop deprecated namespace for oslo.rootwrap
* Encapsulate DVR Fip namespace
* Move ha router functionality from the agent to ha\_router
* Remove duplicate logging of attribute validation errors
* Add requirements.txt file for OpenDaylight Mech Driver
* Mechanisms to move extensions and config into service repos
* Fix flake exclude matching of .\*
* Hardening unittest, make resilient to address assignment order
* Allow to request metadata proxy only with redirection
* Remove unused mocks
* Thining Arista ML2 driver from neutron tree
* Allow port mac\_address to be modified
* Removed redundant statement from l3agentscheduler
* Implements the ProcessMonitor in the l3\_agent
* Add option to remove networks from dead DHCP agents
* Thin MLNX ML2 mechanism driver and agent
* Fixing a log message in Arista L3 Service Plugin
* Not assign dynamic IPv6 address on dhcp interface
* Default security group table
* Support Extra DHCP Options for IPv4 and IPv6
* Refactor \_convert\_sgr\_to\_iptables\_rules in iptables\_firewall
* Do not check twice IP allocations for auto-address subnets
* Make the interface driver available to the router classes
* Make agent config available to the router classes
* Updated from global requirements
* Drop bin/neutron-rootwrap
* Refactor iptables rule expansion for the non ipset case
* Set locale before check dnsmasq version
* Freescale FWaaS Plugin: Update to setup.cfg
* Allow 'max\_l3\_agents\_per\_router' to be set to '0'
* test\_agent\_scheduler: Fix a misleading variable name
* Fix AttributeError when using DVRServerRpcApi
* Add abandon script from nova
* Add missing Connection.close() method
* Deleting HA router with attached port causes DB inconsistencies
* Refactor the ProcessMonitor \_exit\_handler to ProcessMonitor
* TestL2PopulationRpcTestCase: Stop loading linuxbridge mech driver
* Return 404 when executing router-list-on-l3-agent with invalid agent\_id
* VLAN support for DVR
* Fixes Hyper-V agent root\_helper issue
* Ensure ofports are converted to string before trying to use join()
* Add coverage for extra routes extension
* Add address family to 'ip rule' calls
* Add OVSDB abstract API
* Add functional tests for IptablesManager using tcp/udp
* dhcp: move dnsmasq version check to sanity\_check
* Use DVRServerRpcApi instead of a mixin
* Scope secgroup rpc api using a messaging namespace
* Add and use SecurityGroupAgentRpc
* hyperv: drop useless messaging.Target on HyperVSecurityAgent
* tests: don't spread fixtures.TempDir throughout test cases
* Extract l2pop/DVR controller logic to common method
* Imported Translations from Transifex
* attributes: Additional IP address validation
* Mention networking\_odl in README.odl
* Updated from global requirements
* Overload correctly BASEV2.\_\_table\_args\_\_
* Add notes on how to deal with stable branches
* Configure IPv6 LLADDR only on master L3 HA instance
* Do not duplicate message consumers
* Add index on db "allocated" columns
* pep8: cleaned up excludes
* Remove check\_i18n tox target
* Implements ProcessMonitor in the dhcp\_agent
* Functional test IPAM DB operation
* If router is HA, get current\_cidrs from keepalived object
* Move process monitor settings to neutron.conf AGENT section
* Drop SecurityGroupServerRpcApiMixin
* sriovnicagent: drop usage of SecurityGroupServerRpcApiMixin
* sriovnicagent: untangle SecurityGroupAgentRpcMixin
* mlnx: drop usage of SecurityGroupServerRpcApiMixin
* mlnx: untangle SecurityGroupAgentRpcMixin
* linuxbridge: drop usage of SecurityGroupServerRpcApiMixin
* linuxbridge: untangle SecurityGroupAgentRpcMixin
* Use db constraint to ensure mac address uniqueness
* Ignore 404 error and lower a warning log to info
* Reorganize OVSDB API
* Use proper capitalization for OVS table names
* Move shared metadata driver related config options
* Remove useless constant from l3 agent module
* Added test\_dvr\_router\_lifecycle to cover dvr
* Imported Translations from Transifex
* Use constants from networking\_odl project
* Initialize dist\_fip\_count after agent restart
* Fixes Multiple External Networks issue with DVR
* Replace FLOATING\_IP\_CIDR\_SUFFIX constant with utils
* tests: drop usage of SecurityGroupServerRpcApiMixin
* ovs: drop usage of SecurityGroupServerRpcApiMixin
* oneconvergence: drop usage of SecurityGroupServerRpcApiMixin
* ofagent: drop usage of SecurityGroupServerRpcApiMixin
* nec: drop usage of SecurityGroupServerRpcApiMixin
* hyperv: drop usage of SecurityGroupServerRpcApiMixin
* bigswitch: drop usage of SecurityGroupServerRpcApiMixin
* Create SecurityGroupServerRpcApi and add some docs
* Improve agent-based flat/vlan ml2 port binding failure logging
* ml2: remove stale \_filter\_nets\_l3 in get\_networks
* drop unused test rootwrap filter file
* Updated from global requirements
* SIGHUP keepalived if L3 agent restarts
* Update \_cur names to \_current in iptables\_firewall.py
* Added comments, and refactored \_add\_rule\_by\_security\_group
* Improve test coverage of dhcp agent scheduling
* Imported Translations from Transifex
* tools/split.sh: Tweak commit message
* Switch to using abc in the retargetable client
* common\_db\_mixin.py: simplify CommonDbMixin
* Fixes blocking of VRF config in Arista L3 Plugin
* Drop \_test\_rootwrap\_exec test
* Fix pylint unbalanced-tuple-unpacking warning
* Corrected singulars/plurals in iptables\_firewall.py
* Create DvrRouter and HaRouter as a sub-class of Router
* Remove unused self.sync\_progress attribute
* DHCP agent restructuring
* Move Monkey patch back to being as early as possible
* Fix outstanding failures with Neutron API job
* Disable unbalanced-tuple-unpacking
* Revert "Change transaction isolation so retry logic could work properly"
* Change transaction isolation so retry logic could work properly
* Updated from global requirements
* Refactor the \_get\_external\_device\_interface\_name method
* Refactor of floating ip processing in L3 Agent
* ML2: Driver API changes for hierarchical port binding
* Fix some assertEqual argument orders
* Don't log a warning if an iptables chain doesn't exist
* Migrate to oslo.concurrency
* Replace missing space in error message
* Clarify misleading iptables comment
* Fix missing spaces in error messages
* make delete\_router send delete\_port to core\_plugin
* VMWare-NSXv: VMWare NSXv extensions
* Dropped fixture module
* base.py: Improve exception handling
* Correct \_test\_delete\_ports\_by\_device\_id\_second\_call\_failure
* Add ovsdb-related functional tests
* VMWare-NSXv: VMWare NSXv configuration file
* Imported Translations from Transifex
* Create arping helper in ip\_lib
* Initial thin ML2 mechanism driver
* Enable adding new tag with options
* Call on dhcp-agent DhcpLocalProcess.restart() breaks dhcp
* Fixs shared networks in Arista ML2 driver
* Move agent cleanup scripts to cmd module
* Fix IP allocation for multiple slaac subnets
* tests: don't restore stopped mock that is set in setUp()
* misc-sanity-checks.sh: Some cleanups
* Log iptables rules in a readable format
* Remove main alias for bw compat with vpn agent
* Midonet plugin decomposition
* Fix topic for provider security group update
* Specify prefix length for IPv6 subnets
* Service split: cleaned up setup.cfg
* VMWare NSXv DB model bugfix
* Speed up initial L3 full sync time
* hacking: enable H238 (old style class declaration, use new style)
* hacking: enable W292 (no newline at end of file)
* Update hacking to 0.10
* Use "if dict.get(key):" instead "if key in dict and dict[key]:"
* Rename qexception->nexception
* Fix AttributeError on check\_foreign\_keys in functional job
* Catch StaleDataError in update\_device\_down
* Code improvement in type\_vxlan.py and type\_gre.py files
* Ensure config directory created before updating leases
* Allow IptablesManager to manage mangle table
* Fix IPv6 Subnet Slaac Check
* Imported Translations from Transifex
* Move non-bridge-related OVSBridge methods to BaseOVS
* Move metadata agent entry to its own file
* Run only one instance of Nuage sync cycle at a time
* Updated from global requirements
* Scope metadata rpc api using a messaging namespace
* Provide doc string pointers for the dhcp agent rpc api
* Remove DBDuplicateEntry columns check
* Limit permission change
* Break out config and entry point out of l3/agent file
* Validate legacy router services before migration
* Clarify dnsmasq version check failure message
* Update comment about metadata\_proxy\_shared\_secret config
* Remove redundant tunnel ids from ovs agent
* Add index generation for IPv6 rules for DVR
* Correct l3-agent iptables rule for metadata proxy
* Fix UT for L2pop test\_get\_agent\_ports\_no\_data()
* Move postcommit ops out of transaction for bulk
* Reset policies after RESOURCE\_ATTRIBUTE\_MAP is populated
* Remove SELECT FOR UPDATE from delete\_network and delete\_subnet
* Bump minimal dnsmasq version to 2.67
* Make L3 HA VIPs ordering consistent in keepalived.conf
* Add Process class helper to manage processes with namespace
* Make lb mechanism driver use enable\_security\_group flag
* Catch PortNotFound and SubnetNotFound during network\_delete
* HA for DVR - schema migration and change
* Revert "Revert "Add metadata proxy L3 agent driver""
* moving vxlan module check to sanity checks and making practical
* Drop functional/contrib directory
* refactor l3-agent to include dvr.py
* Validate IPv6 subnet while associating to Router
* VMWare-NSXv: VMWare NSXv database models
* Deal with PEP-0476 certificate chaining checking
* Reduce duplicate code in test\_iptables\_manager
* Add support for retargetable functional api testing
* print error when no match mapping found in check\_segment\_for\_agent
* Tweak gate hooks scripts to handle both functional and api jobs
* Replace mention of nose with nose2 in devref
* Skip adding ips from non dhcp enabled subnets to hosts file
* Add developer documentation for plugins/drivers contributions
* Deletes floating agent gw port on disassociate
* Add help text for 'host' parameter in neutron.conf file
* Updated keystone\_admin conf section to reflect changes in middleware
* Removed spurious check for ip version
* Ensure test\_metaplugin handles random hashseeds
* Ignore non-existent ports during OVS intf list
* [apic ml2] Bind ports regardless of the owner
* Improve unit test coverage for Ml2 db.py
* Delete the console scripts for lbaas and vpnaas
* Confusing message deleting default security group
* Enable the "not-callable" pylint check
* ovs\_dvr: Use lazy logging interpolation
* Add a constant for router interface device owners
* Stale VXLAN & GRE tunnel endpoint deletion from DB
* Add support for flat networks in SRIOV Mechanism Driver
* Retry on unassigned ofport instead of treating it as a failure
* VMware: fix security group check on port create
* Eventlet green threads not released back to pool
* Don't unnecessarily loop through all ports/interfaces
* Set type=internal as part of port creation
* Fix DVR flow problems for IPv6 subnet
* Allow to specify IP address of floating ip
* Do not count dvr agents while creating HA ports
* csr1kv\_hd\_driver: Improve exception handling
* Remove \_delete\_port\_security\_group\_bindings from delete\_port
* Remove useless parameter from l3\_dvr\_db.py
* Clean-up sanity checks done via shell scripts
* Do not run neutron-ns-metadata-proxy as root on L3 agent
* Correct invalid indentation in is\_dvr\_serviced
* Add validation for the dvr router l3agent binding
* Fixes spelling error
* get\_binary\_name should returns strings without spaces
* validate L3 HA min/max \_l3\_agents\_per\_router
* Enable pylint checks for "anomalous" string escapes
* Tighten dnsmasq version regex
* Remove unnecessary regex grouping
* Combine author\_tag and log\_translation\_hint regexes
* ML2 UT: Fix incorrect mock return value
* ipv6: set OtherConfig flag for DHCPv6 stateless subnets
* PLUMgrid plugin: Fix for delete subnet with admin context
* brocade: Use lazy logging interpolation
* linuxbridge: Use lazy logging interpolation
* embrane: Use lazy logging interpolation
* bigswitch: Use lazy logging interpolation
* Use lazy logging interpolation
* Cisco: logging incorrectly called with (fmt, arg) tuple
* ml2: remove superfluous %s in LOG.debug() format
* Fix typo'd format parameter in midonet\_lib.py
* Update L3 agent drivers singletons to look at new agent
* Prevent symlinks to be added to the tree
* Copy the contrib directory instead of moving it
* Revert "Add metadata proxy L3 agent driver"
* Scope dhcp rpc api using a messaging namespace
* Validate local\_ip for Linuxbridge agent
* Allow setting a tenant router's external IP
* Remove NSX 'service' plugin
* Imported Translations from Transifex
* Move DB TestModelsMigrations from unit to functional
* tests: drop unit tests that only check default configuration values
* Backward compatibility for advanced services
* Update heal\_script for alembic 0.7.1

2015.1.0b1
----------

* Add metadata proxy L3 agent driver
* Updated from global requirements
* Move contrib directory to base test directory
* Add OVS status and fix OVS crash
* Option for root\_helper when checking namespace
* Cleanup req\_format in test\_api\_v2\_resource
* Imported Translations from Transifex
* Cisco: unsupported format character in log format
* Correct arguments to logging function
* Support 'alive' filter for get\_agents() in agents\_db
* Minor lbaasv2 things from the feature branch, needed in neutron
* Advanced services support in neutron-db-manage
* Remove locking from network and subnet delete op
* Removed unused iso8601 dependency
* Avoid unnecessary explicit str() conversion around exceptions
* Add functional test for l3-agent metadata proxy
* Remove mlnx plugin
* Set timeout for functional job
* Enable test\_migration
* Fix neutron hang for IPv6 allocation pool update
* tests: initialize admin context after super().setUp call
* Improve performance of get\_active\_networks\_info
* Fixed test test\_update\_port\_security\_off\_address\_pairs
* openvswitch/ofagent: Remove OVS.enable\_tunneling option
* Imported Translations from Transifex
* Remove unused dependencies
* Generate testr\_results.html for neutron functional job
* L3 Agent restructure - observer hierarchy
* Replace non-ovs\_lib calls of run\_vsctl with libary functions
* Don't restore stopped mock that is initialized in setUp()
* Separate wait\_until to standalone function
* Imported Translations from Transifex
* Mock up time.sleep to avoid unnecessary wait in test\_ovs\_tunnel
* Catch duplicate errors scheduling SNAT service
* Fix for KeyError: 'gw\_port\_host' on l3\_agent
* Migrate to oslo.context
* Have L3 agent catch the correct exception
* Not nova but neutron
* Remove broad exception catch from periodic\_sync\_routers\_task
* Fix race condition in ProcessMonitor
* Updated from global requirements
* Refactor process\_router method in L3 agent
* Switch to using subunit-trace from tempest-lib
* Move classes out of l3\_agent.py
* Prettify tox output for functional tests
* Services split, pass 2
* Fix IPv6 RA security group rule for DVR
* Imported Translations from Transifex
* ofa\_test\_base: Fix NoSuchOptError in UT
* Add lbaasv2 extension to Neutron for REST refactor
* Remove TODO for H404
* Update rpc\_api docs with example version update
* Auto allocate gateway\_ip even for SLAAC subnets
* Updated from global requirements
* Split services code out of Neutron, pass 1
* Use comments rather than no-op string statements
* Fix AttributeError during startup of ovs agent in DVR mode
* Enforce log hints
* Disallow log hints in LOG.debug
* Reduce code duplication in test\_linux\_dhcp
* Print version info at start
* Enforce log hints in ofagent and oneconvergence
* Make sudo check in ip\_lib.IpNetnsCommand.execute optional
* Move set\_override('root\_helper', ...) to base functional class
* Imported Translations from Transifex
* IpsetManager refactoring
* Update i18n translation for NEC plugin log msg's
* return the dict of port when no sec-group involved
* Imported Translations from Transifex
* Update i18n translation for IBM plugin log msg's
* Workflow documentation is now in infra-manual
* tox.ini: Prevent casual addition of bash dependency
* Updated from global requirements
* Remove RpcCallback class
* Convert several uses of RpcCallback
* Fix up an old RpcProxy assumption
* Remove RpcProxy class
* Cleanup recent generalization in post mortem debugger
* radvd: pass -m syslog to avoid thread lock for radvd 2.0+
* Get rid of py26 references: OrderedDict, httplib, xml testing
* Imported Translations from Transifex
* Fix enable\_metadata\_network flag
* Fix program name in --version output
* Enforce log hints in opencontrail
* Update i18n translation for Metaplugin plugin
* Update i18n translation for Brocade plugin log msg's
* Update i18n translation for Nuage plugin
* Update i18n translation for Embrane plugin
* Enforce log hints in neutron.plugins.plumgrid
* Remove ovs-vsctl call from OVSInterfaceDriver
* Update i18n translation for Midonet plugin
* Enforce log hints in neutron.plugins.sriovnicagent
* Enforce log hints in neutron.plugins.hyperv
* Imported Translations from Transifex
* Drop RpcProxy usage from DhcpAgentNotifyAPI
* Updated the README.rst
* Fix base test class for functional api testing
* Use oslo function for parsing bool from env var
* Don't block on rpc calls in unit tests
* Refactor test\_migration
* Strip square brackets from IPv6 addresses
* Update i18n translation for BigSwitch plugin log msg's
* Imported Translations from Transifex
* pretty\_tox.sh: Portablity improvement
* iptables\_manager: Fix get\_binary\_name for eventlet
* test\_dhcp\_agent: Fix no-op tests
* Drop old code from SecurityGroupAgentRpcApiMixin
* Drop RpcProxy usage from ml2 AgentNotifierApi
* Update i18n translation for Mellanox plugin and agent log msg's
* Drop RpcProxy usage from L3AgentNotifyAPI
* Simplify L3 HA unit test structure
* Update i18n translation for VMware NSX plugin log msg's
* Alter execute\_alembic\_command() to not assume all commands
* hacking: Check if correct log markers are used
* Fix hostname validation for nameservers
* Removed python2.6 rootwrap filters
* Imported Translations from Transifex
* MeteringPluginRpc: Fix crash in periodic\_task
* Enable undefined-loop-variable pylint check
* Remove unused variables from get\_devices\_details\_list
* Change description of default security group
* Fix incorrect exception order in \_execute\_request
* Migrate to oslo.i18n
* Migrate to oslo.middleware
* Remove unused xml constants
* Check metadata iptables chains during functional test
* Drop RpcProxy usage from MeteringAgentNotifyAPI
* Drop RpcProxy usage from l2population code
* Drop RpcProxy usage from cisco apic ml2 plugin
* Drop RpcProxy usage from oneconvergence plugin
* Synced processutils and periodic\_task modules
* Migrate to oslo.utils
* Fix floating-ips in error state in dvr mode
* Reject trailing whitespaces in IP address
* Imported Translations from Transifex
* CSCO:Tenants not to access unshared n/w profiles
* Drop sudo requirement from a unit test
* Remove Python 2.6 classifier
* Update i18n translation for Cisco plugins and cfg agent log msg's
* Remove ryu plugin
* Imported Translations from Transifex
* Drop RpcProxy usage from nec plugin
* Drop RpcProxy usage from mlnx plugin
* Drop RpcProxy usage from ibm plugin
* Drop RpcProxy usage from hyperv plugin
* Drop RpcProxy usage from cisco.l3
* Drop RpcProxy usage from cisco.cfg\_agent
* Drop RpcProxy usage from brocade plugin
* Update rally-jobs files
* Test HA router failover
* Imported Translations from Transifex
* Update i18n translation for linuxbridge log msg's
* Update i18n translation for openvswitch log msg's
* Update i18n translation for ML2 plugin log msg's
* Updated from global requirements
* Imported Translations from Transifex
* Enforce log hints in neutron.services
* Enforce log hints in neutron.services.metering
* Fix metadata proxy start problem for v6-v4 network
* Fix AttributeError in RPC code for DVR
* Drop RpcProxy usage from bigswitch plugin
* Drop RpcProxy usage from VPNaaS code
* Drop RpcProxy usage from metering\_agent
* Fix context.elevated
* Tighten up try/except block around rpc call
* Implement migration of legacy routers to distributed
* run\_tests.sh OS X script fixes
* Eliminate unnecessary indirection in L3 agent
* Show progress output while running unit tests
* Drop RpcProxy usage from LBaaS code
* Enforce log hints in neutron.services.loadbalancer
* Enforce log hints in neutron.services.firewall
* Enforce log hints in neutron.services.l3\_router
* enable H401 hacking check
* enable H237 check
* Updated from global requirements
* Check for default sec-group made case insensitive
* Update i18n translation for neutron.server/scheduler log msg's
* Update i18n translation for neutron.notifiers log msg's
* Update i18n translation for neutron.common/debug log msg's
* Imported Translations from Transifex
* ofagent: Remove obsolete bridge\_mappings (plugin side)
* Delete FIP namespace when last VM is deleted
* Fix a race condition adding a security group rule
* Drop RpcProxy usage from FWaaS code
* Drop RpcProxy usage from neutron.agent.rpc.PluginApi
* Fix a copy/pasted test mistake
* Drop test code copied from nova
* Drop several uses of RpcCallback
* Add some basic rpc api docs
* Drop RpcCallback usage from DhcpRpcCallback
* Drop RpcProxy usage from PluginReportStateAPI
* Fix hostname regex pattern
* Catch NoResultFound in \_get\_policy\_profile\_by\_name
* Validate loadbalancing method when updating a pool
* Update i18n translation for neutron.api log msg's
* Catch DBReferenceError exception during binding a router
* Enable default SNAT from networks connected to a router indirectly
* Imported Translations from Transifex
* BSN: Optimistic locking strategy for consistency
* BSN: include missing data in floating IP call
* ofagent: Remove obsolete bridge\_mappings (agent side)
* NSX: Validate gateway device list against DB
* Drop RpcProxy usage from MetadataPluginApi
* Drop usage of RpcProxy from L3PluginApi
* Prevent an iteration through ports on IPv6 slaac
* Use a string multiplier instead of 59 repetitions
* Convert all incoming protocol numbers to string
* Updated from global requirements
* Correct raw table regex in test\_security\_groups\_rpc
* BSN: Add network to ext\_gw\_info sent to backend
* BSN: Set inconsistency record on delete failure
* Fix PYTHONHASHSEED bugs in test\_security\_groups\_rpc
* Subnet delete for IPv6 SLAAC should not require prior port disassoc
* Fix client side versions in dhcp rpc API
* Drop usage of RpcProxy from DhcpPluginApi
* linuxbridge-agent: make vxlan unicast check more efficent
* Moved out common testcases from test\_type\_vxlan.py
* Update i18n translation for neutron.extension log msg's
* Update i18n translation for neutron.db log msg's
* Update i18n translation for neutron.cmd log msg's
* Update i18n translation for neutron.agents log msg's
* enable F812 check for flake8
* enable F811 check for flake8
* Decrease policy logging verbosity
* Support pudb as a different post mortem debugger
* Cleanup and refactor methods in unit/test\_security\_groups\_rpc
* switch to oslo.serialization
* Add rootwrap filters for ofagent
* Updated policy module from oslo-incubator
* Resolving some spelling mistakes
* Fix for FIPs duplicated across hosts for DVR
* Drop neutron.common.rpc.MessagingTimeout
* Remove neutron.common.rpc.RemoteError
* Remove neutron.common.rpc.RPCException
* Remove useless return
* Cisco VPNaaS and L3 router plugin integration
* Fix missing allowed command in openvswitch xenapi agent
* fix event\_send for re-assign floating ip
* Remove openvswitch core plugin entry point
* rootwrap config files reference deleted quantum binaries
* Fix L3 HA network creation to allow user to create router
* Update default value for agent\_required attribute
* SRIOV: Fix Wrong Product ID for Intel NIC example
* Imported Translations from Transifex
* Updated from global requirements
* Purge use of "PRED and A or B" poor-mans-ternary
* Include call to delete\_subnet from delete\_network at DB level
* Use correct base class for unit tests for ML2 drivers
* Replace "nova" entries in iptables\_manager with "neutron"
* Drop and recreate FK if adding new PK to routerl3bindings
* Imported Translations from Transifex
* Remove duplicate ensure\_remove\_chain method in iptables\_manager
* ML2: fix file permissions
* Fix sneaky copypaste typo in ovs agent scheduler test
* Make L2 DVR Agent start successfully without an active neutron server
* Detect if iproute2 support SR-IOV commands
* Use stop() method on MessageHandlingServer
* Rename constant to a more appropriate name
* Big Switch: Fix SSL version on get\_server\_cert
* Check for concurrent port binding deletion before binding the port
* Imported Translations from Transifex
* Batch ports from security groups RPC handler
* Fix incorrect int/tuple comparison during binary search
* Big Switch: Send notification after port update
* Allow to add router interface to IPv6 SLAAC network
* ML2 Cisco Nexus MD - not overwriting existing config
* Reorder operations in (l3\_dvr) update floating ip
* Use RPC instead of neutron client in metadata agent
* Add assertion to test\_page\_reverse method
* Adds an option to enable broadcast replies to Dnsmasq
* Add advsvc role to neutron policy file
* NSX: allow multiple networks with same vlan on different phy\_net
* NSX: Fix foreign key constraint delete provider network
* Imported Translations from Transifex
* Fix 'Length too long' error in neutron-dsvm-functional tests
* Remove use\_namespaces from RouterInfo Property
* Fix handling of CIDR in allowed address pairs
* Updated from global requirements
* Remove XML support
* enable F402 check for flake8
* enable E713 in pep8 tests
* NEC plugin: Allow to apply Packet filter on OFC router interface
* \_update\_router\_db: don't hold open transactions
* Big Switch: Switch to TLSv1 in server manager
* Only resync DHCP for a particular network when their is a failure
* Validate network config (vlan)
* Validate local\_ip for OVS agent is actual ip address
* Imported Translations from Transifex
* Hyper-V: Remove useless use of "else" clause on for loop
* Enable no-name-in-module pylint check
* Move disabling of metadata and ipv6\_ra to \_destroy\_router\_namespace
* Updated from global requirements
* Adds macvtap support
* Remove duplicate import of constants module
* Switch run-time import to using importutils.import\_module
* Enable assignment-from-no-return pylint check
* tox.ini: Avoid using bash where unnecessary
* l2population\_rpc: docstring improvements
* Fix race condition on processing DVR floating IPs
* neutron-db-manage finds automatically config file
* Ensure test\_agent\_manager handles random hashseeds
* Ensure ofagent unit tests handles random hashseeds
* Moves the HA resource creations outside of transaction
* Modify docstring on send\_delete\_port\_request in N1kv plugin
* Empty files should not contain copyright or license
* Remove superfluous except/re-raise
* Remove single occurrence of lost-exception warning
* Schema enhancement to support MultiSegment Network
* Remove redundant initialization and check from DVR RPC mixin
* Improve performance of security group DB query
* Optimize query in \_select\_dhcp\_ips\_for\_network\_ids
* Updated cache module and its dependencies
* Updated service.py and its dependencies
* Updated fileutils and its dependencies
* Cisco N1kv: Fix update network profile for add tenants
* DB: Only ask for MAC instead of entire port
* Only fetch port\_id from SG binding table
* NSX: Make conn\_idle\_timeout configurable
* nsx plugin: keep old priority when reconnecting bad connection
* l3\_agent: avoid name conflict with context
* Guard against concurrent port removal in DVR
* Refactor l2\_pop code to pass mac/ip info more readably
* Fix KeyError in dhcp\_rpc when plugin.port\_update raise exception
* Refactor \_make\_subnet\_dict to avoid issuing unnecessary queries
* openvswitch: Remove no longer used options
* VPNaaS Cisco unit test clean-up
* Call DVR VMARP notify outside of transaction

2014.2
------

* remove E251 exemption from pep8 check
* Race for l2pop when ports go up/down on same host
* Catch exceptions in router rescheduler
* Minor: remove unnecessary intermediate variable
* Handle unused set\_context in L3NatTestCaseMixin.floatingip\_with\_assoc
* Use EUI64 for IPv6 SLAAC when subnet is specified
* Arista L3 Ops is success if it is successful on one peer
* Add unique constraints in IPAvailabilityRange
* Remove two sets that are not referenced
* Update VPN logging to use new i18n functions
* mock.assert\_called\_once() is not a valid method
* Check for VPN Objects when deleting interfaces
* Compare subnet length as well when deleting DHCP entry
* Add pylint tox environment and disable all existing warnings
* Updated from global requirements
* update the relative path of api\_extensions\_path
* Reduce security group db calls to neutron server
* Ignore top-level hidden dirs/files by default
* Remove some duplicate unit tests
* NSX: drop support to deprecated dist-router extension
* Execute udevadm on other linux installs
* Avoid constructing a RouterInfo object to get namespace name
* Drop sslutils and versionutils modules
* Imported Translations from Transifex
* Remove an argument that is never used
* Refactor \_process\_routers to handle a single router
* Add Juno release milestone
* Add database relationship between router and ports
* Fix L2 agent does not remove unused ipset set

2014.2.rc2
----------

* Add Juno release milestone
* Add database relationship between router and ports
* Disable PUT for IPv6 subnet attributes
* Skip IPv6 Tests in the OpenContrail plugin
* Remove all\_routers argument from \_process\_routers
* update ml2\_migration to reflect optional methods
* Disable PUT for IPv6 subnet attributes
* Do not assume order of lvm.tun\_ofports set elements
* Skip IPv6 Tests in the OpenContrail plugin
* Removed kombu from requirements
* Updated from global requirements
* Imported Translations from Transifex
* Imported Translations from Transifex
* Remove two sets that are not referenced
* Forbid update of HA property of routers
* Forbid update of HA property of routers
* Teach DHCP Agent about DVR router interfaces
* Updated from global requirements
* Allow reading a tenant router's external IP
* Raise exception if ipv6 prefix is inappropriate for address mode
* Retry getting the list of service plugins
* Add missing methods to NoopFirewallDriver
* Don't fail when trying to unbind a router
* Modify the ProcessMonitor class to have one less config parameter
* Big Switch: Don't clear hash before sync
* Remove sslutils from openstack.common
* Divide \_cleanup\_namespaces for easy extensibility
* L3 Agent should generate ns\_name in a single place
* Add comments to iptables rules to help debugging
* nit : missing a "%s" in a log message
* L3 agent should always use a unique CONF object
* Iterate over same port\_id if more than one exists
* Fix setup of Neutron core plugin in VPNaaS UT

2014.2.rc1
----------

* remove openvswitch plugin
* Fix pid file location to avoid I->J changes that break metadata
* Don't fail when trying to unbind a router
* remove linuxbridge plugin
* Allow reading a tenant router's external IP
* Fix sleep function call
* Add admin tenant name to nova notifier
* ML2: move L3 cleanup out of network transaction
* Open Kilo development
* ML2 Cisco Nexus MD: Fix UT to send one create vlan message
* Implement ModelsMigrationsSync test from oslo.db
* Imported Translations from Transifex
* Update migration scripts to support DB2
* Do not assume order of report list elements
* Disallow unsharing used firewall policy
* Imported Translations from Transifex
* Add missing methods to NoopFirewallDriver
* Raise exception if ipv6 prefix is inappropriate for address mode
* Fix broken port query in Extraroute test case
* Revert "Cleanup floatingips also on router delete"
* fix dvr snat bindings for external-gw-clear
* Fix quota limit range validator
* Remove default dictionary from function def
* Fix KeyError when getting secgroup info for ports
* Create DHCP port for IPv6 subnet
* Deletes floating ip related connection states
* Do not lookup l3-agent for floating IP if host=None, dvr issue
* Remove RPC notification from transaction in create/update port
* Do not assume order of body and tags elements
* Remove the translation tag for debug level logs in vmware plugin
* Retry getting the list of service plugins
* Fix entrypoint of OneConvergencePlugin plugin
* Forbid regular users to reset admin-only attrs to default values
* Finish small unit test refactor of API v2 tests
* Security groups: prevent race for default security group creation
* Stop admin using other tenants unshared rules
* Eliminate OrderedDict from test\_api\_v2.py
* Mock out all RPC calls with a fixture
* Add logging for enforced policy rules
* Imported Translations from Transifex
* Remove unnecessary \_make\_port function in BSN UTs
* ofagent: Drop log level of tenant-triggerable events
* Set vif\_details to reflect enable\_security\_group
* Use dict\_extend\_functions to populate provider network attributes
* Fix foreign key constraint error on ml2\_dvr\_port\_bindings
* Some clean up of code I'm preparing to modify
* Indicate the begin and end of the sync process to EOS
* DVR to delete router namespaces for service ports
* Do not assume order of device\_ids set elements
* Fix 500 error on retrieving metadata by invalid URI
* Only setup dhcp interface if dhcp is not active on network
* HA routers master state now distributed amongst agents
* Rework and enable VPNaaS UT for Cisco CSR REST
* Update URL of Ryu official site in ofagent README files
* Set dsvm-functional job to use system packages
* Delete a broken subnet delete unit test
* Fix to delete user and group association in Nuage Plugin
* Deletes FIP agent gw port when last VM is deleted
* Delete DB records instead of tables to speedup UT
* Stop exception log in Big Switch unit tests
* Separate Configuration from Freescale SDN ML2 mechanism Driver
* NSX plugin: set VNIC\_TYPE port binding attribute
* Access correct key for template name
* ofagent: Ignore unknown l2pop entry removals
* Neutron metering does not check overlap ip range
* Rename workers to api\_workers and simplify code
* Fix DVR to service DHCP Ports
* Tunnel ID range validation for VXLAN/GRE networks
* Remove @author(s) from copyright statements
* BSN: Add context to backend request for debugging
* Don't create unused ipset chain
* Imported Translations from Transifex
* Avoid an extra database query in schedule\_snat\_router
* Add HA support to the l3 agent
* Stop ignoring 400 errors returned by ODL
* Fix a test\_db\_plugin unit test side\_effect usage
* Imported Translations from Transifex
* Fix KeyError on missing gw\_port\_host for L3 agent in DVR mode
* Stop using intersphinx
* Updated from global requirements
* Cisco N1kv: Remove vmnetwork delete REST call on last port delete
* Remove the Cisco Nexus monolithic plugin
* L3 Metering label as shared
* Check for ports in subnet before deleting it from Nuage VSD
* ofagent: Fix a possible crash in arp responder
* Add a new scheduler for the l3 HA
* Add functional testing to ipset\_manager
* Properly handle empty before/after notifications in l2pop code
* Remove logic for conditional migrations
* Make Juno migrations config independent
* Introduce havana initial state
* Adds ipset support for Security Groups
* Refactor l3\_agent.process\_router\_floating\_ip\_addresses
* Cleanup floatingips also on router delete
* use TRUE in SQL for boolean var
* Remove faulty .assert\_has\_calls([])
* Fail on None before iteration attempt
* Imported Translations from Transifex
* ofagent: Remove broken XenAPI support
* Passing admin tenant name to EOS
* Fix for floating ip association and deletion
* BSN: Allow concurrent reads to consistency DB
* Remove useless check in \_rpc\_update\_firewall
* Use renamed \_fail\_second\_call() in cisco nexus tests
* Add L3 VRRP HA base classes
* Allow DHCPv6 reply from server to client
* Don't allow user to set firewall rule with port and no protocol
* Added TAP\_DEVICE\_PREFIX info to common/constants
* Fix comments in api.rpc.handlers
* ofagent: Clean up logging
* UTs: Disable auto deletion of ports/subnets/nets
* Remove second call to get\_subnets in delete\_subnet
* Changes to support FWaaS in a DVR based environment
* Imported Translations from Transifex
* Remove hints from schedule\_router
* Call unbind\_snat\_servicenode from schedule router
* NSX: Correct allowed\_address\_pair return value on create\_port
* Add the unit tests for ml2.rpc module
* Neutron should not use the neutronclient utils module for import\_class
* Add unit-test assert to check dict is superset of dict
* Pythonified sanity\_check.all\_tests\_passed
* Removed direct access to MessagingServer
* Remove subnet\_id from check\_ports\_exist\_on\_l3agent
* Add requests\_mock to test-requirements.txt
* Removed kombu from requirements
* Fix metadata agent's auth info caching
* Throw exception instances instead of classes
* Add scheduler unit tests to enable bug fixes and refactoring
* Fix AttributeError when setting external gateway on DVR router
* Stop tracking connections in DVR FIP Namespace
* Fixes formatting for debug output in neutron/agent/l3\_agent.py
* Avoid testing code duplication which introduced testing bugs
* Supply missing cisco\_cfg\_agent.ini file
* Reset IPv6 detection flag after IPv6 tests
* Remove unused arg to config.setup\_logging()
* Updated from global requirements
* Revert "Skip functional l3 agent test"

2014.2.b3
---------

* Fix leftover Timeout effecting most eventlet calls
* shared policy shouldn't have unshared rules
* ofagent: Remove @author tags and update copyright notices
* Work toward Python 3.4 support and testing
* Cleanup rename of get\_compute\_ports\_on\_host\_by\_subnet
* Revert "Cisco DFA ML2 Mechanism Driver"
* Refactor security group rpc call
* Avoid auto-scheduling for distributed routers
* Fix interface IP address for DVR with gateway
* BSN: Bind external ports in ML2 driver
* Remove SELECT FOR UPDATE use in delete\_firewall
* Big Switch: Retry on 503 errors from backend
* Remove absolute path in KillFilter for metadata-proxy
* Implements sync mechanism between Neutron and Nuage VSD
* ofagent: Implement physical\_interface\_mappings
* ofagent: Enable local arp responder for TYPE\_LOCAL
* ofagent: Enable local arp responder for TYPE\_FLAT
* Implements ProcessMonitor to watch over external processes
* Skip functional l3 agent test
* ofagent: Local arp responder for VLAN
* Prevent SystemExits when running tests
* Big Switch: Separate L3 functions into L3 service
* Apic drivers enhancements (second approach): Topology
* Big Switch: Bind IVS ports in ML2 driver
* Add functional test for IptablesManager
* Clarify message when no probes are cleared
* Remove reference to cisco\_cfg\_agent.ini from setup.cfg again
* Fix a bug in Mellanox plugin RPC caused by secgroup RPC refactoring
* Don't spawn metadata-proxy for non-isolated nets
* l2pop: Allow network types overridable
* ML2: Fix release of network segments to allocation pools
* Fix a recent ipv6 UT regression
* Imported Translations from Transifex
* Add endpoint\_type parameter to MetaInterfaceDriver
* Remove chain for correct router during update\_routers()
* ofagent: Enable local arp responder for local VMs
* ofagent: merge br-tun into br-int
* Apic drivers enhancements (second approach): Sync
* Apic drivers enhancements (second approach): L3 refactor
* ML2 Type Driver refactor part 2
* Adds router service plugin for CSR1kv
* Introduces a keepalived manager for HA
* Support for extensions in ML2
* Cisco DFA ML2 Mechanism Driver
* Improve some plugins help strings
* Provide a quick way to run flake8
* Apic drivers enhancements (second approach): L2 refactor
* Make SecurityGroupsRpcCallback a separate callback class
* Subnets with prefix length 0 are invalid
* Adding mechanism driver in ML2 plugin for Nuage Networks
* Fix state\_path in tests
* Add functional test for l3\_agent
* remove explicit include of the ovs plugin
* NSX: log request body to NSX as debug
* Datacenter moid should not be tuple
* Remove ovs dependency in embrane plugin
* Layer 3 service plugin to support hardware based routing
* Remove binding:profile update from Mellanox ML2 MD
* Remove old policies from policy.json
* Apic drivers enhancements (second approach): Backend
* Make DvrServerRpcCallback a separate callback class
* Make DhcpRpcCallback a separate callback class
* Adding support of DNS nameserver and Host routes for the Nuage Plugin
* Block downgrade from icehouse to havana
* Use lockutils module for tox functional env
* Do not use auto\_schedule\_routers to add router to agent
* Fix func job hook script permission problems
* Check for IPv6 file before reading
* Remove SELECT FOR UPDATE use in update\_firewall
* Fix l3 agent scheduling logic to avoid unwanted failures
* Fix InvalidRequestError in auto\_schedule\_routers
* Fix incorrect number of args to string format
* Add support for provider-network extension in nuage Plugin
* Make L3RpcCallback a separate callback class
* Cisco VPN with in-band CSR (interim solution)
* Inline "for val in [ref]" statements
* Minor refactoring for add\_router\_to\_l3\_agent
* Predictable iptables chains output order
* Prefer "val !=/== ref" over "val (not) in [ref]" in conditions
* Heal script: Drop fks before operating on columns
* Fixed template of IPsecSiteConnectionNotFound message
* Fix DVR to service LBaaS VIP Ports
* Refactor test\_type\_gre/vxlan to reduce duplicate code
* Fix heal\_script for MySQL specifics
* Make log level in linux.utils.execute configurable
* Imported Translations from Transifex
* Networks are not scheduled to DHCP agents for Cisco N1KV plugin
* ext-gw update on dvr router improperly handled by l3-agent
* metering driver default value is different in code and config file
* Fix for floatingip-delete not removing fip\_gw port
* Increase the default poll duration for Cisco n1kv
* Fix IpNetnsCommand to execute without root\_wrapper when no netns
* Increase ovsdb\_monitor.SimpleInterfaceMonitor start timeout
* Change autogenerate to be unconditional
* Remove status initialization from plugin's create\_firewall
* Set firewall state to CREATED when dealing with DVR
* Add template attr. for subnet, router create in Nuage plugin
* Implement ip\_lib.device\_exists\_with\_ip\_mac
* Add \_store\_ip\_allocation method
* Updated from global requirements
* Refactor plugin setup helpers out of test.base
* Raise proper exception in case duplicate ipv6 address is allocated
* Do not explicitly set mysql\_engine
* Fixes Hyper-V agent issue on Hyper-V 2008 R2
* Removing sorted() function from assertEqual()
* Add hook scripts for the functional infra job
* ML2 Type driver refactor part 1
* Minor refactoring of auto\_schedule\_routers
* Add ipv6 forwarding for router namespaces
* Refresh rpc\_backend values in unit tests to those from oslo.messaging
* Add unit tests covering single operations to ODL
* One Convergence: Skip all tests with 'v6' in name
* VPNaaS: Enable UT cases with newer oslo.messaging
* Do not log WARN messages about lack of L3 agents for DVR routers
* Add specific docs build option to tox
* Fix policy rules for adding and removing router interfaces
* Refactor type\_tunnel/gre/vxlan to reduce duplicate code
* Join tables in query for down L3 agents
* Rename range to avoid shadowing the builtin
* Fixes Hyper-V issue due to ML2 RPC versioning
* A10 Networks LBaaS v1 Driver
* Assign Cisco nw profile to multi-tenants in single request
* Remove unused network parameter from \_allocate\_ips\_for\_port
* corrects the typos in l3\_router\_plugin's comments
* Support Stateful and Stateless DHCPv6 by dnsmasq
* Implements securitygroup extension for nuage plugin
* Fix bigswitch setup.cfg lines
* Arista Layer 3 Sevice Plugin
* Add config for visibility of cisco-policy-profile
* Ensure ip6tables are used only if ipv6 is enabled in kernel
* Remove invalid or useless initialization in test\_type\_vxlan
* Fix migration set\_length\_of\_description\_field\_metering
* Set InnoDB engine for all existing tables
* Use oslo.db create\_engine instead of SQLAlchemy
* Big Switch: Check for 'id' in port before lookup
* Reorder operations in create\_vip
* Send HTTP exceptions in the format expected by neutronclient
* Change nexus\_dict to accept port lists
* Update DVR Binding when router\_id changes
* Imported Translations from Transifex
* Remove auto-generation of db schema from models at startup
* Cisco N1kv plugin to send subtype on network profile creation
* Implement namespace cleanup for new DVR namespaces
* Fix config option names in ml2\_conf\_sriov.ini
* NSX: Avoid floating IP status reset
* correct getLoggers to use \_\_name\_\_ in code
* Skip FWaaS config mismatch check if RPC method is unsupported
* NSX: lift restriction on DVR update
* Updated from global requirements
* Use jsonutils instead of stdlib json
* Remove INACTIVE status from FWaaS
* Ignore http\_proxy while connecting to test WSGI server
* Fix interface add for dvr with gateway
* l2pop: get\_agent\_ports: Don't yield (None, {})
* ML2: Make get\_device\_details report mac address as well
* Delete DVR namespaces on node after removing last VM
* Fix PortNotFound error during update\_device\_up for DVR
* Option to remove routers from dead l3 agents
* Remove SELECT FOR UPDATE use in ML2 tunnel driver add\_endpoint
* Fix KeyError during sync\_routers
* Fix PortNotFound exception during sync\_routers
* VPNaaS: Cisco fix validation for GW IP
* Raise NotImplementedError instead of NotImplemented
* Imported Translations from Transifex
* Fix duplicate function: test\_getattr\_unallowed\_attr
* Preserve link local IP allocations for DVR fip ns across restart
* Fix 404 error fetching metadata when using DVR
* Raise exception for network delete with subnets presents
* SecurityGroupRuleExists should point out rule id inseand of group id
* Opencontrail plug-in implementation for core resources
* Do not assume order of new\_peers list elements
* Make plugin and l3plugin available as mixin's properties
* Use call to report state when ovs\_agent starts up
* add auth token to context
* Fixes an issue with FIP re-association
* NSX: unify the two distributed routing extensions
* NSX: fix wording for configuration option
* MLNX Agent: ensure removed ports get treated on resyncs
* Add delete operations for the ODL MechanismDriver
* Predictable field and filter ordering
* Fixing neutron-db-manage with some options other than upgrade/downgrade
* Removes extra indents from TestSubresourcePlugin
* ofagent: Upgrade note about firewall\_driver
* Return port context from \_bind\_port\_if\_needed
* MLNX Agent: Process port\_update notifications in the main agent loop
* Fix session's InvalidRequestError because of nested rollback
* Remove unneeded device\_owner field from l2pop tuple
* ofagent: Remove network\_delete method
* Do not assume order of parameters in OVSBridge.add\_flow call
* Fix to throw correct error code for bad attribute
* Improve external gateway update handling
* Do not assume order of pci slot list
* DeferredBridge to allow add\_tunnel\_port passthru
* Enabled Cisco ML2 driver to use new upstream ncclient
* Fix to enable L2pop to serve DVR
* Remove duplicated check for router connect to external net
* ofagent: Add a missing normalized\_port\_name
* Return 403 instead of 404 on attr policy failures
* Proper validation for inserting firewall rule
* Imported Translations from Transifex
* Ensure assertion matches dict iter order in test
* Fix 500 error  during router-update for dvr routers
* Simple refactor to stop passing around an unused parameter
* Make \_build\_uri\_path output predictable
* Radware: When a pip is needed, reuse the Port
* Remove redundant topic from rpc calls
* l3\_db: refactor L3\_NAT\_DB\_mixin
* OVS flows apply concurrently using a deferred OVSBridge
* Do not assume order of network\_uuid's
* Big Switch: Only update hash header on success
* ofagent: Stop monitoring ovsdb for port changes
* ofagent: Desupport ancillary bridges
* Add a tox test environment for random hashseed testing
* OFAgent: Implement arp responder
* Updated from global requirements
* Do not assume order of quotas dictionary elements
* Move Cisco VPN RESTapi URI strings to constants
* Remove ignored do\_request timeout argument
* Move from Python logging to Openstack logging
* Imported Translations from Transifex
* NSX: remove duplicate call to set\_auth\_cookie()
* NSX: Correct default timeout params
* Remove reference to cisco\_cfg\_agent.ini from setup.cfg
* Exit Firewall Agent if config is invalid
* Fix spelling mistakes
* Fix DB Duplicate error when scheduling distributed routers
* Imported Translations from Transifex
* Make ML2 ensure\_dvr\_port\_binding more robust
* centralized router is incorrectly scheduled
* Fix-DVR Gateway clear doesn't delete csnat port
* Fix spelling in get\_plugin\_interface docstring
* Use storage engine when creating tables in migrations
* Removed configobj from test requirements
* Implement Midonet Juno Network Api calls
* Add missing ml2 plugin to migration 1fcfc149aca4
* Replace nullable from primary keys in tz\_network\_bindings with default
* Use correct section for log message if interface\_driver import fails
* Make sure that gateway is in CIDR range by default
* test\_l3\_plugin: L3AgentDbInteTestCase L3AgentDbSepTestCase fails
* Add L3 Scheduler Changes for Distributed Routers
* Pass filters in arrays in get\_agent\_gw\_ports\_exist\_for\_network
* Do not schedule network when creating reserved DHCP port
* Check that router info is set before calling \_update\_arp\_entry
* Move ARP responder test to sanity command
* neutron.conf does not have the definition of firewall quotas
* Fix wrong order of tables in downgrade
* Fix deprecated opt in haproxy driver
* Race condition of L3-agent to add/remove routers
* Replaced the strings with respective constants
* Make dvr\_vmarp\_table\_update call conditional to dvr extension
* ofagent: Update a comment in port\_bound
* Updated from global requirements
* Set promote\_secondaries when creating namespaces
* Functional tests work fine with random PYTHONHASHSEED
* Call config\_parse in base test setup
* ML2 additions to support DVR
* Make test\_l3\_agent.\_prepare\_router\_data a module function
* Remove redundant code in tests/unit/test\_l3\_agent
* Fix ML2 Plugin binding:profile update
* Set python hash seed to 0 in tox.ini
* Add definition for new VIF type
* Configuration agent for Cisco devices
* Handle bool correctly during \_extend\_extra\_router\_dict
* Encapsulate some port properties in the PortContext
* Changes to remove the use of mapping tables from Nuage plugin
* Updated from global requirements
* Log exceptions inside spawned functions
* Correct misspelled variable name
* Avoid RequestURITooLong exception in metadata agent
* Move loadbalancer vip port creation outside of transaction
* Define some abstract methods in VpnDriver class
* ML2 mechanism driver for SR-IOV capable NIC based switching, Part 2
* Modify L3 Agent for Distributed Routers
* Audited attribute for policy update not changing
* OFAgent: Share codes of l2-population in OVS agent

2014.2.b2
---------

* This patch changes the name of directory from mech\_arista to arista
* ML2 mechanism driver for SR-IOV capable NIC based switching, Part 1
* Add rule for updating network's router:external attribute
* L2 Agent-side additions to support DVR
* Imported Translations from Transifex
* NSX: fix router ports port\_security\_enabled=False
* Add partial specs support in ML2 for multiprovider extension
* Add partial specs support in ML2 for gre/vxlan provider networks
* Set nullable=False on tenant\_id in apic\_contracts table
* call security\_groups\_member\_updated in port\_update
* The default value of quota\_firewall\_rule should not be -1
* Correct LOG.debug use
* Fix incorrect downgrade
* Fix spelling mistake in the log message
* Imported Translations from Transifex
* Support Router Advertisement Daemon (radvd) for IPv6
* Move plugin.delete\_port call out of transaction
* Add partial specs support in ML2 for vlan provider networks
* ML2: Update a comment after the recent bind\_port change
* NSX: fix validation logic on network gateway connect
* Initialize RpcProxy objects correctly
* Fix DVR regression for ofagent
* RPC additions to support DVR
* no quota for allowed address pair
* Allow to import \_LC, \_LE, \_LI and \_LW functions directly
* L2 Model additions to support DVR
* Fixed audit notifications for dhcp-agent-network
* Make readme reference git.openstack.org not github
* Fix enums usage for postgres in migrations
* Return a tuple of None's instead of one None
* Fix a log typo in ML2 manager.bind\_port()
* Big Switch: Remove consistency hash on full sync
* VPNaaS: Separate validation for Cisco impl
* VPNaaS: separate out validation logic for ref impl
* VMWare: don't notify on disassociate\_floatingips()
* Add L3 Extension for Distributed Routers
* VPNaaS Cisco REST client enhance CSR create
* Bump hacking to version 0.9.2
* Log methods using rpc communcation
* Fixes port update failure when device ID is not updated
* Support Quota extension in MidoNet plugin
* NSX: Remove unneed call to \_ensure\_default\_security\_group
* Use auth\_token from keystonemiddleware
* update vsm credential correctly
* Shamelessly removing commented print line
* L3 agent prefers RPC messages over full sync
* Dnsmasq config files syntax issue when dhcp\_domain is empty
* Database healing migration
* Fix incorrect default paramater in migration
* Use method's logger in log decorator
* Fixed audit notifications for l3-agent-router ops
* Expand arp\_responder help text
* Send network name and uuid to subnet create
* Cisco: Fix test cases which make incorrect create requests
* ML2: Bind ports outside transactions
* Freeze models for healing migration
* NSX: Optionally not enforce nat rule match length check
* ofagent: Handle device name prefixes other than "tap"
* Add -s option for neutron metering rules
* Security groups extension for PLUMgrid plugin
* Missing max\_routes in neutron.conf
* Clear entries in Cisco N1KV specific tables on rollback
* Allow unsharing a network used as gateway/floatingip
* Change all occurences of no\_delete to do\_delete
* Split up metering test case into plugin + test case
* Use integer server\_default value for multicast\_ip\_index
* Validate expected parameters in add/remove router interfaces
* Revert "VPNaaS REST Client UT Broken"
* Mock out tunnel\_sync in test to avoid sleeping
* Add 'server\_default' parameter
* Add BSN plugin to agent migration script
* Move \_convert\_to\_nsx\_transport\_zones into nsx\_utils
* Extract CommonDBMixin to a separate file
* Remove dead helper function from test\_l3\_plugin
* Added support for NOS version 4.1.0, 5.0.0 and greater
* Remove reference to setuptools\_git
* NSX: neutron router-interface-add should clear security-groups
* Refactor 'if false do nothing' logic in l3 scheduler db
* Imported Translations from Transifex
* Add a gate-specific tox env for functional tests
* NSX: remove unnecessary checks on network delete
* Bump min required version for dnsmasq to 2.63
* Add CONTRIBUTING.rst
* Do not mark device as processed if it wasn't
* Fix 'server\_default' parameter usage in models
* Fix missing migration default value
* Add a link to a blog post by RedHat that discusses GRE tunnels in OVS
* Updated from global requirements
* VPNaaS REST Client UT Broken
* Avoid notifying while inside transaction opened in delete\_port()
* sync periodic\_task fix from incubator
* Omit mode keyword when spawning dnsmasq with some ipv6 subnets
* Fixed spelling mistake in securitygroups\_rpc
* OVS agent: fix a comment on CANARY\_TABLE
* ofagent: Fix an argument mismatch bug in commit 9d13ea88
* Fix UnboundLocalError raised during L3 router sync task
* Updated from global requirements
* Fix isinstance assertions
* Imported Translations from Transifex
* Allow setting a rootwrap cmd for functional tests
* Fix OVSBridge.get\_port\_ofport to handle empty output
* Ignore variable column widths in ovsdb functional tests
* Add configurable http\_timeout parameter for Cisco N1K
* NSX: fix indentations
* BSN: Remove db lock and add missing contexts
* NSX: properly handle floating ip status
* Updated from global requirements
* Fix example for running individual tests
* Stop the dhcp-agent process when dnsmasq version is not determined
* Switch to using of oslo.db
* Replace occurences of 'test\_tenant' with 'test-tenant' in tests
* lb-agent: ensure removed devices get treated on resyncs
* Imported Translations from Transifex
* Add sanity check for nova notification support
* changes ovs agent to get bridges via ovs\_lib
* Use correct MAX\_LEN constant in agent functional tests
* remove unsupported middleware
* Fix re-creation of the pool directory
* Add config for performance gate job
* Use patch ports to interconnect integration/physical bridges
* Exit rpc\_loop when SIGTERM is recieved in ovs-agent
* LBaaS new object model logging no-op driver
* ofagent: Use port desc to monitor ports on br-int
* Fixed dhcp & gateway ip conflict in PLUMgrid plugin
* Introduce bulk calls for get device details
* validate flat networks physical name
* Remove \_\_init\_\_ method from TunnelCallback mixin
* OVS agent: Correct bridge setup ordering
* Revert "Revert "ovs-agent: Ensure integration bridge is created""
* Imported Translations from Transifex
* Synced log module and its dependencies from olso-incubator
* Pass newly created router to \_update\_router\_gw\_info
* don't ignore rules that are already enforced
* Updated neutron.conf to reflect new RPC options
* Moved rpc\_compat.py code back into rpc.py
* Updated from global requirements
* Updated from global requirements
* ofagent: move main module from ryu repository
* Don't convert numeric protocol values to int
* Imported Translations from Transifex
* Revert "Check NVP router's status before deploying a service"
* Remove the useless vim modelines
* Imported Translations from Transifex
* Changing the poll\_duration parameter type to int
* Add test cases for plugins/ml2/plugin.py
* Removed local modification in incubator code
* Removed 'rpc' and 'notifier' incubator modules
* Removed create\_rpc\_dispatcher methods
* Use openstack.common.lockutils module for locks in tox functional tests
* Pass serializer to oslo.messaging Notifier
* Fix auto\_schedule\_networks to resist DBDuplicateEntry
* Imported Translations from Transifex
* Control active number of REST calls from Cisco N1kv plugin to VSM
* Revert "ovs-agent: Ensure integration bridge is created"
* ValueError should use '%' instead of ','
* NSX: return 400 if dscp set for trusted queue
* NSX sync cache: add a flag to skip item deletion
* NSX: propagate network name updates to backend
* Renamed argument for create\_consumer[s]
* Renamed consume\_in\_thread -> consume\_in\_threads
* Renamed start\_rpc\_listener -> start\_rpc\_listeners
* Port to oslo.messaging
* Imported Translations from Transifex
* Pass 'top' to remove\_rule so that rule matching succeeds
* Big Switch: Stop watchdog on interval of 0
* Remove old quantum scripts
* Move \_filter\_non\_model\_columns method to CommonDbMixin
* Updated from global requirements
* Ignore emacs checkpoint files
* Big Switch: Lock consistency table for REST calls
* Check port value when creating firewall rule with icmp protocol
* Improve docstring for OVSNeutronAgent constructor
* Big Switch ML2: sync detection in port-update
* Imported Translations from Transifex
* Remove SELECT FOR UPDATE use in ML2 type driver release\_segment
* Add vlan type driver unittests
* Make sure we call BaseTestCase.setUp() first
* Don't explicitly call .stop() on mock.patch objects
* Don't instantiate RPC clients on import
* Configure agents using neutron.common.config.init (formerly .parse)
* linuxbridge-agent: process port updates in the main loop
* Notify systemd when starting Neutron server
* Ensure entries in dnsmasq belong to a subnet using DHCP
* Added missing core\_plugins symbolic names
* Trigger provider security group update for RA
* NSX: revert queue extension name change
* Fix pool statistics for LBaaS Haproxy driver
* Don't use root\_helper when it's not needed
* Introduced rpc\_compat.create\_connection()
* Copy-paste RPC Service class for backwards compatibility
* Introduce RpcCallback class
* Fix opt helpstring for dhcp\_lease\_duration
* Consistently use jsonutils instead of specific implementation
* Imported Translations from Transifex
* Adding static routes data for members
* remove pep8 E122 exemption and correct style
* Change default netpartition behavior in nuage plugin
* Add 'ip rule ...' support to ip\_lib
* Add missing keyword raise to get\_profile\_binding function
* Add logging for NSX status sync cache

2014.2.b1
---------

* Big Switch: Remove unnecessary initialization code
* Big Switch: Import DB module in unit test
* When l2-pop ON, clean stale ports in table0 br-tun
* remove E112 hacking exemption and fix errors
* Updated from global requirements
* Allowed address pair: Removing check for overlap with fixed ips
* NeutronManager: Remove explicit check of the existence of an attribute
* Fix invalid IPv6 address used in FakeV6 variables
* Improve vxlan type driver initialization performance
* Floatingip extension support for nuage plugin
* ovs-agent: Ensure integration bridge is created
* Brocade mechanism driver depends on the brocade plugin templates
* Brocade mechanism driver should be derived from ML2 plugin base class
* changes ovs agent\_id init to use hostname instead of mac
* multiprovidernet: fix a comment
* Imported Translations from Transifex
* Fix race condition with firewall deletion
* extensions: remove 'check\_env' method
* Check the validation of 'delay' and 'timeout'
* Control update, delete for cisco-network-profile
* Ensure routing key is specified in the address for a direct producer
* Support Subnets that are configured by external RAs
* Refactor code in update\_subnet, splitting into individual methods
* Make allocation\_pools attribute of subnet updateable by PUT
* Monkey patch threading module as early as possible
* Introduced transition RPC exception types
* Added RpcProxy class
* ofagent: Fix VLAN usage for TYPE\_FLAT and TYPE\_VLAN
* Big Switch: Catch exceptions in watchdog thread
* Use import from six.moves to import the queue module
* Start an unstarted patch in the hyperv unit tests
* Imported Translations from Transifex
* Fix NVP FWaaS occurs error when deleting a shared rule
* Check NVP router's status before deploying a service
* Add an option to turn off DF for GRE and VXLAN tunnels
* Increase default metadata\_workers, backlog to 4096
* Big Switch: Add missing data to topology sync
* Replace XML with JSON for N1kv REST calls
* Big Switch: Call correct method in watchdog
* Freescale SDN Mechanism Driver for ML2 Plugin
* OVS Agent: limit veth names to 15 chars
* Added note to neutron.conf
* Return no active network if the agent has not been learnt yet
* Sync service module from oslo-incubator
* ovs, ofagent: Remove dead code
* Default to setting secure mode on the integration bridge
* Cisco APIC Layer 3 Service plugin
* Allow neutron-sanity-check to check OVS patch port support
* Remove run-time version checking for openvswitch features
* Add flat type driver unittests
* Changed DictModel to dict with attribute access
* Pass object to policy when finding fields to strip
* Allow L3 base to handle extensions on router creation
* Refactor some router-related methods
* Add local type driver unittests
* add engine parameter for offline migrations
* Check DB scheme prior to migration to Ml2
* Removes unnecessary Embrane module-level mocks
* Improve module-level mocks in midonet tests
* Big Switch: fix capabilities retrieval code
* Improve iptables\_manager \_modify\_rules() method
* NSX: bump http\_timeout to 30 seconds
* Log firewall status on delete in case of status inconsistency
* BSN: Set hash header to empty instead of False
* Neutron does not follow the RFC 3442 spec for DHCP
* LBaaS add missing rootwrap filter for route
* Radware LBaaS driver is able to flip to a secondary backend node
* NSX: fix invalid docstring
* NSX: fix tenant\_id passed as security\_profile\_id
* NSX: Fix request\_id in api\_client to increment
* Improve usage of MagicMocks in ML2 and L3 tests
* Improve readability of MagicMock use in RYU test
* Remove function replacement with mock patch
* Remove unnecessary MagicMocks in cisco unit tests
* Handle errors from run\_ofctl() when dumping flows
* Sync periodic\_task from oslo-incubator
* Added missing plugin .ini files to setup.cfg
* Imported Translations from Transifex
* Make linux.utils.execute log error on return codes
* FWaaS plugin doesn't need to handle firewall rule del ops
* Reprogram flows when ovs-vswitchd restarts
* Revert "fix openvswitch requirement check"
* Updated from global requirements
* Fix KeyError exception while updating dhcp port
* NSX: fix bug for flat provider network
* Disallow regular user to update firewall's shared attribute
* Support 'infinite' dhcp\_lease\_duration
* l2-pop : removing a TODO for the delete port use case
* NEC plugin: Bump L3RPC callback version to 1.1
* Synced jsonutils from oslo-incubator
* Imported Translations from Transifex
* fix openvswitch requirement check
* NSX: replace strong references to the plugin with weakref ones
* Fixes bugs for requests sent to SDN-VE controller
* Install SNAT rules for ipv4 only
* Imported Translations from Transifex
* Add NVP advanced service check before deleting a router
* Disallow 'timeout' in health\_monitor to be negative
* Remove redundant default=None for config options
* Fix for multiple misspelled words
* Use list copy for events in nova notifier
* Extraroute extension support for nuage plugin
* OFAgent: Fixing lost vlan ids on interfaces
* Set onlink routes for all subnets on an external network
* Cisco APIC ML2 mechanism driver, part 2
* Remove all mostly untranslated PO files
* remove token from notifier middleware
* NSX: get rid of the last Nicira/NVP bits
* Metadata agent caches networks for routers
* Common decorator for caching methods
* Make pid file locking non-blocking
* Allowed Addresspairs: Removing check for overlap with fixed ips
* Do not defer IPTables apply in firewall path
* Metaclass Python 3.x Compatibility
* Fix non-existent 'assert' calls to mocks
* Log iptables rules when they fail to apply
* Remove hard dependency on novaclient
* Provide way to reserve dhcp port during failovers
* Imported Translations from Transifex
* Implement local ARP responder onto OVS agent
* Fix typos in ovs\_neutron\_agent.py
* Allow vlan type usage for OpenDaylight ml2
* NSX: do not raise on missing router during migration step
* NSX: fix error when creating VM ports on subnets without dhcp
* NSX: allow net-migration only in combined mode
* OFAgent: Avoid processing ports which are not yet ready
* Add missing translation support
* Reorg table ml2\_port\_bindings when db migration
* Remove unused parameter
* NSX: Do a single query for all gateway devices
* Add mailmap entry
* Add 'secret' property for 'connection' option
* NSX: Do not extend fault map for network gateway ext
* Ensure tenant owns devices when creating a gateway
* Corrected the syntax of port\_update call to NVSD agent
* Fix some typos in neutron/db and IBM SDN-VE plugin
* Fix issubclass() hook behavior in PluginInterface
* Imported Translations from Transifex
* LBaaS VIP doesn't work after delete and re-add
* OVS lib defer apply doesn't handle concurrency
* Big Switch: Don't use MagicMocks unnecessarily
* Make plugin deallocation check optional
* Restore GARP by default for floating IPs
* Ensure core plugin deallocation after every test
* Updated from global requirements
* Big Switch: Check source\_address attribute exists
* Revert "Big Switch: Check source\_address attribute exists"
* ML2 VxlanTypeDriver: Synchronize of VxlanAllocation table
* Start ping listener also for postgresql
* ofagent: Add a missing push\_vlan action
* NSX: ensure that no LSN is created on external networks
* Make VPNaaS 'InUse' exception more clear
* Remove explicit dependency on amqplib
* Revert "Disable debug messages when running unit tests"
* eswitch\_neutron\_agent: Whitespace fixes in comments
* Upgrade failure for DB2 at ml2\_binding\_vif\_details
* Remove duplicate module-rgx line in .pylintrc
* Disable debug messages when running unit tests
* Perform policy checks only once on list responses
* Allow DHCPv6 solicit from VM
* Fix importing module in test\_netscaler\_driver
* Record and log reason for dhcp agent resync
* Big Switch: Check source\_address attribute exists
* L3 RPC loop could delete a router on concurrent update
* Adding tenant-id while creating Radware ADC service
* Fix H302 violations
* Fix H302 violations in plugins package
* Fix H302 violations in unit tests
* Imported Translations from Transifex
* lbaas on a network without gateway
* Optimize querying for security groups
* NSX: pass the right argument during metadata setup
* Improve help strings for radware LbaaS driver
* Fix network profile subtype validation in N1kv plugin
* Performance improvement of router routes operations
* Add support to dynamically upload drivers in PLUMgrid plugin
* Imported Translations from Transifex
* Reference new get\_engine() method from wsgi.py
* Allow test\_l3\_agent unit test to run individually
* tests/unit: refactor reading neutron.conf.test
* Don't print duplicate messages on SystemExit
* Unit test cases for quota\_db.py
* Cisco VPN device driver - support IPSec connection updates
* OVS and OF Agents: Create updated\_ports attribute before setup\_rpc
* Imported Translations from Transifex
* Updated from global requirements
* Synced jsonutils from oslo-incubator
* Imported Translations from Transifex
* NSX: fix migration for networks without a subnet
* Allow ML2 plugin test cases to be run independently
* Removed signing\_dir from neutron.conf
* Add physical\_network to binding:vif\_details dictionary
* Database exception causes UnboundLocalError in linuxbridge-agent
* Wrong key router.interface reported by ceilometer
* Imported Translations from Transifex
* NSX: fix API payloads for dhcp/metadata setup
* Improve ODL ML2 Exception Handling
* NSX: change api mapping for Service Cluster to Edge Cluster
* Fix protocol value for SG IPV6 RA rule
* Cisco APIC ML2 mechanism driver, part 1
* LBaaS: remove orphan haproxy instances on agent start
* Fixed floating IP logic in PLUMgrid plugin
* Segregate the VSM calls from database calls in N1kv plugin
* NSX: add nsx switch lookup to dhcp and metadata operations
* Use set\_gateway from ip\_lib
* Fix incorrect usage of sa.String() type
* Re-submit "ML2 plugin should not delete ports on subnet deletion"
* LBaaS: Set correct nullable parameter for agent\_id
* Vmware: Set correct nullable for lsn\_id, nsx\_port\_id
* IBM: set secret=True on passwd config field
* Restore ability to run functional tests with run\_tests.sh
* Fix H302 violations in extensions package
* Sync db code from oslo-incubator
* Imported Translations from Transifex
* Remove List events API from Cisco N1kv Neutron
* NSX: Fix fake\_api\_client to raise NotFound
* Replace loopingcall in notifier with a delayed send
* ip-lib : use "ip neigh replace" instead of "ip neigh add"
* Add 2-leg configuration to Radware LBaaS Driver
* Fix H302 violations in db package and services
* Cisco: Set correct nullable for switch\_ip, instance\_id, vlan\_id
* Ml2: Set correct nullable for admin\_state\_up
* Drop service\* tables only if they exist
* Updated from global requirements
* Make help texts more descriptive in Metaplugin
* ML2 Cisco Nexus MD: Improve Unit Test Coverage
* Fix migration that breaks Grenade jobs
* Fix incorrect change of Enum type
* allow delete\_port to work when there are multiple floating ips
* Add nova\_ca\_certificates\_file option to neutron
* gw\_port should be set as lazy='join'
* netaddr<=0.7.10 raises ValueError instead of AddrFormatError
* Imported Translations from Transifex
* netaddr<=0.7.10 raises ValueError instead of AddrFormatError
* Validate IPv6 modes in API when IP version is 4
* Add 'ip neigh' to ip\_lib
* OFAgent: Improve handling of security group updates
* OFAgent: Process port\_update notifications in the main agent loop
* NSX: sync thread catches wrong exceptions on not found
* Notifier: Catch NotFound error from nova
* Switch over to FixedIntervalLoopingCall
* Check if bridge exists and make sure it's UP in ensure\_bridge
* Validate CIDR given as ip-prefix in security-group-rule-create
* Support enhancements to Cisco CSR VPN REST APIs
* Fix uninitialized variable reference
* Nuage Plugin: Delete router requires precommit checks
* Delete DHCP port without DHCP server on a net node
* Improved quota error message
* Remove device\_exists in LinuxBridgeManager
* Add support for multiple RPC workers under Metaplugin
* Security Group rule validation for ICMP rules
* Fix Metering doesn't respect the l3 agent binding
* DHCP agent should check interface is UP before adding route
* Remove workaround for bug #1219530
* Fix LBaaS Haproxy occurs error if no member is added
* Add functional tests to verify ovs\_lib VXLAN detection
* Add nova\_api\_insecure flag to neutron
* Allow combined certificate/key files for SSL
* Verify ML2 type driver exists before calling del
* Fix dangling patches in Cisco and Midonet tests
* Make default nova\_url use a version
* ML2 Cisco Nexus MD: Remove unnecessary Cisco nexus DB
* NSX plugin: fix get\_gateway\_devices
* Exclude .ropeproject from flake8 checks
* Register LBaaS resources to quotas engine
* Remove mock.patch.stop from tests that inherit from BaseTestCase
* Reschedule router if new external gateway is on other network
* Update ensure()/reconnect() to catch MessagingError
* Properly apply column default in migration pool\_monitor\_status
* Remove "reuse\_existing" from setup method in dhcp.py
* Enable flake8 E711 and E712 checking
* Fixes Hyper-V agent security groups disabling
* Fixes Hyper-V agent security group ICMP rules
* Fix typo in ml2 configuration file
* Edge firewall: improve exception handling
* Edge driver: Improve exception handling
* Fix typo in comment
* NSX: Fix KeyError in sync if nsx\_router\_id not found
* VMware: log backend port creation in the right place
* Revert "Hide ipv6 subnet API attributes"
* BigSwitch: Create router ports synchronously
* NSX: ensure dhcp port is setup on metadata network
* Hide ipv6 subnet API attributes
* Set correct columns' length
* Enforce required config params for ODL driver
* Add L2 Agent side handling for non consistent security\_group settings
* BSN: Remove module-level ref to httplib method
* BigSwitch: Stop HTTP patch before overriding
* Typographical correction of Arista ML2 help
* Fix wrong section name "security\_group" in sample config files
* Set the log level to debug for loading extensions
* Updated from global requirements
* set api.extensions logging to ERROR in unit tests
* Add common base class for agent functional tests
* Remove RPC to plugin when dhcp sets default route
* Imported Translations from Transifex
* Add missing comma in nsx router mappings migration
* OFAgent: Avoid re-wiring ports unnecessarily
* BigSwitch: Improves server manager UT coverage
* BigSwitch: Don't import portbindings\_db until use
* lb-agent: fix get\_interfaces\_on\_bridge returning None
* Clean out namespaces even if we don't delete namespaces
* Call policy.init() once per API request
* ofa\_neutron\_agent: Fix \_phys\_br\_block\_untranslated\_traffic
* Don't emit log for missing attribute check policy
* Sync service and systemd modules from oslo-incubator
* Imported Translations from Transifex
* Move bash whitelisting to pep8 testenv
* Fix test MAC addresses to be valid
* ML2: ODL driver sets port status
* Add a note that rpc\_workers option is experimental
* Fix Jenkins translation jobs
* Redundant SG rule create calls in unit tests
* Set ns\_name in RouterInfo as attribute
* Replace HTTPSConnection in NEC plugin
* ignore build directory for pep8
* Imported Translations from Transifex
* Delete routers that are requested but not reported as active
* Explicitly import state\_path opt in tests.base
* fixes tests using called\_once\_ without assert
* Remove invalid copyright headers under API module
* update doc string - correct typo
* Revert changes removing OVSBridge return
* fixes broken neutron-netns-cleanup
* Remove duplicated tests for check\_ovs\_vxlan\_version
* Permit ICMPv6 RAs only from known routers
* Return 409 for second firewall creation
* OFA agent: use hexadecimal IP address in tunnel port name
* Fixing Arista CLI command
* use floatingip's ID as key instead of itself
* Use a temp dir for CONF.state\_path
* Use os.uname() instead of calling uname in subprocess
* Enable hacking H301 check
* Stop using portbindings\_db in BSN ML2 driver
* NSX: Fix pagination support
* Removing vim header lines
* Fix function parsing the kernel version
* Updated from global requirements

2014.1.rc1
----------

* Restore NOT NULL constraint lost by earlier migrations
* BigSwitch: Semaphore on port status update
* Remove last parts of Quantum compatibility shim
* Imported Translations from Transifex
* Fix quota\_health\_monitor opt name in neutron.conf
* Add missing DB migrations for BSN ML2 plugin
* Only send notifications on uuid device\_id's
* Add Icehouse no-op migration
* Add support for https requests on nova metadata
* Delete disassociated floating ips on external network deletion
* Imported Translations from Transifex
* Invoke \_process\_l3\_create within plugin session
* Invalid ovs-agent test case - test\_fdb\_add\_flows
* Add missing parameters for port creation
* Move test\_ovs\_lib to tests/unit/agent/linux
* Update BigSwitch Name to its correct name
* Cancelling thread start while unit tests running
* Delete duplicate external devices in router namespace
* Deals with fails in update\_\*\_postcommit ops
* ML2 Cisco Nexus MD: Support portchannel interfaces
* Changed the message line of RouterInUse class
* UT: do not hide an original error in test resource ctxtmgr
* BigSwitch: Move attr ref after error check
* Fix namespace exist() method
* Make dnsmasq aware of all names
* Open Juno development
* Prevent cross plugging router ports from other tenants
* Adds OVS\_HYBRID\_PLUG flag to portbindings
* Disable XML tests on Py26
* Subnets should be set as lazy='join'
* nec plugin: allow to delete resource with ERROR status
* Synced rpc and gettextutils modules from oslo-incubator
* Import request\_id middleware bug fix from oslo
* Add unit test for add\_vxlan in test\_linux\_ip\_lib
* Start using oslosphinx theme for docs
* Migrate data from cap\_port\_filter to vif\_details
* Imported Translations from Transifex
* Include cisco plugin in migration plugins with ovs
* ML2 Cisco Nexus MD: Remove workaround for bug 1276395
* Fixed TypeError when creating MlnxException
* Replace a usage of the deprecated root\_helper option
* Cisco VPN driver correct reporting for admin state chg
* Add script to migrate ovs or lb db to ml2 db
* Correct OVS VXLAN version check
* LBaaS: make device driver decide whether to deploy instance
* NSX plugin: return 400 for invalid gw certificate
* Imported Translations from Transifex
* Remove extra space in help string
* Add enable\_security\_group to BigSwitch and OneConvergence ini files
* Add nec plugin to allowed address pairs migration
* Imported Translations from Transifex
* Fix segment allocation tables in Cisco N1kv plugin
* Updated from global requirements
* NEC plugin: Rename quantum\_id column to neutron\_id
* Log received pool.status
* NEC plugin: Allow to add prefix to OFC REST URL
* NEC plugin: Remove a colon from binding:profile key due to XML problem
* rename ACTIVE\_PENDING to ACTIVE\_PENDING\_STATUSES
* VPNaaS support for VPN service admin state change and reporting
* Use save\_and\_reraise\_exception when reraise exception
* Return meaningful error message on pool creation error
* Don't set priority when calling mod\_flow
* Avoid creating FixedIntervalLoopingCall in agent UT
* Imported Translations from Transifex
* Big Switch Plugin: No REST port delete on net del
* Add enable\_security\_group option
* Get rid of additional db contention on fetching VIP
* Fix typo in lbaas agent exception message
* De-duplicate unit tests for ports in Big Switch
* ML2: Remove validate\_port\_binding() and unbind\_port()
* Imported Translations from Transifex
* Fix duplicate name of NVP LBaaS objs not allowed on vShield Edge
* tests/unit: clean up notification driver
* Use different name for the same constraint
* Add a semaphore to some ML2 operations
* Log dnsmasq host file generation
* add HEAD sentinel file that contains migration revision
* Added config value help text in ns metadata proxy
* Fix usage of save\_and\_reraise\_exception
* Cisco VPN device driver post-merge cleanup
* Fixes the Hyper-V agent individual ports metrics
* Sync excutils from oslo
* BigSwitch ML2: Include bound\_segment in port
* NEC plugin: Honor Retry-After response from OFC
* Add update binding:profile with physical\_network
* return false or true according to binding result
* Enable to select an RPC handling plugin under Metaplugin
* Ensure to count firewalls in target tenant
* Mock agent RPC for FWaaS tests to delete DB objs
* Allow CIDRs with non-zero masked portions
* Cisco plugin fails with ParseError no elem found
* Cisco Nexus: maximum recursion error in ConnectionContext.\_\_del\_\_
* Don't use root to list namespaces
* Fixes Hyper-V agent security groups enable issue
* ML2 BigSwitch: Don't modify parent context
* Advanced Services documentation
* LBaaS: small cleanup in agent device driver interface
* Change report\_interval from 4 to 30, agent\_down\_time from 9 to 75
* Stop removing ip allocations on port delete
* Imported Translations from Transifex
* Ignore PortNotFound exceptions on lockless delete
* Show neutron API request body with debug enabled
* Add session persistence support for NVP advanced LBaaS
* Fix misleading error message about failed dhcp notifications
* NSX: Fix router-interface-delete returns 404 when router not in nsx
* Fix \_validate\_mac\_address method
* BigSwitch: Watchdog thread start after servers
* Calculate stateless IPv6 address
* Create new IPv6 attributes for Subnets
* Remove individual cfg.CONF.resets from tests
* BigSwitch: Sync workaround for port del deadlock
* NSX: Ensure gateway devices are usable after upgrade
* Correctly inherit \_\_table\_args\_\_ from parent class
* Process ICMP type for iptables firewall
* Imported Translations from Transifex
* Added missing l3\_update call in update\_network
* ML2 plugin involves in agent\_scheduler migration
* Imported Translations from Transifex
* Avoid long transaction in plugin.delete\_ports()
* cisco: Do not change supported\_extension\_aliases directly
* Fix KeyError except on router\_info in FW Agent
* NSX: remove last of unneed quantum references
* NSX: fix intermetting UT failure on vshield test\_router\_create
* Bugfix and refactoring for ovs\_lib flow methods
* Send fdb remove message when a port is migrated
* Imported Translations from Transifex
* Send network-changed notifications to nova
* Notify nova when ports are ready
* Skip radware failing test for now
* NSX: Propagate name updates for security profiles
* Fix in admin\_state\_up check function
* NSX: lower the severity of messages about VIF's on external networks
* Kill 'Skipping unknown group key: firewall\_driver' log trace
* Imported Translations from Transifex
* API layer documentation
* BigSwitch: Use eventlet.sleep in watchdog
* Embrane LBaaS Driver
* BigSwitch: Widen range of HTTPExceptions caught
